'From Squeak3.5gamma of ''29 March 2003'' [latest update: #5175] on 30 April 2003 at 8:21:42 am'!
Object subclass: #Brick
	instanceVariableNames: 'bounds owner submorphs color extension painters name delegate '
	classVariableNames: 'DefaultColor EmptyArray EventDispatchers '
	poolDictionaries: ''
	category: 'Bricks-Kernel'!

!Brick commentStamp: 'tb 3/8/2003 17:09' prior: 0!
I am an attempt to create a new cleaner Morph class that only contains code that is used.  I also have a different layout scheme based on NextStep style struts and springs.  -tb!

MorphicEventDispatcher subclass: #BrickEventDispatcher
	instanceVariableNames: 'stack mouseDownMorph lastEvent lastHeld lastMouseEvent mouseClickState keyboardFocus '
	classVariableNames: 'DispatchersByWorld '
	poolDictionaries: ''
	category: 'Bricks-Events'!
Object subclass: #BrickEventSensor
	instanceVariableNames: 'mouseFocus keyboardFocus eventListeners mouseListeners keyboardListeners mouseClickState mouseOverHandler lastMouseEvent targetOffset damageRecorder cacheCanvas cachedCanvasHasHoles temporaryCursor temporaryCursorOffset hasChanged savedPatch userInitials lastEventBuffer genieGestureProcessor brickEventDispatcher '
	classVariableNames: 'DoubleClickTime EventStats NewEventRules NormalCursor PasteBuffer ShowEvents '
	poolDictionaries: 'EventSensorConstants '
	category: 'Bricks-Events'!
Brick subclass: #BrickModel
	instanceVariableNames: 'model slotName open '
	classVariableNames: 'TimeOfError '
	poolDictionaries: ''
	category: 'Bricks-Kernel'!
Brick subclass: #DragWrapperBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Utility'!
Smalltalk renameClassNamed: #PainterHolderBrick as: #DragPainterBrick!
DragWrapperBrick subclass: #DragPainterBrick
	instanceVariableNames: 'painter removesPainter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Utility'!
Brick subclass: #GridBrick
	instanceVariableNames: 'direction insertionPoint inset cells '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Basic'!
Brick subclass: #ImageBrick
	instanceVariableNames: 'image '
	classVariableNames: 'DefaultForm '
	poolDictionaries: ''
	category: 'Bricks-Basic'!
Brick subclass: #LabelBrick
	instanceVariableNames: 'stringMorph alignment '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Basic'!
Brick subclass: #LayoutControlBrick
	instanceVariableNames: 'morph strutColor springColor layoutProperties vSizeable hSizeable leftMargin rightMargin topMargin bottomMargin '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Kernel'!

!LayoutControlBrick commentStamp: 'tb 2/17/2003 02:07' prior: 0!
I provide a graphical control for setting up struts and springs constraints for the StrutsAndSpringsLayout!

BrickModel subclass: #PSlider
	instanceVariableNames: 'slider value setValueSelector sliderShadow sliderColor descending '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Windows'!
PSlider subclass: #PScrollBar
	instanceVariableNames: 'menuButton upButton downButton pagingArea scrollDelta pageDelta interval menuSelector timeOfMouseDown timeOfLastScroll nextPageDirection currentScrollDelay '
	classVariableNames: 'CachedImages UpArrow UpArrow8Bit '
	poolDictionaries: ''
	category: 'Bricks-Windows'!
Object subclass: #Painter
	instanceVariableNames: ''
	classVariableNames: 'Backgrounds '
	poolDictionaries: ''
	category: 'Bricks-Painters'!

!Painter commentStamp: 'tb 3/17/2003 15:17' prior: 0!
I am the result of refactoring drawing behavior out of Morph.  I am an abstract class but my concrete subclasses are attached to a Brick using #addPainter:.  Each concrete painter has a layer that it wants to draw in.  Painting is done in two passes - Painters with numbers less than zero are considered to be below the Brick's canvas - typically drop shadows, and such.  These painters are invoked from Brick>>paintUnder: aCanvas.  Brick>>paintOn: aCanvas invokes Painters from zero upwards.

Your layer is determined by the number returned by the CLASS METHOD defaultLayer.  Please implement this to call a class method on Painter.  For instance, if you create a FooPainter, please implement Painter>>fooLayer to return your constant, and implement FooPainter(Class)>>defaultLayer.

There are three useful hooks for painters to use.

willPaintBrick: aBrick onCanvas: aCanvas "Useful for precalculating drawing info or storing the current state of the canvas in case it needs restoring later - ie CornerPainter does this for corner rounding.  Do NOT draw here.

paintBrick: aBrick onCanvas: aCanvas "Do your actual drawing here"

didPaintBrick: aBrick onCanvas: aCanvas "Clean up - release cache state - maybe do a little drawing if you really have to - though not recommended"

Finally - if you paint outside the bounds rect of the brick - please implement expandBounds: aRectangle inBrick: aBrick 

this is used in calculating outerBounds.!

Painter subclass: #BackgroundPainter
	instanceVariableNames: 'fillStyle '
	classVariableNames: 'DefaultFillStyle '
	poolDictionaries: ''
	category: 'Bricks-Painters'!
Painter subclass: #BorderPainter
	instanceVariableNames: 'borderStyle '
	classVariableNames: 'DefaultBorderStyle '
	poolDictionaries: ''
	category: 'Bricks-Painters'!

!BorderPainter commentStamp: 'tb 3/19/2003 02:52' prior: 0!
"I paint borders on bricks.  My palette was created with the following commands:"

| toolbar |
toolbar := ToolbarBrick new extent: 320@47.
toolbar inset: 8.
toolbar addPainter: (BackgroundPainter color: (Color tan)).
toolbar addPainter: (BorderPainter etched).
toolbar addMorph: (PainterHolderBrick forPainter: (BorderPainter simple)).
toolbar addMorph: (PainterHolderBrick forPainter: (BorderPainter raised)).
toolbar addMorph: (PainterHolderBrick forPainter: (BorderPainter inset)).
toolbar addMorph: (PainterHolderBrick forPainter: (BorderPainter complexRaised)).
toolbar addMorph: (PainterHolderBrick forPainter: (BorderPainter complexInset)).
toolbar addMorph: (PainterHolderBrick forPainter: (BorderPainter complexFramed)).
toolbar addMorph: (PainterHolderBrick forPainter: (BorderPainter complexAltRaised)).
toolbar addMorph: (PainterHolderBrick forPainter: (BorderPainter complexAltInset)).
toolbar addMorph: (PainterHolderBrick forPainter: (BorderPainter complexAltFramed)).
toolbar addMorph: (PainterHolderBrick unPainter: (BorderPainter color: (Color red) width: 4)).
toolbar sizeToFit.
toolbar openInWorld.!

Painter subclass: #CornerPainter
	instanceVariableNames: 'rounder cornersToRound borderWidth '
	classVariableNames: 'DefaultBorderStyle '
	poolDictionaries: ''
	category: 'Bricks-Painters'!
Painter subclass: #HilightPainter
	instanceVariableNames: 'color bounds '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Painters'!
Brick subclass: #PolygonBrick
	instanceVariableNames: 'vertices closed filledForm arrows arrowForms smoothCurve curveState borderDashSpec handles borderForm '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Basic'!
Morph subclass: #ProtoWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Kernel'!
Painter subclass: #RolloverBorderPainter
	instanceVariableNames: 'rolloverColor rolloverWidth '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Painters'!
Painter subclass: #ShadowPainter
	instanceVariableNames: 'shadowOffset shadowColor color width '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Painters'!
Brick subclass: #StringBrick
	instanceVariableNames: 'font emphasis contents hasFocus '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Basic'!
Brick subclass: #TextBrick
	instanceVariableNames: 'textStyle text wrapFlag paragraph editor container predecessor successor lastGesture backgroundColor margins '
	classVariableNames: 'CaretForm '
	poolDictionaries: ''
	category: 'Bricks-Basic'!
Brick subclass: #ToolbarBrick
	instanceVariableNames: 'direction insertionPoint inset '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bricks-Basic'!
BrickModel subclass: #Window
	instanceVariableNames: 'title titleBar '
	classVariableNames: 'Backgrounds '
	poolDictionaries: ''
	category: 'Bricks-Windows'!

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/14/2003 13:07'!
aboutToBeGrabbedBy: aHand
	"The receiver is being grabbed by a hand.
	Perform necessary adjustments (if any) and return the actual morph
	that should be added to the hand."
	| extentToHandToHand cmd |

	self formerOwner: owner.
	self formerPosition: self position.
	cmd _ self undoGrabCommand.
	cmd ifNotNil:[self setProperty: #undoGrabCommand toValue: cmd].
	(extentToHandToHand _ self valueOfProperty: #expandedExtent)
			ifNotNil:
				[self removeProperty: #expandedExtent.
				self extent: extentToHandToHand].
	^self "Grab me"! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/6/2003 14:04'!
dragEnabled
	"Get this morph's ability to add and remove morphs via drag-n-drop."
	^(self valueOfProperty: #dragEnabled) == true
! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/6/2003 14:04'!
dragNDropEnabled
	"Note: This method is only useful for dragEnabled == dropEnabled at all times"
	self separateDragAndDrop.
	^self dragEnabled and:[self dropEnabled]! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/8/2003 11:53'!
dropEnabled
	"Get this morph's ability to add and remove morphs via drag-n-drop."
	^(self valueOfProperty: #dropEnabled) == true
! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 4/29/2003 22:30'!
dropEnabled: aBool
	^self enableDrop: aBool! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 4/9/2003 16:41'!
enableDrag: aBoolean
	self setProperty: #dragEnabled toValue: aBoolean! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 4/9/2003 16:41'!
enableDragNDrop: aBoolean
	"Set both properties at once"
	self separateDragAndDrop.
	self enableDrag: aBoolean.
	self enableDrop: aBoolean.! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 4/9/2003 16:41'!
enableDrop: aBoolean
	self setProperty: #dropEnabled toValue: aBoolean! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/19/2003 03:07'!
formerOwner
	^self valueOfProperty: #formerOwner! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/4/2003 09:46'!
formerOwner: aMorphOrNil 
	aMorphOrNil isNil 
		ifTrue: [self removeProperty: #formerOwner]
		ifFalse: [self setProperty: #formerOwner toValue: aMorphOrNil]! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/4/2003 09:46'!
formerPosition
	^self valueOfProperty: #formerPosition! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/4/2003 09:46'!
formerPosition: formerPosition 
	formerPosition isNil 
		ifTrue: [self removeProperty: #formerPosition]
		ifFalse: [self setProperty: #formerPosition toValue: formerPosition]! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/14/2003 13:19'!
grabTransform
	"Return the transform for the receiver which should be applied during grabbing"
	^owner ifNil:[IdentityTransform new] ifNotNil:[owner grabTransform]! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/4/2003 09:46'!
justDroppedInto: aMorph event: anEvent
	"This message is sent to a dropped morph after it has been dropped on -- and been accepted by -- a drop-sensitive morph"

	| aWindow partsBinCase cmd aStack |
	self formerOwner: nil.
	self formerPosition: nil.
	cmd _ self valueOfProperty: #undoGrabCommand.
	cmd ifNotNil:[aMorph rememberCommand: cmd.
				self removeProperty: #undoGrabCommand].
	(partsBinCase _ aMorph isPartsBin) ifFalse:
		[self isPartsDonor: false].
	(aWindow _ aMorph ownerThatIsA: SystemWindow) ifNotNil:
		[aWindow isActive ifFalse:
			[aWindow activate]].
	(self isInWorld and: [partsBinCase not]) ifTrue:
		[self world startSteppingSubmorphsOf: self].
	"Note an unhappy inefficiency here:  the startStepping... call will often have already been called in the sequence leading up to entry to this method, but unfortunately the isPartsDonor: call often will not have already happened, with the result that the startStepping... call will not have resulted in the startage of the steppage."

	"An object launched by certain parts-launcher mechanisms should end up fully visible..."
	(self hasProperty: #beFullyVisibleAfterDrop) ifTrue:
		[aMorph == ActiveWorld ifTrue:
			[self goHome].
		self removeProperty: #beFullyVisibleAfterDrop].

	(self holdsSeparateDataForEachInstance and: [(aStack _ self stack) notNil])
		ifTrue:
			[aStack reassessBackgroundShape]
! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/4/2003 09:46'!
justGrabbedFrom: formerOwner
	"The receiver was just grabbed from its former owner and is now attached to the hand. By default, we pass this message on if we're a renderer."
	(self isRenderer and:[self hasSubmorphs]) 
		ifTrue:[self firstSubmorph justGrabbedFrom: formerOwner].! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/4/2003 09:46'!
nameForUndoWording
	"Return wording appropriate to the receiver for use in an undo-related menu item (and perhaps elsewhere)"

	| aName |
	aName _ self knownName ifNil: [self renderedMorph class name].
	^ aName truncateTo: 24! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/8/2003 11:53'!
repelsMorph: aMorph event: ev
	^ false! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/6/2003 14:04'!
separateDragAndDrop
	"Conversion only. Separate the old #dragNDropEnabled into #dragEnabled and #dropEnabled and remove the old property."
	| dnd |
	(self hasProperty: #dragNDropEnabled) ifFalse:[^self].
	dnd _ (self valueOfProperty: #dragNDropEnabled) == true.
	self dragEnabled: dnd.
	self dropEnabled: dnd.
	self removeProperty: #dragNDropEnabled.
! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/17/2003 18:00'!
slideToTrash: evt
	"Perhaps slide the receiver across the screen to a trash can and make it disappear into it.  In any case, remove the receiver from the screen."

	| aForm trash startPoint endPoint morphToSlide |

	((self renderedMorph == Utilities scrapsBook) or: [self renderedMorph isKindOf: TrashCanMorph]) ifTrue:
		[self delete.  ^ self].
	Preferences slideDismissalsToTrash ifTrue:
		[morphToSlide _ self representativeNoTallerThan: 200 norWiderThan: 200 thumbnailHeight: 100.
		aForm _ morphToSlide imageForm offset: (0@0).
		trash _ ActiveWorld
			findDeepSubmorphThat:
				[:aMorph | (aMorph isKindOf: TrashCanMorph) and:
					[aMorph topRendererOrSelf owner == ActiveWorld]]
			ifAbsent:
				[trash _ TrashCanMorph new.
				trash position: ActiveWorld bottomLeft - (0 @ (trash extent y + 26)).
				trash openInWorld.
				trash].
		endPoint _ trash fullBoundsInWorld center.
		startPoint _ self topRendererOrSelf fullBoundsInWorld center - (aForm extent // 2)].
	self delete.
	ActiveWorld displayWorld.
	Preferences slideDismissalsToTrash ifTrue:
		[aForm slideFrom: startPoint to: endPoint nSteps: 12 delay: 15].
	Utilities addToTrash: self! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/4/2003 09:46'!
undoGrabCommand
	"Return an undo command for grabbing the receiver"

	| cmd |
	owner ifNil:
		[^ nil]. "no owner - no undo"
	^ (cmd _ Command new)
		cmdWording: 'move ', self nameForUndoWording;
		undoTarget: self
		selector: #undoMove:redo:owner:bounds:predecessor:
		arguments: {cmd. false. owner. self bounds. (owner morphPreceding: self)};
		yourself! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 4/29/2003 22:02'!
wantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a hand in response to the given event. Note that for a successful drop operation both parties need to agree. The symmetric check is done automatically via aMorph wantsToBeDroppedInto: self."

	^(aMorph isKindOf: DragWrapperBrick) and: [self dropEnabled]! !

!Brick methodsFor: 'dropping/grabbing' stamp: 'tb 3/4/2003 09:46'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph. This check is symmetric to #wantsDroppedMorph:event: to give both parties a chance of figuring out whether they like each other."
	^true! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
actionMap self cloneSelector: #actionMap. ^self actionMap! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
asDraggableMorph self cloneSelector: #asDraggableMorph. ^self asDraggableMorph! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
asMorph self cloneSelector: #asMorph. ^self asMorph! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
beep self cloneSelector: #beep. ^self beep! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
beep: soundName self cloneSelector: #beep:. ^self beep: soundName! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
convertToCurrentVersion: varDict refStream: smartRefStrm self cloneSelector: #convertToCurrentVersion:refStream:. ^self convertToCurrentVersion: varDict refStream: smartRefStrm! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
creationStamp self cloneSelector: #creationStamp. ^self creationStamp! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
currentVocabulary self cloneSelector: #currentVocabulary. ^self currentVocabulary! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
deepCopy self cloneSelector: #deepCopy. ^self deepCopy! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 3/14/2003 12:40'!
defaultEventDispatcher
	"Return the default event dispatcher to use with events that are directly sent to the receiver"
	^self world 
		ifNotNil: [BrickEventDispatcher forWorld: (self world)]
		ifNil: [MorphicEventDispatcher new].! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
defaultFloatPrecisionFor: aGetSelector self cloneSelector: #defaultFloatPrecisionFor:. ^self defaultFloatPrecisionFor: aGetSelector! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
drawOnCanvas: aCanvas self cloneSelector: #drawOnCanvas:. ^self drawOnCanvas: aCanvas! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
flash self cloneSelector: #flash. ^self flash! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
fullDrawPostscriptOn: aCanvas self cloneSelector: #fullDrawPostscriptOn:. ^self fullDrawPostscriptOn: aCanvas! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
initialExtent self cloneSelector: #initialExtent. ^self initialExtent! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
presenter self cloneSelector: #presenter. ^self presenter! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
releaseActionMap self cloneSelector: #releaseActionMap. ^self releaseActionMap! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
renameTo: aName self cloneSelector: #renameTo:. ^self renameTo: aName! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
reportableSize self cloneSelector: #reportableSize. ^self reportableSize! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
scriptPerformer self cloneSelector: #scriptPerformer. ^self scriptPerformer! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
stepTime self cloneSelector: #stepTime. ^self stepTime! !

!Brick methodsFor: 'object-overrides' stamp: 'tb 2/24/2003 11:22'!
updateableActionMap self cloneSelector: #updateableActionMap. ^self updateableActionMap! !

!Brick methodsFor: 'structure' stamp: 'tb 3/8/2003 14:51'!
activeHand
	^ActiveHand! !

!Brick methodsFor: 'structure' stamp: 'tb 3/12/2003 14:20'!
allOwners
	"Return the owners of the reciever"

	^ Array streamContents: [:strm | self allOwnersDo: [:m | strm nextPut: m]]! !

!Brick methodsFor: 'structure' stamp: 'tb 3/4/2003 19:35'!
allOwnersDo: aBlock
	"Evaluate aBlock with all owners of the receiver"
	owner ifNotNil:[^owner withAllOwnersDo: aBlock].! !

!Brick methodsFor: 'structure' stamp: 'tb 3/4/2003 19:35'!
firstOwnerSuchThat: conditionBlock

	self allOwnersDo: [:m | (conditionBlock value: m) ifTrue: [^ m]].
	^ nil
! !

!Brick methodsFor: 'structure' stamp: 'tb 2/24/2003 11:41'!
hasOwner: aMorph
	"Return true if the receiver has aMorph in its owner chain"
	aMorph ifNil:[^true].
	self allOwnersDo:[:m| m = aMorph ifTrue:[^true]].
	^false! !

!Brick methodsFor: 'structure' stamp: 'tb 3/4/2003 09:46'!
isInWorld
	"Return true if this morph is in a world."

	^self world notNil! !

!Brick methodsFor: 'structure' stamp: 'tb 3/14/2003 13:19'!
morphPreceding: aSubmorph
	"Answer the morph immediately preceding aSubmorph, or nil if none"

	| anIndex |
	anIndex _ submorphs indexOf: aSubmorph ifAbsent: [^ nil].
	^ anIndex > 1
		ifTrue:
			[submorphs at: (anIndex - 1)]
		ifFalse:
			[nil]! !

!Brick methodsFor: 'structure' stamp: 'tb 3/4/2003 19:35'!
outermostWorldMorph

	| outer |
	World ifNotNil:[^World].
	self flag: #arNote. "stuff below is really only for MVC"
	outer _ self outermostMorphThat: [ :x | x isWorldMorph].
	outer ifNotNil: [^outer].
	self isWorldMorph ifTrue: [^self].
	^nil! !

!Brick methodsFor: 'structure' stamp: 'tb 2/24/2003 11:40'!
owner
	"Returns the owner of this morph, which may be nil."

	^ owner! !

!Brick methodsFor: 'structure' stamp: 'tb 3/4/2003 19:35'!
ownerThatIsA: aClass
	"Return the first enclosing morph that is a kind of aClass, or nil if none"

	^ self firstOwnerSuchThat: [:m | m isKindOf: aClass]! !

!Brick methodsFor: 'structure' stamp: 'tb 3/4/2003 19:35'!
pasteUpMorph
	"Answer the closest containing morph that is a PasteUp morph"
	^ self ownerThatIsA: PasteUpMorph! !

!Brick methodsFor: 'structure' stamp: 'tb 3/4/2003 09:46'!
renderedMorph
	"If the receiver is a renderer morph, answer the rendered morph. Otherwise, answer the receiver. A renderer morph with no submorphs answers itself. See the comment in Morph>isRenderer."

	self isRenderer ifFalse: [^self].
	submorphs isEmpty ifTrue: [^self].
	^self firstSubmorph renderedMorph! !

!Brick methodsFor: 'structure' stamp: 'tb 2/24/2003 11:41'!
topRendererOrSelf
	"Answer the topmost renderer for this morph, or this morph itself if it has no renderer. See the comment in Morph>isRenderer."

	| top topsOwner |
	owner ifNil: [^self].
	self isWorldMorph ifTrue: [^self].	"ignore scaling of this world"
	top := self.
	topsOwner := top owner.
	[topsOwner notNil and: [topsOwner isRenderer]] whileTrue: 
			[top := topsOwner.
			topsOwner := top owner].
	^top! !

!Brick methodsFor: 'structure' stamp: 'tb 3/8/2003 12:02'!
withAllOwnersDo: aBlock
	"Evaluate aBlock with the receiver and all of its owners"
	aBlock value: self.
	owner ifNotNil:[^owner withAllOwnersDo: aBlock].! !

!Brick methodsFor: 'structure' stamp: 'tb 3/4/2003 09:46'!
world
	^owner isNil ifTrue: [nil] ifFalse: [owner world]! !

!Brick methodsFor: 'menus' stamp: 'tb 4/29/2003 21:42'!
adMiscExtrasTo: aMenu 
	"Add a submenu of miscellaneous extra items to the menu."

	| realOwner realMorph subMenu |
	subMenu := MenuMorph new defaultTarget: self.
	(self isWorldMorph not 
		and: [(self renderedMorph isKindOf: SystemWindow) not]) 
			ifTrue: [subMenu add: 'put in a window' action: #embedInWindow].
	self isWorldMorph 
		ifFalse: 
			[subMenu add: 'adhere to edge...' action: #adhereToEdge.
			subMenu addLine].
	realOwner := (realMorph := self topRendererOrSelf) owner.
	(realOwner isKindOf: TextPlusPasteUpMorph) 
		ifTrue: 
			[subMenu add: 'GeeMail stuff...'
				subMenu: (realOwner textPlusMenuFor: realMorph)].
	self affiliatedSelector ifNotNil: 
			[subMenu add: 'open a messenger' action: #openMessenger.
			subMenu 
				balloonTextForLastItem: 'Open a Messenger on the actual method call used when the button action of this object is triggered.'.
			subMenu addLine].
	subMenu
		add: 'add mouse up action' action: #addMouseUpAction;
		add: 'remove mouse up action' action: #removeMouseUpAction;
		add: 'hand me tiles to fire this button' action: #handMeTilesToFire.
	subMenu addLine.
	subMenu add: 'arrowheads on pen trails...' action: #setArrowheads.
	subMenu addLine.
	subMenu defaultTarget: self topRendererOrSelf.
	subMenu add: 'draw new path' action: #definePath.
	subMenu add: 'follow existing path' action: #followPath.
	subMenu add: 'delete existing path' action: #deletePath.
	subMenu addLine.
	self addGenieMenuItems: subMenu hand: ActiveHand.
	aMenu add: 'extras...' subMenu: subMenu! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addAddHandMenuItemsForHalo: aMenu hand: aHandMorph
	"The former charter of this method was to add halo menu items that pertained specifically to the hand.  Over time this charter has withered, and most morphs reimplement this method simply to add their morph-specific menu items.  So in the latest round, all other implementors in the standard image have been removed.  However, this is left here as a hook for the benefit of existing code in client uses."

! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addCopyItemsTo: aMenu
	"Add copy-like items to the halo menu"

	| subMenu |
	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'copy to paste buffer' action: #copyToPasteBuffer:.
	subMenu add: 'copy Postscript' action: #clipPostscript.
	subMenu add: 'print Postscript to file...' target: self selector: #printPSToFile.
	aMenu add: 'copy & print...' subMenu: subMenu! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addCustomHaloMenuItems: aMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand from the halo.  To get started, we defer to the counterpart method used with the option-menu, but in time we can have separate menu choices for halo-menus and for option-menus"

	self addCustomMenuItems: aMenu hand: aHandMorph! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand.  This method provides is invoked both from the halo-menu and from the control-menu regimes."
! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addExportMenuItems: aMenu hand: aHandMorph
	"Add export items to the menu"

	aMenu ifNotNil:
		[ | aSubMenu |
		aSubMenu _ MenuMorph new defaultTarget: self.
		aSubMenu add: 'BMP file' action: #exportAsBMP.
		aSubMenu add: 'GIF file' action: #exportAsGIF.
		aSubMenu add: 'JPEG file' action: #exportAsJPEG.
		aMenu add: 'export...' subMenu: aSubMenu]
! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addFillStyleMenuItems: aMenu hand: aHand
	"Add the items for changing the current fill style of the Morph"
	| menu |
	self canHaveFillStyles ifFalse:[^aMenu add: 'change color...' target: self action: #changeColor].
	menu _ MenuMorph new defaultTarget: self.
	self fillStyle addFillStyleMenuItems: menu hand: aHand from: self.
	menu addLine.
	menu add: 'solid fill' action: #useSolidFill.
	menu add: 'gradient fill' action: #useGradientFill.
	menu add: 'bitmap fill' action: #useBitmapFill.
	menu add: 'default fill' action: #useDefaultFill.
	aMenu add: 'fill style' subMenu: menu.
	"aMenu add: 'change color...' action: #changeColor"! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addHaloActionsTo: aMenu
	"Add items to aMenu representing actions requestable via halo"

	| subMenu |
	subMenu _ MenuMorph new defaultTarget: self.
	subMenu addTitle: self externalName.
	subMenu addStayUpItemSpecial.
	subMenu addLine.
	subMenu add: 'delete' action: #dismissViaHalo.
	subMenu balloonTextForLastItem: 'Delete this object -- warning -- can be destructive!!'.

	self maybeAddCollapseItemTo: subMenu.
	subMenu add: 'grab' action: #openInHand.
	subMenu balloonTextForLastItem: 'Pick this object up -- warning, since this removes it from its container, it can have adverse effects.'.

	subMenu addLine.

	subMenu add: 'resize' action: #resizeFromMenu.
	subMenu balloonTextForLastItem: 'Change the size of this object'.

	subMenu add: 'duplicate' action: #maybeDuplicateMorph.
	subMenu balloonTextForLastItem: 'Hand me a copy of this object'.

	subMenu addLine.
	subMenu add: 'property sheet' target: self renderedMorph action: #openAPropertySheet.
	subMenu balloonTextForLastItem: 'Open a property sheet for me. Allows changing lots of stuff at once.'.

	subMenu add: 'set color' target: self renderedMorph action: #changeColor.
	subMenu balloonTextForLastItem: 'Change the color of this object'.

	subMenu add: 'viewer' target: self action: #beViewed.
	subMenu balloonTextForLastItem: 'Open a Viewer that will allow everything about this object to be seen and controlled.'.

	subMenu add: 'tile browser' target: self action: #openInstanceBrowserWithTiles.
	subMenu balloonTextForLastItem: 'Open a tool that will facilitate tile scripting of this object.'.

	subMenu add: 'hand me a tile' target: self action: #tearOffTile.
	subMenu balloonTextForLastItem: 'Hand me a tile represting this object'.
	subMenu addLine.

	subMenu add: 'inspect' target: self action: #inspect.
	subMenu balloonTextForLastItem: 'Open an Inspector on this object'.

	aMenu add: 'halo actions...' subMenu: subMenu
! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addPlayerItemsTo: aMenu
	"Add player-related items to the menu if appropriate"

	| aPlayer subMenu |
	aPlayer _ self topRendererOrSelf player.
	subMenu _ MenuMorph new defaultTarget: self.
	subMenu add: 'make a sibling instance' target: self action: #makeNewPlayerInstance:.
	subMenu balloonTextForLastItem: 'Makes another morph whose player is of the same class as this one.  Both siblings will share the same scripts'.

	subMenu add: 'make multiple siblings...' target: self action: #makeMultipleSiblings:.
	subMenu balloonTextForLastItem: 'Make any number of sibling instances all at once'.

	(aPlayer belongsToUniClass and: [aPlayer class instanceCount > 1]) ifTrue:
		[subMenu addLine.
		subMenu add: 'make all siblings look like me' target: self action: #makeSiblingsLookLikeMe:.
		subMenu balloonTextForLastItem: 'make all my sibling instances look like me.'.

		subMenu add: 'bring all siblings to my location' target: self action: #bringAllSiblingsToMe:.
		subMenu balloonTextForLastItem: 'find all sibling instances and bring them to me'.

		subMenu add: 'apply status to all siblngs' target: self action: #applyStatusToAllSiblings:.
		subMenu balloonTextForLastItem: 'apply the current status of all of my scripts to the scripts of all my siblings'].

		aMenu add: 'siblings...' subMenu: subMenu

! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addStackItemsTo: aMenu
	"Add stack-related items to the menu"

	| stackSubMenu |
	stackSubMenu _ MenuMorph new defaultTarget: self.
	(owner notNil and: [owner isStackBackground]) ifTrue:
		[self isShared
			ifFalse:
				[self couldHoldSeparateDataForEachInstance
					ifTrue:
						[stackSubMenu add: 'Background field, shared value' target: self action: #putOnBackground.
						stackSubMenu add: 'Background field, individual values' target: self action: #becomeSharedBackgroundField]
					ifFalse:
						[stackSubMenu add: 'put onto Background' target: self action: #putOnBackground]]
			ifTrue:
				[stackSubMenu add: 'remove from Background' target: self action: #putOnForeground.
				self couldHoldSeparateDataForEachInstance ifTrue:
					[self holdsSeparateDataForEachInstance
						ifFalse:
							[stackSubMenu add: 'start holding separate data for each instance' target: self action: #makeHoldSeparateDataForEachInstance]
						ifTrue:
							[stackSubMenu add: 'stop holding separate data for each instance' target: self action: #stopHoldingSeparateDataForEachInstance].
							stackSubMenu add: 'be default value on new card' target: self action: #setAsDefaultValueForNewCard.
							(self hasProperty: #thumbnailImage)
								ifTrue:
									[stackSubMenu add: 'stop using for reference thumbnail' target: self action: #stopUsingForReferenceThumbnail]
								ifFalse:
									[stackSubMenu add: 'start using for reference thumbnail' target: self action: #startUsingForReferenceThumbnail]]].
				stackSubMenu addLine].

	(self isStackBackground) ifFalse:
		[stackSubMenu add: 'be a card in an existing stack...' action: #insertAsStackBackground].
	stackSubMenu add: 'make an instance for my data' action: #abstractAModel.
	(self isStackBackground) ifFalse:
		[stackSubMenu add: 'become a stack of cards' action: #wrapWithAStack].
	aMenu add: 'stacks and cards...' subMenu: stackSubMenu
! !

!Brick methodsFor: 'menus' stamp: 'tb 4/9/2003 16:41'!
addStandardHaloMenuItemsTo: aMenu hand: aHandMorph
	"Add standard halo items to the menu"

	| unlockables |

	self isWorldMorph ifTrue:
		[^ self addWorldHaloMenuItemsTo: aMenu hand: aHandMorph].

	self mustBeBackmost ifFalse:
		[aMenu add: 'send to back' action: #goBehind.
		aMenu add: 'bring to front' action: #comeToFront.
		self addEmbeddingMenuItemsTo: aMenu hand: aHandMorph.
		aMenu addLine].

"
	self addFillStyleMenuItems: aMenu hand: aHandMorph.
	self addBorderStyleMenuItems: aMenu hand: aHandMorph.
	self addDropShadowMenuItems: aMenu hand: aHandMorph."
	self addLayoutMenuItems: aMenu hand: aHandMorph.
	self addHaloActionsTo: aMenu.
	owner isTextMorph ifTrue:[self addTextAnchorMenuItems: aMenu hand: aHandMorph].
	aMenu addLine.
	self addToggleItemsToHaloMenu: aMenu.
	aMenu addLine.
	self addCopyItemsTo: aMenu.
	self addPlayerItemsTo: aMenu.
	self addExportMenuItems: aMenu hand: aHandMorph.
	self addStackItemsTo: aMenu.
	self adMiscExtrasTo: aMenu.
	Preferences noviceMode ifFalse:
		[self addDebuggingItemsTo: aMenu hand: aHandMorph].

	aMenu addLine.
	aMenu defaultTarget: self.

	aMenu addLine.

	unlockables _ self submorphs select:
		[:m | m isLocked].
	unlockables size == 1 ifTrue:
		[aMenu add: 'unlock "', unlockables first externalName, '"' action: #unlockContents].
	unlockables size > 1 ifTrue:
		[aMenu add: 'unlock all contents' action: #unlockContents.
		aMenu add: 'unlock...' action: #unlockOneSubpart].

	aMenu defaultTarget: aHandMorph.
! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
addTitleForHaloMenu: aMenu
	aMenu addTitle: self externalName! !

!Brick methodsFor: 'menus' stamp: 'tb 4/9/2003 15:08'!
addToggleItemsToHaloMenu: aMenu
	"Add standard true/false-checkbox items to the memu"

	#((resistsRemovalString toggleResistsRemoval 'whether I should be reistant to easy deletion via the pink X handle')
	(stickinessString toggleStickiness 'whether I should be resistant to a drag done by mousing down on me')
	(lockedString lockUnlockMorph 'when "locked", I am inert to all user interactions')
	(hasClipSubmorphsString changeClipSubmorphs 'whether the parts of objects within me that are outside my bounds should be masked.')
	(hasDirectionHandlesString changeDirectionHandles 'whether direction handles are shown with the halo')
	(hasDragAndDropEnabledString changeDragAndDrop 'whether I am open to having objects dropped into me')) do:

		[:trip | aMenu addUpdating: trip first action: trip second.
			aMenu balloonTextForLastItem: trip third].
"
	self couldHaveRoundedCorners ifTrue:
		[aMenu addUpdating: #roundedCornersString action: #toggleCornerRounding.
		aMenu balloonTextForLastItem: 'whether my corners should be rounded']"! !

!Brick methodsFor: 'menus' stamp: 'tb 3/9/2003 00:43'!
changeColor
	"Change the color of the receiver -- triggered, e.g. from a menu"

	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: #fillStyle:;
		originalColor: self color;
		putUpFor: self near: self fullBoundsInWorld! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:15'!
changeDirectionHandles
	^self wantsDirectionHandles: self wantsDirectionHandles not! !

!Brick methodsFor: 'menus' stamp: 'tb 4/9/2003 16:41'!
changeDragAndDrop
	^self enableDragNDrop: self dragNDropEnabled not! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
hasDirectionHandlesString
	^(self wantsDirectionHandles ifTrue:['<on>'] ifFalse:['<off>']), 'direction handles'! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
hasDragAndDropEnabledString
	"Answer a string to characterize the drag & drop status of the receiver"

	^ self dragNDropEnabled ifTrue:['<on>accept drops'] ifFalse:['<off>accept drops']! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:13'!
inspectInMorphic: evt
	evt hand attachMorph: ((Inspector openAsMorphOn: self) extent: 300@200)! !

!Brick methodsFor: 'menus' stamp: 'tb 3/11/2003 00:28'!
lockUnlockMorph
	"If the receiver is locked, unlock it; if unlocked, lock it"

	self isLocked ifTrue: [self unlock] ifFalse: [self lock]! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
lockedString
	"Answer the string to be shown in a menu to represent the 'locked' status"

	^ self isLocked
		ifTrue:
			['<on>be locked']
		ifFalse:
			['<off>be locked']! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
maybeAddCollapseItemTo: aMenu
	"If appropriate, add a collapse item to the given menu"

	| anOwner |
	(anOwner _ self topRendererOrSelf owner) ifNotNil:
			[anOwner isWorldMorph ifTrue:
				[aMenu add: #collapse target: self action: #collapse]]! !

!Brick methodsFor: 'menus' stamp: 'tb 3/17/2003 11:08'!
outerBounds
	"Return the 'outer' bounds of the receiver, e.g., the bounds that need to be invalidated when the receiver changes."
	| box values |
	box _ self bounds.

	painters ifNil: [^box].

	values := painters values.

	^values inject: box into: [:rect :p | p expandBounds: rect inBrick: self].

! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
resistsRemovalString
	"Answer the string to be shown in a menu to represent the 'resistsRemoval' status"

	^ self resistsRemoval
		ifTrue:
			['<on>resist being deleted']
		ifFalse:
			['<off>resist being deleted']! !

!Brick methodsFor: 'menus' stamp: 'tb 3/6/2003 14:04'!
stickinessString
	"Answer the string to be shown in a menu to represent the stickiness status"

	^ self isSticky
		ifTrue: ['<yes>resist being picked up']
		ifFalse: ['<no>resist being picked up']! !

!Brick methodsFor: 'debug and other' stamp: 'tb 3/6/2003 14:04'!
addDebuggingItemsTo: aMenu hand: aHandMorph
	aMenu add: 'debug...' subMenu:  (self buildDebugMenu: aHandMorph)! !

!Brick methodsFor: 'debug and other' stamp: 'tb 3/6/2003 14:04'!
addViewingItemsTo: aMenu
	"Add viewing-related items to the given menu.  If any are added, this method is also responsible for adding a line after them"! !

!Brick methodsFor: 'debug and other' stamp: 'tb 3/6/2003 14:04'!
buildDebugMenu: aHand 
	"Answer a debugging menu for the receiver.  The hand argument is seemingly historical and plays no role presently"

	| aMenu aPlayer |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	(self hasProperty: #errorOnDraw) 
		ifTrue: 
			[aMenu add: 'start drawing again' action: #resumeAfterDrawError.
			aMenu addLine].
	(self hasProperty: #errorOnStep) 
		ifTrue: 
			[aMenu add: 'start stepping again' action: #resumeAfterStepError.
			aMenu addLine].
	aMenu add: 'inspect morph' action: #inspectInMorphic:.
	aMenu add: 'inspect owner chain' action: #inspectOwnerChain.
	Smalltalk isMorphic 
		ifFalse: [aMenu add: 'inspect morph (in MVC)' action: #inspect].
	(self isMorphicModel) 
		ifTrue: 
			[aMenu 
				add: 'inspect model'
				target: self model
				action: #inspect].
	(aPlayer := self player) ifNotNil: 
			[aMenu 
				add: 'inspect player'
				target: aPlayer
				action: #inspect].
	aMenu 
		add: 'explore morph'
		target: self
		selector: #explore.
	aMenu addLine.
	aMenu 
		add: 'viewer for Player'
		target: self player
		action: #beViewed.
	aMenu 
		balloonTextForLastItem: 'Opens a viewer on my Player -- this is the same thing you get if you click on the cyan "View" halo handle'.
	aMenu 
		add: 'viewer for Morph'
		target: self
		action: #viewMorphDirectly.
	aMenu 
		balloonTextForLastItem: 'Opens a Viewer on this Morph, rather than on its Player'.
	aMenu addLine.
	aPlayer ifNotNil: 
			[aPlayer class isUniClass 
				ifTrue: 
					[aMenu 
						add: 'browse player class'
						target: aPlayer
						action: #browseHierarchy]].
	aMenu 
		add: 'browse morph class'
		target: self
		selector: #browseHierarchy.
	aMenu addLine.
	aPlayer ifNotNil: 
			[aMenu 
				add: 'player protocol (tiles)'
				target: aPlayer
				action: #openInstanceBrowserWithTiles
			"#browseProtocolForPlayer"].
	aMenu 
		add: 'morph protocol (text)'
		target: self
		selector: #haveFullProtocolBrowsed.
	aMenu 
		add: 'morph protocol (tiles)'
		target: self
		selector: #openInstanceBrowserWithTiles.
	aMenu addLine.
	self addViewingItemsTo: aMenu.
	aMenu
		add: 'make own subclass' action: #subclassMorph;
		add: 'internal name ' action: #choosePartName;
		add: 'save morph in file' action: #saveOnFile;
		addLine;
		add: 'call #tempCommand' action: #tempCommand;
		add: 'define #tempCommand' action: #defineTempCommand;
		addLine;
		add: 'control-menu...'
			target: self
			selector: #invokeMetaMenu:;
		add: 'edit balloon help' action: #editBalloonHelpText.
	^aMenu! !

!Brick methodsFor: 'debug and other' stamp: 'tb 3/17/2003 11:09'!
resumeAfterDrawError

	self changed.
	self removeProperty:#errorOnDraw.
	self changed.! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 3/6/2003 14:04'!
addEmbeddingMenuItemsTo: aMenu hand: aHandMorph
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	self potentialEmbeddingTargets reverseDo: [:m | 
		menu add: (m knownName ifNil:[m class name asString]) target: m selector: #addMorphFrontFromWorldPosition: argumentList: {self}].
	aMenu ifNotNil:[
		menu submorphCount > 0 
			ifTrue:[aMenu add:'embed into' subMenu: menu].
	].
	^menu! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 4/9/2003 14:51'!
blueButtonDown: anEvent
	"Special gestures (cmd-mouse on the Macintosh; Alt-mouse on Windows and Unix) allow a mouse-sensitive morph to be moved or bring up a halo for the morph."
	| h tfm doNotDrag |
	h _ anEvent hand halo.
	"Prevent wrap around halo transfers originating from throwing the event back in"
	doNotDrag _ false.
	h ifNotNil:[
		(h innerTarget == self) ifTrue:[doNotDrag _ true].
		(h innerTarget hasOwner: self) ifTrue:[doNotDrag _ true].
		(self hasOwner: h target) ifTrue:[doNotDrag _ true]].

	tfm _ (self transformedFrom: nil) inverseTransformation.

	"cmd-drag on flexed morphs works better this way"
	h _ self addHalo: (anEvent transformedBy: tfm).
	doNotDrag ifTrue:[^self].
	"Initiate drag transition if requested"
	anEvent hand 
		waitForClicksOrDrag: h
		event: (anEvent transformedBy: tfm)
		selectors: { nil. nil. nil. #dragTarget:. }
		threshold: 5.
	"Pass focus explicitly here"
	anEvent hand newMouseFocus: h.! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 3/6/2003 14:04'!
buildHandleMenu: aHand
	"Build the morph menu for the given morph's halo's menu handle. This menu has two sections. The first section contains commands that are interpreted by the hand; the second contains commands provided by the target morph. This method allows the morph to decide which items should be included in the hand's section of the menu."

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	menu addLine.
	self addStandardHaloMenuItemsTo: menu hand: aHand.
	menu defaultTarget: aHand.
	self addAddHandMenuItemsForHalo: menu  hand: aHand.
	menu defaultTarget: self.
	self addCustomHaloMenuItems: menu hand: aHand.
	menu defaultTarget: aHand.
	^ menu
! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 3/10/2003 10:27'!
buildMetaMenu: evt
	"Build the morph menu. This menu has two sections. The first section contains commands that are handled by the hand; the second contains commands handled by the argument morph."
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	menu add: 'grab' action: #grabMorph:.
	menu add: 'copy to paste buffer' action: #copyToPasteBuffer:.
	self maybeAddCollapseItemTo: menu.
	menu add: 'delete' action: #dismissMorph:.
	menu addLine.
	menu add: 'copy Postscript' action: #clipPostscript.
	menu add: 'print PS to file...' action: #printPSToFile.
	menu addLine.
	menu add: 'go behind' action: #goBehind.
	menu add: 'add halo' action: #addHalo:.
	menu add: 'duplicate' action: #maybeDuplicateMorph:.

	self addEmbeddingMenuItemsTo: menu hand: evt hand.

	menu add: 'resize' action: #resizeMorph:.
	"Give the argument control over what should be done about fill styles"
	self addFillStyleMenuItems: menu hand: evt hand.
	self addDropShadowMenuItems: menu hand: evt hand.
	self addLayoutMenuItems: menu hand: evt hand.
	menu addUpdating: #hasClipSubmorphsString target: self selector: #changeClipSubmorphs argumentList: #().
	menu addLine.

	(self morphsAt: evt position) size > 1 ifTrue:
		[menu add: 'submorphs...'
			target: self
			selector: #invokeMetaMenuAt:event:
			argument: evt position].
	menu addLine.
	menu add: 'inspect' selector: #inspectAt:event: argument: evt position.
	menu add: 'explore' action: #explore.
	menu add: 'browse hierarchy' action: #browseHierarchy.
	menu add: 'make own subclass' action: #subclassMorph.
	menu addLine.
	menu add: 'set variable name...' action: #choosePartName.
	(self isMorphicModel) ifTrue:
		[menu add: 'save morph as prototype' action: #saveAsPrototype.
		(self ~~ self world modelOrNil) ifTrue:
			 [menu add: 'become this world''s model' action: #beThisWorldsModel]].
	menu add: 'save morph in file' action: #saveOnFile.
	(self hasProperty: #resourceFilePath)
		ifTrue: [((self valueOfProperty: #resourceFilePath) endsWith: '.morph')
				ifTrue: [menu add: 'save as resource' action: #saveAsResource].
				menu add: 'update from resource' action: #updateFromResource]
		ifFalse: [menu add: 'attach to resource' action: #attachToResource].
	menu add: 'show actions' action: #showActions.
	menu addLine.
	self addDebuggingItemsTo: menu hand: evt hand.

	self addCustomMenuItems: menu hand: evt hand.
	^ menu
! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 3/11/2003 00:36'!
changeColorTarget: anObject selector: aSymbol originalColor: aColor hand: aHand
	"Put up a color picker for changing some kind of color.  May be modal or modeless, depending on #modalColorPickers setting"
	self flag: #arNote. "Simplify this due to anObject == self for almost all cases"
	^ ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: aHand;
		target: anObject;
		selector: aSymbol;
		originalColor: aColor;
		putUpFor: anObject near: (anObject isMorph
					ifTrue:	 [Rectangle center: self position extent: 20]
					ifFalse: [anObject == self world
								ifTrue: [anObject viewBox bottomLeft + (20@-20) extent: 200]
								ifFalse: [anObject fullBoundsInWorld]]);
		yourself! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 3/4/2003 19:35'!
handlerForBlueButtonDown: anEvent
	"Return the (prospective) handler for a mouse down event. The handler is temporarily installed and can be used for morphs further down the hierarchy to negotiate whether the inner or the outer morph should finally handle the event.
	Note: Halos handle blue button events themselves so we will only be asked if there is currently no halo on top of us."
	self wantsHaloFromClick ifFalse:[^nil].
	anEvent handler ifNil:[^self].
	anEvent handler isPlayfieldLike ifTrue:[^self]. "by default exclude playfields"
	(anEvent shiftPressed)
		ifFalse:[^nil] "let outer guy have it"
		ifTrue:[^self] "let me have it"
! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 3/10/2003 10:27'!
invokeMetaMenu: evt
	| menu |
	menu _ self buildMetaMenu: evt.
	menu addTitle: self externalName.
	menu popUpEvent: evt in: self world! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 3/8/2003 20:15'!
openAPropertySheet

	ObjectPropertiesMorph basicNew
		targetMorph: self;
		initialize;
		openNearTarget! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 3/6/2003 14:04'!
potentialEmbeddingTargets
	"Return the potential targets for embedding the receiver"
	owner ifNil:[^#()].
	^owner morphsAt: self referencePosition behind: self unlocked: true! !

!Brick methodsFor: 'meta-actions' stamp: 'tb 4/9/2003 16:42'!
subclassMorph
	"Create a new subclass of this morph's class and make this morph be an instance of it."

	| oldClass newClassName newClass newMorph |
	oldClass _ self class.
	newClassName _ FillInTheBlank
		request: 'Please give this new class a name'
		initialAnswer: oldClass name.
	newClassName = '' ifTrue: [^ self].
	(Smalltalk includesKey: newClassName)
		ifTrue: [^ self inform: 'Sorry, there is already a class of that name'].

	newClass _ oldClass subclass: newClassName asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: oldClass category asString.
	newMorph _ self as: newClass.
	self become: newMorph.
! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/19/2003 21:26'!
addHalo: evt
	| halo prospectiveHaloClass |
	prospectiveHaloClass _ Smalltalk at: self haloClass ifAbsent: [HaloMorph].
	halo _ prospectiveHaloClass new bounds: self worldBoundsForHalo.
	halo popUpFor: self event: evt.
	^halo! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/8/2003 12:02'!
addHalo: evt from: formerHaloOwner
	"Transfer a halo from the former halo owner to the receiver"
	^self addHalo: evt! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
addHandlesTo: aHaloMorph box: box
	"Add halo handles to the halo.  Apply the halo filter if appropriate"

	| wantIt |
	aHaloMorph haloBox: box.
	Preferences haloSpecifications  do:
		[:aSpec | 
			wantIt _ Preferences selectiveHalos
				ifTrue:
					[self wantsHaloHandleWithSelector: aSpec addHandleSelector inHalo: aHaloMorph]
				ifFalse:
					[true].
			wantIt ifTrue:
				[aHaloMorph perform: aSpec addHandleSelector with: aSpec]].

	aHaloMorph innerTarget addOptionalHandlesTo: aHaloMorph box: box! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
addOptionalHandlesTo: aHalo box: box
	aHalo addDirectionHandles! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
balloonHelpTextForHandle: aHandle
	"Answer a string providing balloon help for the given halo handle"

	|  itsSelector |
	itsSelector _ aHandle eventHandler firstMouseSelector.
	#(	(addFullHandles							'More halo handles')
		(addSimpleHandles						'Fewer halo handles')
		(chooseEmphasisOrAlignment				'Emphasis & alignment')
		(chooseFont								'Change font')
		(chooseNewGraphicFromHalo				'Choose a new graphic')
		(chooseStyle								'Change style')
		(dismiss									'Remove')
		(doDebug:with:							'Debug')
		(doDirection:with:						'Choose forward direction')
		(doDup:with:							'Duplicate')
		(doMenu:with:							'Menu')
		(doGrab:with:							'Pick up')
		(doRecolor:with:							'Change color')
		(editButtonsScript						'See the script for this button')
		(editDrawing							'Repaint')
		(maybeDoDup:with:						'Duplicate')
		(makeNascentScript						'Make a scratch script')
		(makeNewDrawingWithin				'Paint new object')
		(mouseDownInCollapseHandle:with:		'Collapse')
		(mouseDownOnHelpHandle:				'Help')
		(openViewerForArgument				'Open a Viewer for me')
		(openViewerForTarget:with:				'Open a Viewer for me')
		(paintBackground						'Paint background')
		(prepareToTrackCenterOfRotation:with:	'Move object or set center of rotation')
		(presentViewMenu						'Present the Viewing menu')
		(startDrag:with:							'Move')
		(startGrow:with:							'Change size') 
		(startRot:with:							'Rotate')
		(startScale:with:							'Change scale') 
		(tearOffTile								'Make a tile representing this object')
		(tearOffTileForTarget:with:				'Make a tile representing this object')
		(trackCenterOfRotation:with:				'Set center of rotation')) 


	do:
		[:pair | itsSelector == pair first ifTrue: [^ pair last]].

	(itsSelector == #mouseDownInDimissHandle:with:) ifTrue:
		[^ Preferences preserveTrash
			ifTrue:
				['Move to trash']
			ifFalse:
				['Remove from screen']].

	^ 'unknown halo handle'! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/9/2003 00:42'!
halo

	(self outermostWorldMorph ifNil: [^nil]) haloMorphs do: [:h | h target == self ifTrue: [^ h]].
	^ nil! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
haloClass
	"Answer the name of the desired kind of HaloMorph to launch on behalf of the receiver"

	^ #HaloMorph
! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
hasHalo: aBool
	aBool
		ifTrue:[self setProperty: #hasHalo toValue: true]
		ifFalse:[self removeProperty: #hasHalo]! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
okayToAddDismissHandle
	"Answer whether a halo on the receiver should offer a dismiss handle.  This provides a hook for making it harder to disassemble some strucures even momentarily"

	^ self holdsSeparateDataForEachInstance not  and:
		[self resistsRemoval not]! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
okayToAddGrabHandle
	"Answer whether a halo on the receiver should offer a grab handle.  This provides a hook for making it harder to deconstruct some strucures even momentarily"

	^ self holdsSeparateDataForEachInstance not ! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/9/2003 16:02'!
removeHalo
	| h |
	h _ self halo.
	h ifNotNil: [h delete]! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/19/2003 15:23'!
setBalloonText: stringOrText
	"Set receiver's balloon help text. Pass nil to remove the help."

	self setBalloonText: stringOrText maxLineLength: Preferences maxBalloonHelpLineLength! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/19/2003 15:23'!
setBalloonText: stringOrText maxLineLength: aLength 
	"Set receiver's balloon help text. Pass nil to remove the help."
	(self hasExtension not
			and: [stringOrText isNil])
		ifTrue: [^ self].
	self assureExtension
		balloonText: (stringOrText
				ifNotNil: [stringOrText asString withNoLineLongerThan: aLength])! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/8/2003 12:02'!
transferHalo: event from: formerHaloOwner
	"Progressively transfer the halo to the next likely recipient"
	| localEvt w target |

	self flag: #workAround. "For halo's distinction between 'target' and 'innerTarget' we need to bypass any renderers."
	(formerHaloOwner == self and:[self isRenderer and:[self wantsHaloFromClick not]]) ifTrue:[
		event shiftPressed ifTrue:[
			target _ owner.
			localEvt _ event transformedBy: (self transformedFrom: owner).
		] ifFalse:[
			target _ self renderedMorph.
			localEvt _ event transformedBy: (target transformedFrom: self).
		].
		^target transferHalo: localEvt from: target].

	"Never transfer halo to top-most world"
	(self isWorldMorph and:[owner isNil]) ifFalse:[
		(self wantsHaloFromClick and:[formerHaloOwner ~~ self]) 
			ifTrue:[^self addHalo: event from: formerHaloOwner]].

	event shiftPressed ifTrue:[
		"Pass it outwards"
		owner ifNotNil:[^owner transferHalo: event from: formerHaloOwner].
		"We're at the top level; throw the event back in to find recipient"
		formerHaloOwner removeHalo.
		^self processEvent: event copy resetHandlerFields.
	].
	self submorphsDo:[:m|
		localEvt _ event transformedBy: (m transformedFrom: self).
		(m fullContainsPoint: localEvt position) 
			ifTrue:[^m transferHalo: event from: formerHaloOwner].
	].
	"We're at the bottom most level; throw the event back up to the root to find recipient"
	formerHaloOwner removeHalo.
	w _ self world.
	localEvt _ event transformedBy: (self transformedFrom: w) inverseTransformation.
	^w processEvent: localEvt resetHandlerFields.
! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 2/24/2003 11:41'!
wantsBalloon
	"Answer true if receiver wants to show a balloon help text is a few moments."

	^ (self balloonText notNil) and: [Preferences balloonHelpEnabled]! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
wantsDirectionHandles
	^self valueOfProperty: #wantsDirectionHandles ifAbsent:[Preferences showDirectionHandles]! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/6/2003 14:15'!
wantsDirectionHandles: aBool
	aBool == Preferences showDirectionHandles
		ifTrue:[self removeProperty: #wantsDirectionHandles]
		ifFalse:[self setProperty: #wantsDirectionHandles toValue: aBool].
! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 2/24/2003 11:41'!
wantsHalo
	| topOwner |
	^(topOwner := self topRendererOrSelf owner) notNil 
		and: [topOwner wantsHaloFor: self]! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/8/2003 12:02'!
wantsHaloFor: aSubMorph
	^ false! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
wantsHaloFromClick
	^ true! !

!Brick methodsFor: 'halos and balloon help' stamp: 'tb 3/4/2003 19:35'!
wantsScriptorHaloHandle
	"Answer whether the receiver would like to have a Scriptor halo handle put up on its behalf.  Initially, only the ScriptableButton says yes"

	^ false! !

!Brick methodsFor: 'layout-menu' stamp: 'tb 3/17/2003 14:14'!
addLayoutMenuItems: topMenu hand: aHand

	self world == self owner ifFalse: [topMenu add: 'layout options...' action: #openLayoutControl]! !

!Brick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/8/2003 18:01'!
addMorph: aMorph

	self addMorphFront: aMorph.! !

!Brick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/8/2003 18:13'!
addMorphCentered: aMorph

	aMorph position: bounds center - (aMorph extent // 2).
	self addMorphFront: aMorph.
! !

!Brick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/8/2003 12:02'!
addMorphFront: aMorph
	^self privateAddMorph: aMorph atIndex: 1! !

!Brick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/8/2003 12:02'!
addMorphFront: aMorph fromWorldPosition: wp

	self addMorphFront: aMorph.
	aMorph position: (self transformFromWorld globalPointToLocal: wp)! !

!Brick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/8/2003 12:02'!
addMorphFrontFromWorldPosition: aMorph
	^self addMorphFront: aMorph fromWorldPosition: aMorph positionInWorld.! !

!Brick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/17/2003 16:28'!
delete
	"Remove the receiver as a submorph of its owner and make its 
	new owner be nil."

	| aWorld |
	aWorld := self world ifNil: [World].
	"or some proper of getting the World"
	"Terminate genie recognition focus"
	"I encountered a case where the hand was nil, so I put in a little 
	protection - raa"
	aWorld 
		ifNotNil: [aWorld currentHand ifNotNilDo: [:h | h disableGenieFocus: self]].
	owner ifNotNil: 
			[(self hasExtension not or: [self player isNil]) 
				ifTrue: 
					[owner privateRemoveMorph: self.
					owner := nil]
				ifFalse: 
					["Player must be notified"

					owner privateRemoveMorph: self.
					owner := nil.
					self player noteDeletionOf: self fromWorld: aWorld]].
! !

!Brick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/15/2003 11:55'!
removeAllMorphs
	| myWorld |
	myWorld _ self world.
	self isInWorld ifTrue:[self invalidRect: self fullBounds].
	submorphs do: [:m | m outOfWorld: myWorld; privateOwner: nil].
	submorphs _ EmptyArray.
	self layoutChanged.
! !

!Brick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/18/2003 16:50'!
removeAllMorphsIn: aCollection
	"greatly speeds up the removal of *lots* of submorphs"
	| set myWorld |
	myWorld _ self world.
	(fullBounds notNil or:[myWorld notNil]) ifTrue:[self invalidRect: self fullBounds].
	aCollection do: [:m | m outOfWorld: myWorld; privateOwner: nil].
	set _ IdentitySet new: aCollection size * 4 // 3.
	aCollection do: [:each | set add: each].
	submorphs _ submorphs reject: [ :each | set includes: each].
	self layoutChanged.
! !

!Brick methodsFor: 'painters' stamp: 'tb 3/16/2003 17:08'!
addPainter: aPainter

	self addPainter: aPainter atLayer: (aPainter defaultLayer)! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 01:44'!
addPainter: aPainter atLayer: aLayer

	painters ifNil: [painters := Dictionary new].
	painters at: aLayer put: aPainter. 
	self changed.! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 12:31'!
defaultLayer

	^Painter brickLayer! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 12:34'!
didPaintBrick: aBrick onCanvas: aCanvas! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 12:43'!
expandBounds: aRectangle inBrick: aBrick

	^aRectangle! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 12:34'!
paintBrick: aBrick onCanvas: aCanvas

	self drawOn: aCanvas! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 17:39'!
paintOn: aCanvas

	"Allow all painters in positive layers to paint"

	| lower upper |

	painters ifNotNil:
	[
		lower := (painters keys select: [:k | k >= Painter canvasLayer 
			and: [k <= Painter brickLayer]]) asArray sort.
		upper := (painters keys select: [:k | k > Painter brickLayer]) asArray sort.

		lower do: [:layer | (painters at: layer) willPaintBrick: self onCanvas: aCanvas].	
		upper do: [:layer | (painters at: layer) willPaintBrick: self onCanvas: aCanvas].	

		lower do: [:layer | (painters at: layer) paintBrick: self onCanvas: aCanvas].	
		self drawSubmorphsOn: aCanvas.
		upper do: [:layer | (painters at: layer) paintBrick: self onCanvas: aCanvas].	

		lower do: [:layer | (painters at: layer) didPaintBrick: self onCanvas: aCanvas].
		upper do: [:layer | (painters at: layer) didPaintBrick: self onCanvas: aCanvas].
	].
! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 17:25'!
paintUnder: aCanvas

	"Allow all painters in negative layers to paint - shadows and such"

	| layers |

	painters ifNotNil:
	[
		layers := (painters keys select: [:k | k < Painter canvasLayer]) asArray sort.
		layers do: [:layer | (painters at: layer) willPaintBrick: self onCanvas: aCanvas].	
		layers do: [:layer | (painters at: layer) paintBrick: self onCanvas: aCanvas].	
		layers do: [:layer | (painters at: layer) didPaintBrick: self onCanvas: aCanvas].
	]! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 02:11'!
painterAtLayer: aLayerNumber

	^painters at: aLayerNumber ifAbsent: [nil]. ! !

!Brick methodsFor: 'painters' stamp: 'tb 3/16/2003 17:02'!
paintersAtLayer: aLayerNumber

	^painters at: aLayerNumber ifAbsent: [EmptyArray]. ! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 02:00'!
paintersDo: aBlock

	painters ifNotNil:
	[
		| layers | 
		layers := painters keys asArray sort.
		layers do: [:layer |

			| painter | 
			
			painter := (painters at: layer).
		
			painter isCollection 
				ifTrue: [painter do: [:p | aBlock value: p ]]
				ifFalse: [ aBlock value: painter ] 
		]
	]! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 11:23'!
removePainter: aPainterOrPainterClassOrLayer

	self changed.
	aPainterOrPainterClassOrLayer isNumber 
		ifTrue: [ painters removeKey: aPainterOrPainterClassOrLayer ifAbsent: [nil]]
		ifFalse: [ painters removeKey: aPainterOrPainterClassOrLayer defaultLayer ifAbsent: [nil]].
	"self changed."! !

!Brick methodsFor: 'painters' stamp: 'tb 3/18/2003 13:35'!
replaceAllPaintersWithPainter: aPainter

	self changed.
	painters := Dictionary new.
	self addPainter: aPainter.! !

!Brick methodsFor: 'painters' stamp: 'tb 3/17/2003 15:36'!
willPaintBrick: aBrick onCanvas: aCanvas

	"If you are implementing drawOn: and need to do some precalculation - this is a good place"! !

!Brick methodsFor: 'change reporting' stamp: 'tb 3/8/2003 12:02'!
addedOrRemovedSubmorph: aMorph
	"Report that the area occupied by this morph should be redrawn."
	"NOTE: this is subtly different from 'aMorph changed'
	in that it forces computation of aMorph fullBounds."

	"Used to be...
	self invalidRect: aMorph fullBounds from: aMorph"

	aMorph fullBounds.
	aMorph changed! !

!Brick methodsFor: 'change reporting' stamp: 'tb 2/24/2003 11:56'!
invalidRect: damageRect
	^self invalidRect: damageRect from: self! !

!Brick methodsFor: 'change reporting' stamp: 'tb 3/17/2003 15:25'!
invalidRect: aRectangle from: aMorph
	| damageRect |
	damageRect _ aRectangle.
	aMorph == self ifFalse:[
		"Clip to receiver's clipping bounds if the damage came from a child"
		self clipSubmorphs 
			ifTrue:[damageRect _ aRectangle intersect: self clippingBounds]].
	owner ifNotNil: [owner invalidRect: damageRect from: self].
! !

!Brick methodsFor: 'change reporting' stamp: 'tb 3/6/2003 10:21'!
ownerChanged
	"The receiver's owner, some kind of a pasteup, has changed its layout."

! !

!Brick methodsFor: 'messenger' stamp: 'tb 3/6/2003 14:04'!
affiliatedSelector
	"Answer a selector affiliated with the receiver for the purposes of launching a messenger.   Reimplement this to plug into the messenger service"

	^ nil! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
align: aPoint1 with: aPoint2
	"Translate by aPoint2 - aPoint1."

	^ self position: self position + (aPoint2 - aPoint1)! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bottom

	^ bounds bottom! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bottom: aNumber
	self position: (bounds left @ (aNumber - self height))! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bottomCenter

	^ bounds bottomCenter! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bottomLeft

	^ bounds bottomLeft! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bottomLeft: aPoint
	self bottom: aPoint y.
	self left: aPoint x! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bottomRight

	^ bounds bottomRight! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bottomRight: aPoint
	self bottom: aPoint y.
	self right: aPoint x! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bounds
	"Return the bounds of this morph."
	"Note: It is best not to override this method because many methods in Morph and its subclasses use the instance variable directly rather than 'self bounds'. Instead, subclasses should be sure that the bounds instance variable is correct."

	^ bounds
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bounds: newBounds
	| oldExtent newExtent |
	oldExtent _ self extent.
	newExtent _ newBounds extent.
	(oldExtent dotProduct: oldExtent) <= (newExtent dotProduct: newExtent) ifTrue:[
		"We're growing. First move then resize."
		self position: newBounds topLeft; extent: newExtent.
	] ifFalse:[
		"We're shrinking. First resize then move."
		self extent: newExtent; position: newBounds topLeft.
	].! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bounds: aRectangle from: referenceMorph
	"Return the receiver's bounds as seen by aMorphs coordinate frame"
	owner ifNil: [^ aRectangle].
	^(owner transformFrom: referenceMorph) globalBoundsToLocal: aRectangle
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
bounds: aRectangle in: referenceMorph
	"Return the receiver's bounds as seen by aMorphs coordinate frame"
	owner ifNil: [^ aRectangle].
	^(owner transformFrom: referenceMorph) localBoundsToGlobal: aRectangle
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
boundsIn: referenceMorph
	"Return the receiver's bounds as seen by aMorphs coordinate frame"
	^self bounds: self bounds in: referenceMorph! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
boundsInWorld
	^self bounds: self bounds in: self world! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
center

	^ bounds center! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
center: aPoint
	self position: (aPoint - (self extent // 2))! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
extent

	^ bounds extent! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/9/2003 15:52'!
extent: aPoint

	| newBounds |

	bounds extent = aPoint ifTrue: [^ self].
	self changed.	
	newBounds _ self topLeft extent: aPoint.
	self doLayoutIn: newBounds.
	self privateBounds: newBounds.
	self layoutChanged.
	self changed.
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
fullBoundsInWorld
	^self bounds: self fullBounds in: self world! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
globalPointToLocal: aPoint
	^self point: aPoint from: nil! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
gridPoint: ungriddedPoint

	^ ungriddedPoint! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
griddedPoint: ungriddedPoint

	| griddingContext |
	self flag: #arNote. "Used by event handling - should transform to pasteUp for gridding"
	(griddingContext _ self pasteUpMorph) ifNil: [^ ungriddedPoint].
	^ griddingContext gridPoint: ungriddedPoint! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
height

	^ bounds height! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
height: aNumber

	self extent: self width@aNumber asInteger.
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
innerBounds
	"Return the inner rectangle enclosed by the bounds of this morph excluding the space taken by its borders. For an unbordered morph, this is just its bounds."

	^ self bounds insetBy: self borderWidth! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
left

	^ bounds left! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
left: aNumber
	self position: (aNumber @ bounds top)! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
leftCenter

	^ bounds leftCenter! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
localPointToGlobal: aPoint
	^self point: aPoint in: nil! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
minimumExtent
	| ext |
	"This returns the minimum extent that the morph may be shrunk to.  Not honored in too many places yet, but respected by the resizeToFit feature, at least.  copied up from SystemWindow 6/00"
	(ext _ self valueOfProperty: #minimumExtent)
		ifNotNil:
			[^ ext].
	^ 100 @ 80! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
minimumExtent: aPoint
	"Remember a minimumExtent, for possible future use"

	self setProperty: #minimumExtent toValue: aPoint
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
nextOwnerPage
	"Tell my container to advance to the next page"
	| targ |
	targ _ self ownerThatIsA: BookMorph.
	targ ifNotNil: [targ nextPage]! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
point: aPoint from: aReferenceMorph

	owner ifNil: [^ aPoint].
	^ (owner transformFrom: aReferenceMorph) globalPointToLocal: aPoint.
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
point: aPoint in: aReferenceMorph

	owner ifNil: [^ aPoint].
	^ (owner transformFrom: aReferenceMorph) localPointToGlobal: aPoint.
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
pointFromWorld: aPoint
	^self point: aPoint from: self world! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
pointInWorld: aPoint
	^self point: aPoint in: self world! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
position

	^ bounds topLeft! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
position: aPoint
	"Change the position of this morph and and all of its submorphs."

	| delta box |
	delta _ aPoint - bounds topLeft.
	(delta x = 0 and: [delta y = 0]) ifTrue: [^ self].  "Null change"
	box _ self fullBounds.
	(delta dotProduct: delta) > 100 ifTrue:[
		"e.g., more than 10 pixels moved"
		self invalidRect: box.
		self invalidRect: (box translateBy: delta).
	] ifFalse:[
		self invalidRect: (box merge: (box translateBy: delta)).
	].
	self privateFullMoveBy: delta.
	owner ifNotNil:[owner layoutChanged].! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
positionInWorld

	^ self pointInWorld: self position.
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/6/2003 10:30'!
positionSubmorphs

	"snapToEdgeIfAppropriate is a silly message - lets try to get rid of it"

	"self submorphsDo:
		[:aMorph | aMorph snapToEdgeIfAppropriate]"! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
previousOwnerPage
	"Tell my container to advance to the previous page"
	| targ |
	targ _ self ownerThatIsA: BookMorph.
	targ ifNotNil: [targ previousPage]! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
right

	^ bounds right! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
right: aNumber
	self position: ((aNumber - bounds width) @ bounds top)! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
rightCenter

	^ bounds rightCenter! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
screenLocation
	"For compatibility only"

	^ self fullBounds origin! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
screenRectangle
	"For compatibility only"

	^ self fullBounds! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
shiftSubmorphsBy: delta
	self shiftSubmorphsOtherThan: (submorphs select: [:m | m isFlapOrTab]) by: delta! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
shiftSubmorphsOtherThan: listNotToShift by: delta
	| rejectList |
	rejectList _ listNotToShift ifNil: [OrderedCollection new].
	(submorphs copyWithoutAll: rejectList) do:
		[:m | m position: (m position + delta)]! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
top

	^ bounds top! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
top: aNumber
	self position: (bounds left @ aNumber)! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
topCenter

	^ bounds topCenter! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
topLeft

	^ bounds topLeft! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
topLeft: aPoint
	self top: aPoint y.
	self left: aPoint x! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
topRight

	^ bounds topRight! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
topRight: aPoint
	self top: aPoint y.
	self right: aPoint x! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
transformedBy: aTransform
	aTransform isIdentity ifTrue:[^self].
	aTransform isPureTranslation ifTrue:[
		^self position: (aTransform localPointToGlobal: self position).
	].
	^self addFlexShell transformedBy: aTransform! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
width

	^ bounds width! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
width: aNumber

	self extent: aNumber asInteger@self height.
! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
worldBounds
	^ self world bounds! !

!Brick methodsFor: 'geometry' stamp: 'tb 3/4/2003 20:19'!
worldBoundsForHalo
	"To restore older behavior, change this to return  self fullBoundsInWorld"

	^ self boundsIn: nil! !

!Brick methodsFor: 'submorphs-accessing' stamp: 'tb 2/24/2003 11:56'!
allMorphsDo: aBlock 
	"Evaluate the given block for all morphs in this composite morph (including the receiver)."

	submorphs do: [:m | m allMorphsDo: aBlock].
	aBlock value: self! !

!Brick methodsFor: 'submorphs-accessing' stamp: 'tb 3/4/2003 19:35'!
allSubmorphNamesDo: nameBlock
	"Return a list of all known names of submorphs and nested submorphs of the receiver, based on the scope of the receiver.  Items in parts bins are excluded"

	self isPartsBin ifTrue: [^ self]. "Don't report names from parts bins"
	self submorphsDo: 
		[:m | m knownName ifNotNilDo: [:n | nameBlock value: n].
		m allSubmorphNamesDo: nameBlock].
! !

!Brick methodsFor: 'submorphs-accessing' stamp: 'tb 3/8/2003 18:18'!
hasSubmorphs
	^submorphs notEmpty! !

!Brick methodsFor: 'submorphs-accessing' stamp: 'tb 3/10/2003 10:27'!
morphsAt: aPoint
	"Return a collection of all morphs in this morph structure that contain the given point, possibly including the receiver itself.  The order is deepest embedding first."
	^self morphsAt: aPoint unlocked: false! !

!Brick methodsFor: 'submorphs-accessing' stamp: 'tb 3/8/2003 12:01'!
morphsAt: aPoint behind: aMorph unlocked: aBool 
	"Return all morphs at aPoint that are behind frontMorph; if aBool is true return only unlocked, visible morphs."

	| isBack found all tfm |
	all := (aMorph isNil or: [owner isNil]) 
				ifTrue: 
					["Traverse down"

					(self fullBounds containsPoint: aPoint) ifFalse: [^#()].
					(aBool and: [self isLocked or: [self visible not]]) ifTrue: [^#()].
					nil]
				ifFalse: 
					["Traverse up"

					tfm := self transformedFrom: owner.
					all := owner 
								morphsAt: (tfm localPointToGlobal: aPoint)
								behind: self
								unlocked: aBool.
					WriteStream with: all].
	isBack := aMorph isNil.
	self submorphsDo: 
			[:m | 
			isBack 
				ifTrue: 
					[tfm := m transformedFrom: self.
					found := m 
								morphsAt: (tfm globalPointToLocal: aPoint)
								behind: nil
								unlocked: aBool.
					found notEmpty 
						ifTrue: 
							[all ifNil: [all := WriteStream on: #()].
							all nextPutAll: found]].
			m == aMorph ifTrue: [isBack := true]].
	(isBack and: [self containsPoint: aPoint]) 
		ifTrue: 
			[all ifNil: [^Array with: self].
			all nextPut: self].
	^all ifNil: [#()] ifNotNil: [all contents]! !

!Brick methodsFor: 'submorphs-accessing' stamp: 'tb 3/10/2003 10:27'!
morphsAt: aPoint unlocked: aBool
	"Return a collection of all morphs in this morph structure that contain the given point, possibly including the receiver itself.  The order is deepest embedding first."
	| mList |
	mList _ WriteStream on: #().
	self morphsAt: aPoint unlocked: aBool do:[:m| mList nextPut: m].
	^mList contents! !

!Brick methodsFor: 'submorphs-accessing' stamp: 'tb 3/10/2003 10:27'!
morphsAt: aPoint unlocked: aBool do: aBlock
	"Evaluate aBlock with all the morphs starting at the receiver which appear at aPoint. If aBool is true take only visible, unlocked morphs into account."
	| tfm |
	(self fullBounds containsPoint: aPoint) ifFalse:[^self].
	(aBool and:[self isLocked or:[self visible not]]) ifTrue:[^self].
	self submorphsDo:[:m|
		tfm _ m transformedFrom: self.
		m morphsAt: (tfm globalPointToLocal: aPoint) unlocked: aBool do: aBlock].
	(self containsPoint: aPoint) ifTrue:[aBlock value: self].! !

!Brick methodsFor: 'submorphs-accessing' stamp: 'tb 2/24/2003 11:41'!
submorphs

	^ submorphs copy! !

!Brick methodsFor: 'submorphs-accessing' stamp: 'tb 2/24/2003 11:56'!
submorphsDo: aBlock 
	submorphs do: aBlock! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/16/2003 20:33'!
areasRemainingToFill: aRectangle
	
	^ Array with: aRectangle! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/8/2003 18:18'!
boundsWithinCorners

	^ CornerRounder rectWithinCornersOf: self bounds! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/6/2003 14:04'!
clipSubmorphs
	"Drawing specific. If this property is set, clip the receiver's  
	submorphs to the receiver's clipping bounds."
	^ self
		valueOfProperty: #clipSubmorphs
		ifAbsent: [false]! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/8/2003 14:51'!
drawDropShadowOn: aCanvas

	aCanvas 
		translateBy: self shadowOffset 
		during: [ :shadowCanvas |
			shadowCanvas shadowColor: self shadowColor.
			shadowCanvas roundCornersOf: self during: [ 
				(shadowCanvas isVisible: self bounds) ifTrue:[shadowCanvas drawMorph: self ]]
		].
! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/9/2003 18:12'!
drawErrorOn: aCanvas
	"The morph (or one of its submorphs) had an error in its drawing method."
	aCanvas
		frameAndFillRectangle: bounds
		fillColor: Color red
		borderWidth: 1
		borderColor: Color yellow.
	aCanvas line: bounds topLeft to: bounds bottomRight width: 1 color: Color yellow.
	aCanvas line: bounds topRight to: bounds bottomLeft width: 1 color: Color yellow.! !

!Brick methodsFor: 'drawing' stamp: 'tb 2/24/2003 11:40'!
drawMouseDownHighlightOn: aCanvas
	self highlightedForMouseDown ifTrue: [
		aCanvas frameRectangle: self fullBounds color: self color darker darker].! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/17/2003 12:12'!
drawOn: aCanvas

	"Do custom drawing here"! !

!Brick methodsFor: 'drawing' stamp: 'tb 2/24/2003 11:40'!
drawSubmorphsOn: aCanvas 
	"Display submorphs back to front"

	| drawBlock |
	submorphs isEmpty ifTrue: [^self].
	drawBlock := [:canvas | submorphs reverseDo: [:m | canvas fullDrawMorph: m]].
	self clipSubmorphs 
		ifTrue: [aCanvas clipBy: self clippingBounds during: drawBlock]
		ifFalse: [drawBlock value: aCanvas]! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/17/2003 17:40'!
fullDrawOn: aCanvas
	"Draw the full Morphic structure on the given Canvas"

	self visible ifFalse: [^ self].
	(aCanvas isVisible: self fullBounds) ifFalse:[^self].
	(self hasProperty: #errorOnDraw) ifTrue:[^self drawErrorOn: aCanvas].
	"Note: At some point we should generalize this into some sort of 
	multi-canvas so that we can cross-optimize some drawing operations."

	(aCanvas isVisible: self bounds) ifTrue:
		[
			painters ifNil: [aCanvas drawMorph: self]
			ifNotNil: 
			[
				self paintUnder: aCanvas.
				self paintOn: aCanvas.
				"self paintOver: aCanvas."
			].

" These want to become painters -tb
		self drawDropHighlightOn: aCanvas.
		self drawMouseDownHighlightOn: aCanvas
"
	].! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/6/2003 14:04'!
hasClipSubmorphsString
	"Answer a string that represents the clip-submophs checkbox"

	^ self clipSubmorphs
		ifTrue:['<on>provide clipping']
		ifFalse:['<off>provide clipping']! !

!Brick methodsFor: 'drawing' stamp: 'tb 2/24/2003 11:40'!
highlightedForMouseDown
	^(self valueOfProperty: #highlightedForMouseDown) == true! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/8/2003 14:46'!
imageForm

	^ self imageFormForRectangle: self fullBounds
! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/6/2003 14:16'!
imageForm: depth forRectangle: rect
	| canvas |
	canvas _ Display defaultCanvasClass extent: rect extent depth: depth.
	canvas translateBy: rect topLeft negated
		during:[:tempCanvas| tempCanvas fullDrawMorph: self].
	^ canvas form offset: rect topLeft! !

!Brick methodsFor: 'drawing' stamp: 'tb 3/6/2003 14:16'!
imageFormForRectangle: rect

	^ self imageForm: Display depth forRectangle: rect
! !

!Brick methodsFor: 'drawing' stamp: 'tb 2/24/2003 11:40'!
visible
	"answer whether the receiver is visible"
	self hasExtension
		ifFalse: [^ true].
	^ self extension visible! !

!Brick methodsFor: 'accessing - extension' stamp: 'tb 3/4/2003 09:46'!
assureExtension
	"creates an extension for the receiver if needed"
	self hasExtension
		ifFalse: [self initializeExtension].
	^ self extension! !

!Brick methodsFor: 'accessing - extension' stamp: 'tb 2/24/2003 11:23'!
extension
	"answer the recevier's extension"
	^ extension! !

!Brick methodsFor: 'accessing - extension' stamp: 'tb 2/24/2003 11:23'!
hasExtension
	"answer whether the receiver has extention"
	^ self extension notNil! !

!Brick methodsFor: 'accessing - extension' stamp: 'tb 3/4/2003 09:46'!
initializeExtension
	"private - initializes the receiver's extension"
	self privateExtension: MorphExtension new initialize! !

!Brick methodsFor: 'accessing - extension' stamp: 'tb 3/4/2003 09:46'!
privateExtension: aMorphExtension
	"private - change the receiver's extension"
	extension _ aMorphExtension! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/8/2003 12:07'!
assureLayoutProperties
	| props |
	props _ self layoutProperties.
	props == self ifTrue:[props _ nil].
	props ifNil:[
		props _ LayoutProperties new initializeFrom: self.
		self layoutProperties: props].
	^props! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:10'!
bottomFixed
	"answer if my bottom edge stays a fixed distance from my owner's bottom edge"
	
	| props |
	props _ self extension.
	^props ifNil:[false] ifNotNil:[props valueOfProperty: #bottomFixed ifAbsent: [false]].! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:18'!
bottomFixed: opt
	"answer #rigid if I don't stretch horizontally when my owner is resized"
	
	opt ifFalse:
	[
		self extension notNil ifTrue: [self extension removeProperty: #bottomFixed].
	]
	ifTrue:
	[
		self assureExtension setProperty: #bottomFixed toValue: opt.
	]
		! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 21:04'!
bottomFraction

	self extension ifNil: [ self updateLayoutProperties ].
	^self extension valueOfProperty: #bottomFraction	
		ifAbsent: [self updateLayoutProperties. extension valueOfProperty: #bottomFraction]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 20:11'!
disableTableLayout
	"Layout specific. Disable laying out the receiver in table layout"
	| props |
	props _ self layoutProperties.
	^props ifNil:[false] ifNotNil:[props disableTableLayout].! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 21:03'!
hCenterFraction

	self extension ifNil: [ self updateLayoutProperties ].
	^self extension valueOfProperty: #hCenterFraction 
		ifAbsent: [self updateLayoutProperties. extension valueOfProperty: #hCenterFraction]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:06'!
hResizing
	"answer #rigid if I don't stretch horizontally when my owner is resized"
	
	| props |
	props _ self extension.
	^props ifNil:[#rigid] ifNotNil:[props valueOfProperty: #hResizing ifAbsent: [#rigid]].! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:04'!
hResizing: opt
	"answer #rigid if I don't stretch horizontally when my owner is resized"
	
	(opt ~= self hResizing) ifTrue: [self assureExtension setProperty: #hResizing toValue: opt].! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/8/2003 16:37'!
layoutInset
	"Return the extra inset for layouts"
	| props |
	props _ self layoutProperties.
	^props ifNil:[0] ifNotNil:[props layoutInset].! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/8/2003 18:18'!
layoutPolicy
	"Layout specific. Return the layout policy describing how children 
	of the receiver should appear."
	^ self hasExtension
		ifTrue: [ self extension layoutPolicy]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/8/2003 20:07'!
layoutPolicy: aLayoutPolicy
	"Layout specific. Return the layout policy describing how children of the receiver should appear."
	self layoutPolicy == aLayoutPolicy ifTrue:[^self].
	self assureExtension layoutPolicy: aLayoutPolicy.
	self layoutChanged.! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 20:01'!
layoutProperties
	"Return the current layout properties associated with the  
	receiver"
	^ self hasExtension
		ifTrue: [self extension layoutProperties]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 22:20'!
layoutProperties: newProperties
	"Return the current layout properties associated with the receiver"
	self layoutProperties == newProperties ifTrue:[^self].
	self assureExtension layoutProperties: newProperties.
! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:08'!
leftFixed
	"answer if my left edge stays a fixed distance from my owner's left edge"
	
	| props |
	props _ self extension.
	^props ifNil:[true] ifNotNil:[props valueOfProperty: #leftFixed ifAbsent: [true]].! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:17'!
leftFixed: opt
	"answer #rigid if I don't stretch horizontally when my owner is resized"
	
	opt ifTrue:
	[
		self extension notNil ifTrue: [self extension removeProperty: #leftFixed].
	]
	ifFalse:
	[
		self assureExtension setProperty: #leftFixed toValue: opt.
	]
		! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 21:05'!
leftFraction

	self extension ifNil: [ self updateLayoutProperties ].
	^self extension valueOfProperty: #leftFraction
		ifAbsent: [self updateLayoutProperties. extension valueOfProperty: #leftFraction]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/10/2003 22:42'!
leftToRightLayout: aString

	aString size = 3 ifTrue:
	[
		self leftFixed: ((aString at: 1) = $-).
		self rightFixed: ((aString at: 3) = $-).
		((aString at: 2) = $-) 
			ifTrue: [ self hResizing: #rigid ]
			ifFalse: [ self hResizing: #spaceFill ] 
	]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 20:59'!
rightFixed
	"answer if my right edge stays a fixed distance from my owner's right edge"
	| props |
	
	props _ self extension.
	^props ifNil:[false] ifNotNil:[props valueOfProperty: #rightFixed ifAbsent: [false]].! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 20:58'!
rightFixed: opt
	"answer #rigid if I don't stretch horizontally when my owner is resized"
	
	opt ifFalse:
	[
		self extension notNil ifTrue: [self extension removeProperty: #rightFixed].
	]
	ifTrue:
	[
		self assureExtension setProperty: #rightFixed toValue: opt.
	]
		! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 21:05'!
rightFraction

	self extension ifNil: [ self updateLayoutProperties ].
	^self extension valueOfProperty: #rightFraction
		ifAbsent: [self updateLayoutProperties. extension valueOfProperty: #rightFraction]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/8/2003 18:18'!
spaceFillWeight
	"Layout specific. This property describes the relative weight that 
	should be given to the receiver when extra space is distributed 
	between different #spaceFill cells."

	^ self
		valueOfProperty: #spaceFillWeight
		ifAbsent: [1]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:08'!
topFixed
	"answer if my top edge stays a fixed distance from my owner's top edge"
	
	| props |
	props _ self extension.
	^props ifNil:[true] ifNotNil:[props valueOfProperty: #topFixed ifAbsent: [true]].! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:17'!
topFixed: opt
	"answer #rigid if I don't stretch horizontally when my owner is resized"
	
	opt ifTrue:
	[
		self extension notNil ifTrue: [self extension removeProperty: #topFixed].
	]
	ifFalse:
	[
		self assureExtension setProperty: #topFixed toValue: opt.
	]
		! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 21:05'!
topFraction

	self extension ifNil: [ self updateLayoutProperties ].
	^self extension valueOfProperty: #topFraction
		ifAbsent: [self updateLayoutProperties. extension valueOfProperty: #topFraction]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/10/2003 22:42'!
topToBottomLayout: aString

	aString size = 3 ifTrue:
	[
		self topFixed: ((aString at: 1) = $-).
		self bottomFixed: ((aString at: 3) = $-).
		((aString at: 2) = $-) 
			ifTrue: [ self vResizing: #rigid ]
			ifFalse: [ self vResizing: #spaceFill ] 
	]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/10/2003 21:52'!
updateLayoutProperties

	(self owner == self world or: [(self owner isNil)]) ifTrue: 
	[
		| ext |
		(ext := self extension) ifNotNil:
		[
			ext removeProperty: #leftFraction.
			ext removeProperty: #rightFraction.
			ext removeProperty: #topFraction.
			ext removeProperty: #bottomFraction.
			ext removeProperty: #hCenterFraction.
			ext removeProperty: #vCenterFraction.
		] 
	]
	ifFalse:
	[
		| ext |
		ext := self assureExtension.
		ext setProperty: #leftFraction toValue: ((self left - self owner left)/(self owner width)).
		ext setProperty: #rightFraction toValue: ((self right - self owner left)/(self owner width)).
		ext setProperty: #topFraction toValue: ((self top - self owner top)/(self owner height)).
		ext setProperty: #bottomFraction toValue: ((self bottom - self owner top)/(self owner height)).
		ext setProperty: #hCenterFraction toValue: ((self center x - self owner left)/(self owner width)).
		ext setProperty: #vCenterFraction toValue: ((self center y - self owner top)/(self owner height)).
	]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 21:04'!
vCenterFraction

	self extension ifNil: [ self updateLayoutProperties ].
	^self extension valueOfProperty: #vCenterFraction 		
		ifAbsent: [self updateLayoutProperties. extension valueOfProperty: #vCenterFraction]! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:06'!
vResizing
	"answer #rigid if I don't stretch horizontally when my owner is resized"
	
	| props |
	props _ self extension.
	^props ifNil:[#rigid] ifNotNil:[props valueOfProperty: #vResizing ifAbsent: [#rigid]].! !

!Brick methodsFor: 'layout-properties' stamp: 'tb 3/9/2003 19:04'!
vResizing: opt
	"answer #rigid if I don't stretch horizontally when my owner is resized"
	
	(opt ~= self vResizing) ifTrue: [self assureExtension setProperty: #vResizing toValue: opt].! !

!Brick methodsFor: 'e-toy support' stamp: 'tb 3/9/2003 16:03'!
automaticViewing
	"Backstop, in case this message gets sent to an owner that is not a playfield"
	^ false! !

!Brick methodsFor: 'e-toy support' stamp: 'tb 3/6/2003 14:04'!
mustBeBackmost
	"Answer whether the receiver needs to be the backmost morph in its owner's submorph list"

	^ false! !

!Brick methodsFor: 'e-toy support' stamp: 'tb 3/9/2003 00:24'!
referencePlayfield
	"Answer the PasteUpMorph to be used for cartesian-coordinate reference"

	| former |
	owner ifNotNil:
		[owner isPlayfieldLike ifTrue: [^ owner].
		(owner isHandMorph and: [(former _ self formerOwner) notNil])
			ifTrue:
				[^ former isPlayfieldLike 
					ifTrue: [former]
					ifFalse: [former referencePlayfield]]].
	^ self world! !

!Brick methodsFor: 'accessing' stamp: 'tb 2/24/2003 11:41'!
balloonText
	"Answer balloon help text or nil, if no help is available.  
	NB: subclasses may override such that they programatically  
	construct the text, for economy's sake, such as model phrases in 
	a Viewer"

	| text balloonSelector aString |
	self hasExtension ifFalse: [^nil].
	(text := self extension balloonText) ifNotNil: [^text].
	(balloonSelector := self extension balloonTextSelector) ifNotNil: 
			[aString := ScriptingSystem helpStringOrNilFor: balloonSelector.
			(aString isNil and: [balloonSelector == #methodComment]) 
				ifTrue: [aString := self methodCommentAsBalloonHelp].
			((aString isNil and: [balloonSelector numArgs = 0]) 
				and: [self respondsTo: balloonSelector]) 
					ifTrue: [aString := self perform: balloonSelector]].
	^aString ifNotNil: 
			[aString asString 
				withNoLineLongerThan: Preferences maxBalloonHelpLineLength]! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/19/2003 14:23'!
balloonTextSelector: aSelector 
	"change the receiver's balloonTextSelector"
	self assureExtension balloonTextSelector: aSelector! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/18/2003 13:49'!
borderStyle
	^(self valueOfProperty: #borderStyle ifAbsent:[BorderStyle default]) trackColorFrom: self! !

!Brick methodsFor: 'accessing' stamp: 'tb 4/9/2003 17:20'!
borderWidth
	^self borderStyle width! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/8/2003 12:33'!
color

	^ color 	"has already been set to ((self valueOfProperty: #fillStyle) asColor)"! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/8/2003 11:53'!
color: aColor
	"Set the receiver's color.  Directly set the color if appropriate, else go by way of fillStyle"

	(aColor isColor or: [aColor isKindOf: InfiniteForm]) ifFalse:[^ self fillStyle: aColor].
	color = aColor ifFalse:
		[self removeProperty: #fillStyle.
		color _ aColor.
		self changed]! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/8/2003 14:45'!
colorForInsets
	"Return the color to be used for shading inset borders.  The default is my own color, but it might want to be, eg, my owner's color.  Whoever's color ends up prevailing, the color itself gets the last chance to determine, so that when, for example, an InfiniteForm serves as the color, callers won't choke on some non-Color object being returned"
	(color isColor and:[color isTransparent and:[owner notNil]]) ifTrue:[^owner colorForInsets].
	^ color colorForInsets
! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/6/2003 14:04'!
couldHaveRoundedCorners
	^ true! !

!Brick methodsFor: 'accessing' stamp: 'tb 2/24/2003 11:41'!
eventHandler
	"answer the receiver's eventHandler"
	^ self hasExtension
		ifTrue: [self extension eventHandler] ! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/8/2003 18:13'!
eventHandler: anEventHandler 
	"Note that morphs can share eventHandlers and all is OK. "
	self assureExtension eventHandler: anEventHandler! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/6/2003 14:16'!
forwardDirection
	"Return the receiver's forward direction (in eToy terms)"
	^self valueOfProperty: #forwardDirection ifAbsent:[0.0]! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/4/2003 09:46'!
hasTranslucentColor
	"Answer true if this any of this morph is translucent but not transparent."

	^ color isColor and: [color isTranslucentColor]
! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/8/2003 14:45'!
insetColor
	owner ifNil:[^self color].
	^ self colorForInsets! !

!Brick methodsFor: 'accessing' stamp: 'tb 2/24/2003 11:40'!
isFlap
	"Answer whether the receiver claims to be a flap"

	^ self hasProperty: #flap! !

!Brick methodsFor: 'accessing' stamp: 'tb 2/24/2003 11:40'!
isLocked
	"answer whether the receiver is Locked"
	self hasExtension
		ifFalse: [^ false].
	^ self extension locked! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/4/2003 09:46'!
isShared
	"Answer whether the receiver has the #shared property.  This property allows it to be treated as a 'background' item"

	^ self hasProperty: #shared! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/4/2003 09:46'!
isSticky
	"answer whether the receiver is Sticky"
	self hasExtension
		ifFalse: [^ false].
	^ self extension sticky! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/11/2003 00:28'!
lock
	self lock: true! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/8/2003 20:16'!
lock: aBoolean 
	"change the receiver's lock property"
	(self hasExtension not
			and: [aBoolean not])
		ifTrue: [^ self].
	self assureExtension locked: aBoolean! !

!Brick methodsFor: 'accessing' stamp: 'tb 2/24/2003 11:40'!
player
	"answer the receiver's player"
	^ self hasExtension
		ifTrue: [self extension player]! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/8/2003 14:43'!
raisedColor
	"Return the color to be used for shading raised borders.  The default is my own color, but it might want to be, eg, my owner's color.  Whoever's color ends up prevailing, the color itself gets the last chance to determine, so that when, for example, an InfiniteForm serves as the color, callers won't choke on some non-Color object being returned"
	(color isColor and:[color isTransparent and:[owner notNil]]) ifTrue:[^owner raisedColor].
	^ color raisedColor! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/4/2003 19:35'!
resistsRemoval
	"Answer whether the receiver is marked as resisting removal"

	^ self hasProperty: #resistsRemoval! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/9/2003 19:52'!
setConstrainedPosition: aPoint hangOut: partiallyOutside
	"Change the position of this morph and and all of its submorphs to aPoint, but don't let me go outside my owner's bounds.  Let me go within two pixels of completely outside if partiallyOutside is true."

	| trialRect delta boundingMorph bRect |
	owner ifNil:[^self].
	trialRect _ aPoint extent: self bounds extent.
	boundingMorph _ self topRendererOrSelf owner.
	delta _ boundingMorph
			ifNil:    [0@0]
			ifNotNil: [
				bRect _ partiallyOutside 
					ifTrue: [boundingMorph bounds insetBy: 
								self extent negated + boundingMorph borderWidth + (2@2)]
					ifFalse: [boundingMorph bounds].
				trialRect amountToTranslateWithin: bRect].
	self position: aPoint + delta.
	self updateLayoutProperties.
	self layoutChanged  "So that, eg, surrounding text will readjust"
! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/17/2003 12:54'!
sqkPage
	^ self valueOfProperty: #SqueakPage! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/8/2003 20:16'!
sticky: aBoolean 
	"change the receiver's sticky property"
	self extension sticky: aBoolean! !

!Brick methodsFor: 'accessing' stamp: 'tb 4/9/2003 15:23'!
toggleStickiness
	"togle the receiver's Stickiness"
	self hasExtension
		ifFalse: [^ self beSticky].
	self extension sticky: self extension sticky not! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/11/2003 00:30'!
unlock
	self lock: false! !

!Brick methodsFor: 'accessing' stamp: 'tb 3/4/2003 09:46'!
wantsToBeCachedByHand
	"Return true if the receiver wants to be cached by the hand when it is dragged around.
	Note: The default implementation queries all submorphs since subclasses may have shapes that do not fill the receiver's bounds completely."
	self hasTranslucentColor ifTrue:[^false].
	self submorphsDo:[:m|
		m wantsToBeCachedByHand ifFalse:[^false].
	].
	^true! !

!Brick methodsFor: 'testing' stamp: 'tb 2/24/2003 19:32'!
isMorph

	^ true! !

!Brick methodsFor: 'testing' stamp: 'tb 2/24/2003 11:23'!
knownName
	"answer a name by which the receiver is known, or nil if none"
	^ self hasExtension
		ifTrue: [self extension externalName]! !

!Brick methodsFor: 'testing' stamp: 'tb 3/4/2003 09:46'!
shouldDropOnMouseUp
	| former |
	former _ self formerPosition ifNil:[^false].
	^(former dist: self position) > 10! !

!Brick methodsFor: 'testing' stamp: 'tb 2/24/2003 11:55'!
wantsSteps
	"Return true if the receiver overrides the default Morph step method."
	"Details: Find first class in superclass chain that implements #step and return true if it isn't class Morph."

	| c |
	self isPartsDonor ifTrue: [^ false].
	self player wantsSteps ifTrue: [^ true].
	c _ self class.
	[(c superclass ~= Object) and: [(c includesSelector: #step) not]] whileTrue: [c _ c superclass].
	^ c superclass ~= Object! !

!Brick methodsFor: 'visual properties' stamp: 'tb 4/9/2003 15:23'!
canHaveFillStyles
	"Return true if the receiver can have general fill styles; not just colors.
	This method is for gradually converting old morphs."
	^self class == Morph "no subclasses"! !

!Brick methodsFor: 'updating' stamp: 'tb 3/15/2003 11:53'!
changed
	"Report that the area occupied by this morph should be redrawn."
	^self invalidRect: self outerBounds! !

!Brick methodsFor: 'naming' stamp: 'tb 3/10/2003 10:27'!
choosePartName
	"Pick an unused name for this morph."
	| className |
	(self world model isKindOf: Component) ifTrue:
		[self knownName ifNil: [^ self nameMeIn: self world]
					ifNotNil: [^ self renameMe]].
	className _ self class name.
	(className size > 5 and: [className endsWith: 'Morph'])
		ifTrue: [className _ className copyFrom: 1 to: className size - 5].
	^ self world model addPartNameLike: className withValue: self! !

!Brick methodsFor: 'naming' stamp: 'tb 3/4/2003 19:35'!
innocuousName
	"Choose an innocuous name for the receiver -- one that does not end in the word Morph"

	| className allKnownNames |
	className _ self defaultNameStemForInstances.
	(className size > 5 and: [className endsWith: 'Morph'])
		ifTrue: [className _ className copyFrom: 1 to: className size - 5].
	className _ className asString.
	allKnownNames _ self world ifNil: [OrderedCollection new] ifNotNil: [self world allKnownNames].
	^ Utilities keyLike: className asString satisfying:
		[:aName | (allKnownNames includes: aName) not]! !

!Brick methodsFor: 'naming' stamp: 'tb 4/12/2003 15:53'!
nameForFindWindowFeature
	"Answer the name to show in a list of windows-and-morphs to represent the receiver"

	^ self knownName ifNil: [self class name]! !

!Brick methodsFor: 'error handling' stamp: 'tb 3/14/2003 11:59'!
cloneSelector: sel

	Brick removeSelector: sel.
	Brick copy: sel from: Morph.
	"(ChangeSet allInstances detect: [:ea | ea name = 'Morphic-Changes']) fileOut."
! !

!Brick methodsFor: 'error handling' stamp: 'tb 2/13/2003 00:40'!
doesNotUnderstand: aMessage 

	Morph sourceCodeAt: (aMessage selector) ifAbsent: [ super doesNotUnderstand: aMessage].
	self cloneSelector: (aMessage selector).
	^self perform: (aMessage selector) withArguments: (aMessage arguments).
	! !

!Brick methodsFor: 'undo' stamp: 'tb 3/9/2003 00:42'!
commandHistory
	"Return the command history for the receiver"
	| w |
	(w _ self world) ifNotNil:[^w commandHistory].
	(w _ self currentWorld) ifNotNil:[^w commandHistory].
	^CommandHistory new. "won't really record anything but prevent breaking things"! !

!Brick methodsFor: 'geometry testing' stamp: 'tb 2/24/2003 11:41'!
containsPoint: aPoint

	^ self bounds containsPoint: aPoint! !

!Brick methodsFor: 'geometry testing' stamp: 'tb 2/24/2003 15:55'!
fullContainsPoint: aPoint

	(self fullBounds containsPoint: aPoint) ifFalse: [^ false].  "quick elimination"
	(self containsPoint: aPoint) ifTrue: [^ true].  "quick acceptance"
	submorphs do: [:m | (m fullContainsPoint: aPoint) ifTrue: [^ true]].
	^ false
! !

!Brick methodsFor: 'events-processing' stamp: 'tb 2/24/2003 11:41'!
containsPoint: aPoint event: anEvent
	"Return true if aPoint is considered to be inside the receiver for the given event.
	The default implementation treats locked children as integral part of their owners."
	(self fullBounds containsPoint: aPoint) ifFalse:[^false].
	(self containsPoint: aPoint) ifTrue:[^true].
	self submorphsDo:[:m|
		(m isLocked and:[m fullContainsPoint: 
			((m transformedFrom: self) globalPointToLocal: aPoint)]) ifTrue:[^true]].
	^false! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 23:45'!
handleDropMorph: anEvent
	"Handle a dropping morph."
	| aMorph localPt |
	aMorph _ anEvent contents.
	"Do a symmetric check if both morphs like each other"
	((self wantsDroppedMorph: aMorph event: anEvent)	"I want her"
		and: [aMorph wantsToBeDroppedInto: self])		"she wants me"
		ifFalse: [aMorph removeProperty: #undoGrabCommand.
				^ self].
	anEvent wasHandled: true.
	"Transform the morph into the receiver's coordinate frame. This is currently incomplete since it only takes the offset into account where it really should take the entire transform."
	localPt _ (self transformedFrom: anEvent hand world) "full transform down"
				globalPointToLocal: aMorph referencePosition.
	aMorph referencePosition: localPt.
	self acceptDroppingMorph: aMorph event: anEvent.
	aMorph justDroppedInto: self event: anEvent.
	self removePainter: RolloverBorderPainter.
! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 14:47'!
handleEvent: anEvent
	"Handle the given event"
	^anEvent sentTo: self.! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 15:28'!
handleFocusEvent: anEvent
	"Handle the given event. This message is sent if the receiver currently has the focus and is therefore receiving events directly from some hand."
	^self handleEvent: anEvent! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/14/2003 12:03'!
handleKeyDown: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:[^self].
	anEvent wasHandled: true.
	^self keyDown: anEvent! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/14/2003 12:03'!
handleKeyUp: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:[^self].
	anEvent wasHandled: true.
	^self keyUp: anEvent! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/14/2003 12:03'!
handleKeystroke: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:[^self].
	anEvent wasHandled: true.
	^self keyStroke: anEvent! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 18:07'!
handleMouseDown: anEvent
	"System level event handling."
	| selectors |
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent hand removePendingBalloonFor: self.
	anEvent hand removePendingHaloFor: self.
	anEvent wasHandled: true.
	anEvent controlKeyPressed ifTrue:[^self invokeMetaMenu: anEvent].
	"Make me modal during mouse transitions"
	anEvent hand newMouseFocus: self event: anEvent.
	anEvent blueButtonChanged ifTrue:[^self blueButtonDown: anEvent].
	(self allowsGestureStart: anEvent)
		ifTrue: [^ self gestureStart: anEvent].
	(self respondsTo: #mouseDown:) ifTrue: [self mouseDown: anEvent].
	anEvent hand removeHaloFromClick: anEvent on: self.

	selectors := Array 
		with: ((self respondsTo: #click:) ifTrue: [#click: ] ifFalse: [nil])
		with: ((self respondsTo: #doubleClick:) ifTrue: [#doubleClick: ] ifFalse: [nil])
		with: nil
		with: ((self respondsTo: #startDrag:) ifTrue:[#startDrag:] ifFalse:[nil]).

	(self handlesMouseStillDown: anEvent) ifTrue:[
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue + self mouseStillDownThreshold
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].

	anEvent hand waitForClicksOrDrag: self event: anEvent selectors: selectors threshold: 10 "pixels".

! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/29/2003 22:08'!
handleMouseEnter: anEvent
	"System level event handling."
	| aMorph |

	(anEvent isDraggingEvent or: [anEvent hand submorphs isEmpty not]) ifTrue:
	[
		aMorph := nil.
		(anEvent respondsTo: #contents) 
			ifTrue: [aMorph := anEvent contents]
			ifFalse: 
			[
				aMorph := (anEvent hand hasSubmorphs) 
					ifTrue: [anEvent hand submorphs last] 
					ifFalse:[nil]
			].

		aMorph ifNotNil:
		[
			"Do a symmetric check if both morphs like each other"
			((self wantsDroppedMorph: aMorph event: anEvent)	"I want her"
				and: [aMorph wantsToBeDroppedInto: self])		"she wants me"
			ifTrue: 
			[
				"if owner has a hilight - remove it"
				self allOwnersDo: [:ea | (ea isKindOf: Brick) 
					ifTrue: [ea removePainter: RolloverBorderPainter]].
				self addPainter: (RolloverBorderPainter new)].
			].

		(self handlesMouseOverDragging: anEvent) ifTrue: [
			anEvent wasHandled: true.
			self mouseEnterDragging: anEvent].
		^self
	].
	self wantsHalo "If receiver wants halo and balloon, trigger balloon after halo"
		ifTrue:[anEvent hand triggerHaloFor: self after: self haloDelayTime]
		ifFalse:[self wantsBalloon
			ifTrue:[anEvent hand triggerBalloonFor: self after: self balloonHelpDelayTime]].
	((self handlesMouseOver: anEvent) and: [self respondsTo: #mouseEnter:]) ifTrue:[
		anEvent wasHandled: true.
		self mouseEnter: anEvent.
	].! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/29/2003 22:37'!
handleMouseLeave: anEvent
	"System level event handling."
	anEvent hand removePendingBalloonFor: self.
	anEvent hand removePendingHaloFor: self.
	self removePainter: RolloverBorderPainter.
	anEvent isDraggingEvent ifTrue:
	[
		| parent dragged |
		dragged := anEvent hand submorphs 
			isEmpty ifTrue: [nil] 
			ifFalse: [anEvent hand submorphs].

		dragged ifNotNil:
		[
			parent := self allOwners detect: 
				[:ea | (ea isKindOf: Brick) and: 
					[((ea wantsDroppedMorph: dragged event: anEvent)	"I want her"
					and: [dragged wantsToBeDroppedInto: ea])]]	"she wants me"
				ifNone: [nil].
		] ifNil: [parent := nil].		
		
		parent ifNotNil: [parent addPainter: (RolloverBorderPainter new)].

		(self handlesMouseOverDragging: anEvent) ifTrue:[
			anEvent wasHandled: true.
			(self respondsTo: #mouseLeaveDragging:) ifTrue: [self mouseLeaveDragging: anEvent]].
		^self].
	((self handlesMouseOver: anEvent) and: [self respondsTo: #mouseLeave:]) ifTrue:[
		anEvent wasHandled: true.
		self mouseLeave: anEvent.
	].
! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/10/2003 16:37'!
handleMouseMove: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	"Rules say that by default a morph gets #mouseMove iff
		* the hand is not dragging anything,
			+ and some button is down,
			+ and the receiver is the current mouse focus."
	(anEvent hand hasSubmorphs) ifTrue:[^self].
	
	(self respondsTo: #mouseMove:) ifTrue: 
	[
		anEvent wasHandled: true. self mouseMove: anEvent
	].
	(self handlesMouseStillDown: anEvent) ifTrue:[
		"Step at the new location"
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].
! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 14:47'!
handleMouseOver: anEvent
	"System level event handling."
	anEvent hand mouseFocus == self ifTrue:[
		"Got this directly through #handleFocusEvent: so check explicitly"
		(self containsPoint: anEvent position event: anEvent) ifFalse:[^self]].
	anEvent hand noticeMouseOver: self event: anEvent! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 15:30'!
handleMouseUp: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent hand mouseFocus == self ifFalse:[^self]. "Not interested in other parties"
	anEvent hand releaseMouseFocus: self.
	anEvent wasHandled: true.
	anEvent blueButtonChanged
		ifTrue:[self blueButtonUp: anEvent]
		ifFalse:[(self respondsTo: #mouseUp:) ifTrue: [self mouseUp: anEvent].
				self stopSteppingSelector: #handleMouseStillDown:].! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 14:49'!
handlerForMouseDown: anEvent
	"Return the (prospective) handler for a mouse down event. The handler is temporarily installed and can be used for morphs further down the hierarchy to negotiate whether the inner or the outer morph should finally handle the event"
	anEvent blueButtonPressed ifTrue:[^self handlerForBlueButtonDown: anEvent].
	anEvent controlKeyPressed ifTrue:[^self handlerForMetaMenu: anEvent].
	(self handlesMouseDown: anEvent) ifFalse:[^nil]. "not interested"
	anEvent handler ifNil:[^self]. "Nobody else was interested"
	self mouseDownPriority >= anEvent handler mouseDownPriority 
		ifTrue:[^self] "Same priority but I am innermost"
		ifFalse:[^nil]. "Other guy has higher priority than I"! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 15:28'!
mouseDownPriority
	"Return the default mouse down priority for the receiver"

	^ (self isPartsDonor or: [self isPartsBin])
		ifTrue:	[50]
		ifFalse:	[0]

	"The above is a workaround for the complete confusion between parts donors and parts bins. Morphs residing in a parts bin may or may not have the parts donor property set; if they have they may or may not actually handle events. To work around this, parts bins get an equal priority to parts donors so that when a morph in the parts bin does have the property set but does not handle the event we still get a copy from picking it up through the parts bin. Argh. This just *cries* for a cleanup."
	"And the above comment is Andreas's from 10/2000, which was formerly retrievable by a #flag: call which however caused a problem when trying to recompile the method from decompiled source."! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 14:47'!
processEvent: anEvent using: defaultDispatcher
	"This is the central entry for dispatching events in morphic. Given some event and a default dispatch strategy, find the right receiver and let him handle it.
	WARNING: This is a powerful hook. If you want to use a different event dispatcher from the default, here is the place to hook it in. Depending on how the dispatcher is written (e.g., whether it calls simply #processEvent: or #processEvent:using:) you can change the dispatch strategy for entire trees of morphs. Similarly, you can disable entire trees of morphs from receiving any events whatsoever. Read the documentation in class MorphicEventDispatcher before playing with it. "
	(self rejectsEvent: anEvent) ifTrue:[^#rejected].
	^defaultDispatcher dispatchEvent: anEvent with: self! !

!Brick methodsFor: 'events-processing' stamp: 'tb 4/9/2003 17:19'!
rejectDropEvent: anEvent
	"This hook allows the receiver to repel a drop operation currently executed. The method is called prior to checking children so the receiver must validate that the event was really designated for it.
	Note that the ordering of the tests below is designed to avoid a (possibly expensive) #fullContainsPoint: test. If the receiver doesn't want to repel the morph anyways we don't need to check after all."
	(self repelsMorph: anEvent contents event: anEvent) ifFalse:[^self]. "not repelled"
	(self fullContainsPoint: anEvent position) ifFalse:[^self]. "not for me"
	"Throw it away"
	anEvent wasHandled: true.
	anEvent contents rejectDropMorphEvent: anEvent.! !

!Brick methodsFor: 'events-processing' stamp: 'tb 3/11/2003 16:58'!
rejectsEvent: anEvent
	"Return true to reject the given event. Rejecting an event means neither the receiver nor any of it's submorphs will be given any chance to handle it."
	^(self visible not) or: [(self containsPoint: (anEvent cursorPoint)) not]! !

!Brick methodsFor: 'events-processing' stamp: 'tb 2/24/2003 11:40'!
transformedFrom: uberMorph
	"Return a transform to map coordinates of uberMorph, a morph above me in my owner chain, into the coordinates of MYSELF not any of my children."
	self flag: #arNote. "rename this method"
	owner ifNil:[^IdentityTransform new].
	^ (owner transformFrom: uberMorph)! !

!Brick methodsFor: 'copying' stamp: 'tb 3/18/2003 20:10'!
copy

	^ self veryDeepCopy! !

!Brick methodsFor: 'copying' stamp: 'tb 3/18/2003 20:10'!
veryDeepCopyWith: deepCopier
	"Copy me and the entire tree of objects I point to.  An object in the tree twice is copied once, and both references point to him.  deepCopier holds a dictionary of objects we have seen.  See veryDeepInner:, veryDeepFixupWith:"

	self prepareToBeSaved.
	^ super veryDeepCopyWith: deepCopier! !

!Brick methodsFor: 'copying' stamp: 'tb 3/18/2003 20:10'!
veryDeepFixupWith: deepCopier
	"If some fields were weakly copied, fix new copy here."

	"super veryDeepFixupWith: deepCopier.	Object has no fixups, so don't call it"

	"If my owner is being duplicated too, then store his duplicate.
	 If I am owned outside the duplicated tree, then I am no longer owned!!"
	owner _ deepCopier references at: owner ifAbsent: [nil].

! !

!Brick methodsFor: 'copying' stamp: 'tb 4/29/2003 21:44'!
veryDeepInner: deepCopier 
	"The inner loop, so it can be overridden when a field should not  
	be traced."
	"super veryDeepInner: deepCopier.	know Object has no inst vars"
	bounds _ bounds clone.
	"Points are shared with original"
	"owner _ owner.	special, see veryDeepFixupWith:"
	submorphs _ submorphs veryDeepCopyWith: deepCopier.
	"each submorph's fixup will install me as the owner"
	"fullBounds _ fullBounds.	fullBounds is shared with original!!"
	color _ color veryDeepCopyWith: deepCopier.
	painters := painters copy.
	delegate := nil.
	name := name ifNotNil: [name := (name, ' copy')] ifNil: [nil].
	"color, if simple, will return self. may be complex"
	self
		privateExtension: (self extension veryDeepCopyWith: deepCopier)! !

!Brick methodsFor: 'rounding' stamp: 'tb 4/9/2003 15:12'!
wantsRoundedCorners
	"Return true if the receiver wants its corners rounded"
	^ false! !

!Brick methodsFor: 'event handling' stamp: 'tb 3/12/2003 13:15'!
cursorPoint
	^ self currentHand lastEvent cursorPoint! !

!Brick methodsFor: 'event handling' stamp: 'tb 4/14/2003 12:03'!
handlesKeyboard: evt
	"Return true if the receiver wishes to handle the given keyboard event"
	self eventHandler ifNotNil: [^ self eventHandler handlesKeyboard: evt].
	^ false
! !

!Brick methodsFor: 'event handling' stamp: 'tb 4/9/2003 15:28'!
handlesMouseDown: evt
	"Do I want to receive mouseDown events (mouseDown:, mouseMove:, mouseUp:)?"
	"NOTE: The default response is false, except if you have added sensitivity to mouseDown events using the on:send:to: mechanism.  Subclasses that implement these messages directly should override this one to return true." 

	(self respondsTo: #mouseDown:) ifTrue: [^true].
	self eventHandler ifNotNil: [^ self eventHandler handlesMouseDown: evt].
	^ self allowsGestureStart: evt.
! !

!Brick methodsFor: 'event handling' stamp: 'tb 4/9/2003 16:16'!
handlesMouseOver: evt
	"Do I want to receive mouseEnter: and mouseLeave: when the button is up and the hand is empty?  The default response is false, except if you have added sensitivity to mouseEnter: or mouseLeave:, using the on:send:to: mechanism." 

	self eventHandler ifNotNil: [^ self eventHandler handlesMouseOver: evt].
	^ (self respondsTo: #mouseEnter:) or: [self respondsTo: #mouseLeave:]! !

!Brick methodsFor: 'event handling' stamp: 'tb 4/9/2003 22:04'!
handlesMouseOverDragging: anEvent
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient.  The default response is false, except if you have added sensitivity to mouseEnterLaden: or mouseLeaveLaden:, using the on:send:to: mechanism."
	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	((self respondsTo: #mouseEnterDragging:) or: [self respondsTo: #mouseLeaveDragging:] )
		ifTrue: [ ^true ].

	self eventHandler ifNotNil: [^ self eventHandler handlesMouseOverDragging: anEvent].
	^ false! !

!Brick methodsFor: 'event handling' stamp: 'tb 4/9/2003 16:14'!
handlesMouseStillDown: evt
	"Return true if the receiver wants to get repeated #mouseStillDown: messages between #mouseDown: and #mouseUp"
	self eventHandler ifNotNil: [^ self eventHandler handlesMouseStillDown: evt].
	^ self respondsTo: #mouseStillDown:
! !

!Brick methodsFor: 'event handling' stamp: 'tb 4/29/2003 21:59'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event, meaning the mouse just entered my bounds with a button pressed or laden with submorphs.  The default response is to let my eventHandler, if any, handle it, or else to do nothing."

	self eventHandler ifNotNil:
		[^ self eventHandler mouseEnterDragging: evt fromMorph: self].
! !

!Brick methodsFor: 'event handling' stamp: 'tb 3/14/2003 13:19'!
transformFrom: uberMorph 
	"Return a transform to be used to map coordinates in a morph above me into my childrens coordinates, or vice-versa. This is used to support scrolling, scaling, and/or rotation. This default implementation just returns my owner's transform or the identity transform if my owner is nil. 
	Note:  This method cannot be used to map into the receiver's coordinate system!!"

	(self == uberMorph or: [owner isNil]) ifTrue: [^IdentityTransform new].
	^owner transformFrom: uberMorph! !

!Brick methodsFor: 'event handling' stamp: 'tb 3/14/2003 14:05'!
transformFromWorld
	"Return a transform to map world coordinates into my local coordinates"

	^ self transformFrom: nil! !

!Brick methodsFor: 'initialization' stamp: 'tb 3/15/2003 12:49'!
defaultBounds
	^(30 @ 30) extent: (68 @ 70)! !

!Brick methodsFor: 'initialization' stamp: 'tb 4/9/2003 17:07'!
defaultColor
	"answer the default color/fill style for the receiver"
	"Morphs are blue - Bricks are RED!!"

	^ DefaultColor ifNil: [ Color green ] ifNotNil: [DefaultColor]! !

!Brick methodsFor: 'initialization' stamp: 'tb 3/17/2003 14:22'!
initialize
	"initialize the state of the receiver"
	
owner := nil.
	submorphs := EmptyArray.
	bounds := self defaultBounds.

	color _ self defaultColor.
	painters := Dictionary new.
	self addPainter: BackgroundPainter new.
! !

!Brick methodsFor: 'initialization' stamp: 'tb 2/24/2003 11:40'!
intoWorld: aWorld
	"The receiver has just appeared in a new world. Note:
		* aWorld can be nil (due to optimizations in other places)
		* owner is already set
		* owner's submorphs may not include receiver yet.
	Important: Keep this method fast - it is run whenever morphs are added."
	aWorld ifNil:[^self].
	self wantsSteps ifTrue:[aWorld startStepping: self].
	self submorphsDo:[:m| m intoWorld: aWorld].
! !

!Brick methodsFor: 'initialization' stamp: 'tb 2/24/2003 11:40'!
openInWorld
        "Add this morph to the world.  If in MVC, then provide a Morphic window for it."

        self couldOpenInMorphic
                ifTrue: [self openInWorld: self currentWorld]
                ifFalse: [self openInMVC]! !

!Brick methodsFor: 'initialization' stamp: 'tb 2/24/2003 11:40'!
openInWorld: aWorld
	"Add this morph to the requested World."
	(aWorld viewBox origin ~= (0@0) and: [self position = (0@0)]) ifTrue:
		[self position: aWorld viewBox origin].
	aWorld addMorph: self.
	aWorld startSteppingSubmorphsOf: self! !

!Brick methodsFor: 'initialization' stamp: 'tb 3/8/2003 18:18'!
outOfWorld: aWorld
	"The receiver has just appeared in a new world. Notes:
		* aWorld can be nil (due to optimizations in other places)
		* owner is still valid
	Important: Keep this method fast - it is run whenever morphs are removed."
	aWorld ifNil:[^self].
	"ar 1/31/2001: We could explicitly stop stepping the receiver here but for the sake of speed I'm for now relying on the lazy machinery in the world itself."
	"aWorld stopStepping: self."
	self submorphsDo:[:m| m outOfWorld: aWorld].
! !

!Brick methodsFor: 'user interface' stamp: 'tb 2/24/2003 11:23'!
defaultLabelForInspector
	"Answer the default label to be used for an Inspector window on the receiver."
	^ super printString truncateTo: 40! !

!Brick methodsFor: 'thumbnail' stamp: 'tb 3/8/2003 14:46'!
demandsThumbnailing
	"Answer whether the receiver, if in a thumbnailable parts bin, wants to be thumbnailed whether or not size requires it"

	^ false! !

!Brick methodsFor: 'thumbnail' stamp: 'tb 3/8/2003 14:46'!
permitsThumbnailing
	^ true! !

!Brick methodsFor: 'thumbnail' stamp: 'tb 3/8/2003 14:46'!
representativeNoTallerThan: maxHeight norWiderThan: maxWidth thumbnailHeight: thumbnailHeight
	"Return a morph representing the receiver but which is no taller than aHeight.  If the receiver is already small enough, just return it, else return a MorphThumbnail companioned to the receiver, enforcing the maxWidth.  If the receiver personally *demands* thumbnailing, do it even if there is no size-related reason to do it."

	self demandsThumbnailing ifFalse:
		[self permitsThumbnailing ifFalse: [^ self].
		(self fullBounds height <= maxHeight and: [self fullBounds width <= maxWidth]) ifTrue: [^ self]].

	^ MorphThumbnail new extent: maxWidth @ (thumbnailHeight min: self fullBounds height); morphRepresented: self! !

!Brick methodsFor: 'layout' stamp: 'tb 4/9/2003 21:10'!
acceptDroppingMorph: aMorph event: evt
	"This message is sent when a morph is dropped onto a morph that has agreed to accept the dropped morph by responding 'true' to the wantsDroppedMorph:Event: message. This default implementation just adds the given morph to the receiver."
	| layout |
	layout _ self layoutPolicy.
	layout ifNil:[^self addMorph: aMorph].
	self privateAddMorph: aMorph 
		atIndex: (layout indexForInserting: aMorph at: evt position in: self).! !

!Brick methodsFor: 'layout' stamp: 'tb 3/8/2003 13:11'!
doLayoutIn: newBounds 

	self submorphs do: 
	[:m |

		[
			self layoutChild: m in: newBounds
		] on: Error do: [ self halt ]
	]! !

!Brick methodsFor: 'layout' stamp: 'tb 3/9/2003 16:24'!
fullBounds
	"Return the bounding box of the receiver and all its children. Recompute the layout if necessary."
	^self privateFullBounds

	"^fullBounds 
		ifNil: [ fullBounds := self privateFullBounds ] 
		ifNotNil:[fullBounds]."
! !

!Brick methodsFor: 'layout' stamp: 'tb 3/4/2003 21:03'!
layoutChanged
	owner ifNotNil: [owner layoutChanged].
	"note: does not send #ownerChanged here - we'll do this when computing the new layout"! !

!Brick methodsFor: 'layout' stamp: 'tb 3/9/2003 19:59'!
layoutChild: aMorph in: newBounds 

	"The key is for the bounds of this morph to be the old bounds of the morph and newBounds is what bounds will be set to soon"

	| oldBounds   x y r b myNewBounds aPoint |

	"self fullBounds."

	oldBounds := self bounds.
	aPoint := newBounds extent - oldBounds extent.
	
	x := aMorph left.
	y := aMorph top.
	r := aMorph right.
	b := aMorph bottom.

	aMorph hResizing == #rigid 
		ifTrue: 
		[
			aMorph rightFixed 
				ifTrue: 
				[
					aMorph leftFixed
						ifTrue: "-|-|-" 
						[
							"Deny window resize in horizontal window direction?"
						]
						ifFalse: "s|-|-"
						[
							x := x + (aPoint x). r := r + (aPoint x) 
						]
				] 
				ifFalse: 
				[ 
					aMorph leftFixed
						ifTrue: "-|-|s"
						[
							"Do nothing - no resize and no move"
						]
						ifFalse: "s|-|s"
						[
							"Keep midpoints aligned proportionally"
							|  newCenter |
							newCenter := (newBounds width * aMorph hCenterFraction) + newBounds left.
							x := newCenter - (aMorph width/2).
							r := x + aMorph width.
						]
				]
		]
		ifFalse:
		[
			aMorph leftFixed 
				ifTrue:
				[
					aMorph rightFixed 
						ifTrue:  "-|s|- simply grow the component"
						[ 
							r := r + (aPoint x)
						]
						ifFalse: "-|s|s split growth between springs"
						[
							r := (newBounds left + (newBounds width * aMorph rightFraction) ) rounded
						] 
				]
				ifFalse:
				[
					aMorph rightFixed
						ifTrue: "s|s|-"
						[
							x := newBounds left + (newBounds width * aMorph leftFraction). 
						] 
						ifFalse: "s|s|s" 
						[
							x := newBounds left + (newBounds width * aMorph leftFraction). 
							r := newBounds left + (newBounds width * aMorph rightFraction)
						]
				]
		].

		aMorph vResizing == #rigid 
		ifTrue: 
		[
			aMorph bottomFixed 
				ifTrue: 
				[
					aMorph topFixed
						ifTrue: "-|-|-" 
						[
							"Deny window resize in vertical window direction?"
						]
						ifFalse: "s|-|-"
						[
							y := y + (aPoint y). b := b + (aPoint y) 
						]
				] 
				ifFalse: 
				[ 
					aMorph topFixed
						ifTrue: "-|-|s"
						[
							"Do nothing - no resize and no move"
						]
						ifFalse: "s|-|s"
						[
							"Keep midpoints aligned proportionally"
							|  newCenter |
							newCenter := (newBounds height * aMorph vCenterFraction) + newBounds top.
							y := newCenter - (aMorph height/2).
							b := y + aMorph height.
						]
				]
		]
		ifFalse:
		[
			aMorph topFixed 
				ifTrue:
				[
					aMorph bottomFixed 
						ifTrue: "-|s|- simply grow the component"
						[ 
							b := b + (aPoint y)
						] 
						ifFalse: "-|s|s split growth between springs"
						[
							b := (newBounds top + (newBounds height * aMorph bottomFraction) )
						] 
				]
				ifFalse:
				[
					aMorph bottomFixed
						ifTrue: "s|s|-"
						[
							y := newBounds top + (newBounds height * aMorph topFraction). 
						] 
						ifFalse: "s|s|s" 
						[
							y := newBounds top + (newBounds height * aMorph topFraction). 
							b := newBounds top + (newBounds height * aMorph bottomFraction)
						]
				]
		].

		myNewBounds := (((x rounded)@(y rounded)) corner: ((r rounded)@(b rounded))).

		aMorph bounds: myNewBounds.


! !

!Brick methodsFor: 'layout' stamp: 'tb 3/9/2003 18:15'!
layoutInBounds: cellBounds

	"do nothing"! !

!Brick methodsFor: 'layout' stamp: 'tb 3/8/2003 16:37'!
minExtent
	"Layout specific. Return the minimum size the receiver can be represented in.
	Implementation note: When this message is sent from an owner trying to lay out its children it will traverse down the morph tree and recompute the minimal arrangement of the morphs based on which the minimal extent is returned. When a morph with some layout strategy is encountered, the morph will ask its strategy to compute the new arrangement. However, since the final size given to the receiver is unknown at the point of the query, the assumption is made that the current bounds of the receiver are the base on which the layout should be computed. This scheme prevents strange layout changes when for instance, a table is contained in another table. Unless the inner table has been resized manually (which means its bounds are already enlarged) the arrangement of the inner table will not change here. Thus the entire layout computation is basically an iterative process which may have different results depending on the incremental changes applied."

	| layout minExtent extra hFit vFit |
	hFit := self hResizing.
	vFit := self vResizing.
	(hFit == #spaceFill or: [vFit == #spaceFill]) 
		ifFalse: 
			["The receiver will not adjust to parents layout by growing or shrinking,
		which means that an accurate layout defines the minimum size."

			^self fullBounds extent].

	"An exception -- a receiver with #shrinkWrap constraints but no children is being treated #rigid (the equivalent to a #spaceFill receiver in a non-layouting owner)"
	self hasSubmorphs 
		ifFalse: 
			[hFit == #shrinkWrap ifTrue: [hFit := #rigid].
			vFit == #shrinkWrap ifTrue: [vFit := #rigid]].
	layout := self layoutPolicy.
	layout isNil 
		ifTrue: [minExtent := 0 @ 0]
		ifFalse: [minExtent := layout minExtentOf: self in: self layoutBounds].
	hFit == #rigid 
		ifTrue: [minExtent := self fullBounds extent x @ minExtent y]
		ifFalse: 
			[extra := self bounds width - self layoutBounds width.
			minExtent := (minExtent x + extra) @ minExtent y].
	minExtent := vFit == #rigid 
				ifTrue: [minExtent x @ self fullBounds extent y]
				ifFalse: 
					[extra := self bounds height - self layoutBounds height.
					minExtent x @ (minExtent y + extra)].
	minExtent := minExtent max: self minWidth @ self minHeight.
	^minExtent! !

!Brick methodsFor: 'layout' stamp: 'tb 3/8/2003 18:18'!
minHeight
	"answer the receiver's minHeight"
	^ self
		valueOfProperty: #minHeight
		ifAbsent: [2]! !

!Brick methodsFor: 'layout' stamp: 'tb 3/8/2003 18:18'!
minWidth
	"answer the receiver's minWidth"
	^ self
		valueOfProperty: #minWidth
		ifAbsent: [2]! !

!Brick methodsFor: 'layout' stamp: 'tb 3/17/2003 14:14'!
openLayoutControl

	(LayoutControlBrick on: self) openInWorld
! !

!Brick methodsFor: 'layout' stamp: 'tb 3/4/2003 19:35'!
privateFullBounds
	"Private. Compute the actual full bounds of the receiver"

	| box |
	submorphs isEmpty ifTrue: [^self outerBounds].
	box := self outerBounds copy.
	box := box quickMerge: (self clipSubmorphs 
						ifTrue: [self submorphBounds intersect: self clippingBounds]
						ifFalse: [self submorphBounds]).
	^box origin asIntegerPoint corner: box corner asIntegerPoint! !

!Brick methodsFor: 'layout' stamp: 'tb 3/8/2003 12:02'!
submorphBounds
	"Private. Compute the actual full bounds of the receiver"
	| box subBox |
	submorphs do: [:m | 
		(m visible) ifTrue: [
			subBox _ m fullBounds.
			box 
				ifNil:[box _ subBox copy]
				ifNotNil:[box _ box quickMerge: subBox]]].
	box ifNil:[^self bounds]. "e.g., having submorphs but not visible"
	^ box origin asIntegerPoint corner: box corner asIntegerPoint
! !

!Brick methodsFor: 'layout' stamp: 'tb 3/9/2003 17:24'!
updateLayoutFrame

	! !

!Brick methodsFor: 'viewer' stamp: 'tb 3/4/2003 19:35'!
externalName
	^ self knownName ifNil: [self innocuousName]! !

!Brick methodsFor: 'caching' stamp: 'tb 3/9/2003 16:25'!
fullReleaseCachedState
	"Release the cached state of the receiver and its full submorph tree."

	self allMorphsDo: [:m | m releaseCachedState].
! !

!Brick methodsFor: 'caching' stamp: 'tb 3/17/2003 17:56'!
releaseCachedState

	"Release any state that can be recomputed on demand, such as the pixel values for a color gradient or the editor state for a TextMorph. This method may be called to save space when a morph becomes inaccessible. Implementations of this method should do 'super releaseCachedState'."

	self paintersDo: [:ea | ea == self ifFalse: [ea releaseCachedState]].! !

!Brick methodsFor: 'accessing - properties' stamp: 'tb 2/24/2003 11:40'!
hasProperty: aSymbol 
	"Answer whether the receiver has the property named aSymbol"
	self hasExtension
		ifFalse: [^ false].
	^ self extension hasProperty: aSymbol! !

!Brick methodsFor: 'accessing - properties' stamp: 'tb 2/24/2003 19:32'!
removeProperty: aSymbol 
	"removes the property named aSymbol if it exists"
	self hasExtension
		ifFalse: [^ self].
	self extension removeProperty: aSymbol! !

!Brick methodsFor: 'accessing - properties' stamp: 'tb 3/4/2003 09:46'!
setProperty: aSymbol toValue: anObject 
	"change the receiver's property named aSymbol to anObject"
	anObject
		ifNil: [^ self removeProperty: aSymbol].
	self assureExtension setProperty: aSymbol toValue: anObject! !

!Brick methodsFor: 'accessing - properties' stamp: 'tb 2/24/2003 11:40'!
valueOfProperty: aSymbol 
	"answer the value of the receiver's property named aSymbol"
	^ self hasExtension
		ifTrue: [self extension valueOfProperty: aSymbol]! !

!Brick methodsFor: 'accessing - properties' stamp: 'tb 2/24/2003 11:40'!
valueOfProperty: aSymbol ifAbsent: aBlock 
	"if the receiver possesses a property of the given name, answer  
	its value. If not then evaluate aBlock and answer the result of  
	this block evaluation"
	^ self hasExtension
		ifTrue: [self extension valueOfProperty: aSymbol ifAbsent: aBlock]
		ifFalse: [aBlock value]! !

!Brick methodsFor: 'geometry eToy' stamp: 'tb 3/6/2003 14:16'!
heading
	"Return the receiver's heading (in eToy terms)"
	owner ifNil: [^ self forwardDirection].
	^ self forwardDirection + owner degreesOfFlex! !

!Brick methodsFor: 'geometry eToy' stamp: 'tb 3/4/2003 09:46'!
referencePosition
	"Return the current reference position of the receiver"
	| box |
	box _ self bounds.
	^box origin + (self rotationCenter * box extent).
! !

!Brick methodsFor: 'geometry eToy' stamp: 'tb 3/4/2003 09:46'!
referencePosition: aPosition
	"Move the receiver to match its reference position with aPosition"
	| newPos intPos |
	newPos _ self position + (aPosition - self referencePosition).
	intPos _ newPos asIntegerPoint.
	newPos = intPos 
		ifTrue:[self position: intPos]
		ifFalse:[self position: newPos].! !

!Brick methodsFor: 'geometry eToy' stamp: 'tb 3/6/2003 14:16'!
referencePositionInWorld

	^ self pointInWorld: self referencePosition
! !

!Brick methodsFor: 'geometry eToy' stamp: 'tb 3/4/2003 09:46'!
rotationCenter
	"Return the rotation center of the receiver. The rotation center defines the relative offset inside the receiver's bounds for locating the reference position."
	^self valueOfProperty: #rotationCenter ifAbsent:[0.5@0.5]
! !

!Brick methodsFor: 'geometry eToy' stamp: 'tb 3/9/2003 00:24'!
x
	"Return my horizontal position relative to the cartesian origin of a relevant playfield"

	| aPlayfield |
	aPlayfield := self referencePlayfield.
	^aPlayfield isNil 
		ifTrue: [self referencePosition x]
		ifFalse: [self referencePosition x - aPlayfield cartesianOrigin x]! !

!Brick methodsFor: 'geometry eToy' stamp: 'tb 3/18/2003 16:06'!
y
	"Return my vertical position relative to the cartesian origin of the playfield or the world. Note that larger y values are closer to the top of the screen."

	| w aPlayfield |
	w := self world.
	w ifNil: [^bounds top].
	aPlayfield := self referencePlayfield.
	^aPlayfield isNil 
		ifTrue: [w cartesianOrigin y - self referencePosition y]
		ifFalse: [aPlayfield cartesianOrigin y - self referencePosition y]! !

!Brick methodsFor: 'card in a stack' stamp: 'tb 3/4/2003 09:46'!
holdsSeparateDataForEachInstance
	"Answer whether the receiver is currently behaving as a 'background field', i.e., whether it is marked as shared (viz. occurring on the background of a stack) *and* is marked as holding separate data for each instance"

	^ self isShared and: [self hasProperty: #holdsSeparateDataForEachInstance]! !

!Brick methodsFor: 'card in a stack' stamp: 'tb 3/6/2003 14:04'!
isStackBackground
	"Answer whether the receiver serves as a background of a stack"

	^ ((owner isKindOf: StackMorph) and: [owner currentPage == self]) or:
		[self hasProperty: #stackBackground]

	"This odd property-based check is because when a paste-up-morph is not the *current* background of a stack, it is maddeningly ownerlyess"! !

!Brick methodsFor: 'classification' stamp: 'tb 2/24/2003 11:40'!
isFlapOrTab
	^self isFlap or:[self isFlapTab]! !

!Brick methodsFor: 'classification' stamp: 'tb 2/24/2003 11:40'!
isFlapTab
	^false! !

!Brick methodsFor: 'classification' stamp: 'tb 3/4/2003 19:35'!
isFlexMorph

	^ false
! !

!Brick methodsFor: 'classification' stamp: 'tb 3/8/2003 11:56'!
isHandMorph

	^ false! !

!Brick methodsFor: 'classification' stamp: 'tb 3/8/2003 12:02'!
isPlayfieldLike
	^ false! !

!Brick methodsFor: 'classification' stamp: 'tb 3/4/2003 09:46'!
isRenderer
	"A *renderer* morph transforms the appearance of its submorph in some manner. For example, it might supply a drop shadow or scale and rotate the morph it encases. Answer true if this morph acts as a renderer. This default implementation returns false."
	"Details: A renderer is assumed to have a single submorph. Renderers may be nested to concatenate their transformations. It is useful to be able to find the outer-most renderer. This can be done by ascending the owner chain from the rendered morph. To find the morph being rendered, one can descend through the (singleton) submorph lists of the renderer chain until a non-renderer is encountered."

	^ false
! !

!Brick methodsFor: 'classification' stamp: 'tb 3/4/2003 09:46'!
isSyntaxMorph
	^false! !

!Brick methodsFor: 'classification' stamp: 'tb 3/4/2003 19:35'!
isTextMorph
	^false! !

!Brick methodsFor: 'classification' stamp: 'tb 2/24/2003 11:41'!
isWorldMorph

	^ false! !

!Brick methodsFor: 'classification' stamp: 'tb 3/8/2003 12:02'!
isWorldOrHandMorph

	^ self isWorldMorph or: [self isHandMorph]! !

!Brick methodsFor: 'parts bin' stamp: 'tb 3/4/2003 19:35'!
isPartsBin
	^ false! !

!Brick methodsFor: 'parts bin' stamp: 'tb 2/24/2003 11:40'!
isPartsDonor
	"answer whether the receiver is PartsDonor"
	self hasExtension
		ifFalse: [^ false].
	^ self extension isPartsDonor! !

!Brick methodsFor: 'parts bin' stamp: 'tb 3/4/2003 09:46'!
isPartsDonor: aBoolean 
	"change the receiver's isPartDonor property"
	(self hasExtension not
			and: [aBoolean not])
		ifTrue: [^ self].
	self assureExtension isPartsDonor: aBoolean! !

!Brick methodsFor: 'rotate scale and flex' stamp: 'tb 3/4/2003 09:46'!
keepsTransform
	"Return true if the receiver will keep it's transform while being grabbed by a hand."
	^false! !

!Brick methodsFor: 'WiW support' stamp: 'tb 3/4/2003 19:35'!
morphicLayerNumber

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^(owner isNil or: [owner isWorldMorph]) ifTrue: [
		self valueOfProperty: #morphicLayerNumber ifAbsent: [100]
	] ifFalse: [
		owner morphicLayerNumber
	].

	"leave lots of room for special things"! !

!Brick methodsFor: 'WiW support' stamp: 'tb 2/24/2003 11:40'!
morphicLayerNumberWithin: anOwner

	"helpful for insuring some morphs always appear in front of or behind others.
	smaller numbers are in front"

	^(owner isNil or: [owner isWorldMorph or: [anOwner == owner]]) ifTrue: [
		self valueOfProperty: #morphicLayerNumber ifAbsent: [100]
	] ifFalse: [
		owner morphicLayerNumber
	].

	"leave lots of room for special things"! !

!Brick methodsFor: 'objects from disk' stamp: 'tb 3/17/2003 12:54'!
objectForDataStream: refStrm 
	"I am being written out on an object file"

	| dp |
	self sqkPage ifNotNil: 
			[refStrm rootObject == self | (refStrm rootObject == self sqkPage) 
				ifFalse: 
					[self url notEmpty 
						ifTrue: 
							[dp := self sqkPage copyForSaving.	"be careful touching this object!!"
							refStrm replace: self with: dp.
							^dp]]].
	self prepareToBeSaved.	"Amen"
	^self! !

!Brick methodsFor: 'objects from disk' stamp: 'tb 3/17/2003 22:52'!
saveAsMethod
	"Ask the user for a filename and save myself on a SmartReferenceStream file.  Writes out the version and class structure.  The file is fileIn-able.  UniClasses will be filed out."

	| className aClass prompt aMethodName |

	className := 'Window'.
	prompt := 'Class Name?'.
	aClass := nil.

	[aClass == nil] whileTrue: 
	[
		className := FillInTheBlank request: prompt
						initialAnswer: className.

		(className isNil or: [className size = 0]) ifTrue: [^self].

		aClass := Smalltalk at: (className asSymbol) ifAbsent: [ nil ].
		prompt := 'Class Name? (''', className, ''' was not found)'.
	].
	aMethodName := 'new', self class name, (self identityHash asString).

	aMethodName := FillInTheBlank request: ('Method name on class ', aClass name, '?')
						initialAnswer: aMethodName.

	^self saveAsMethod: aMethodName onClass: aClass.! !

!Brick methodsFor: 'objects from disk' stamp: 'tb 3/18/2003 00:22'!
saveAsMethod: methodName onClass: aClass

	| stream codeStream |
	self allMorphsDo: [:m | m prepareToBeSaved].
	
	codeStream := RWBinaryOrTextStream on: (ByteArray new).
	codeStream fileOutClass: nil andObject: self.	"Puts UniClass definitions out anyway"

	stream := RWBinaryOrTextStream on: (String new).

	stream nextPutAll: methodName; cr; tab. 
	stream nextPutAll: '| data | '; cr; tab; nextPutAll: 'data := '.
	(codeStream contents printOn: stream). 
	stream nextPutAll: '.'; cr; tab.
	stream nextPutAll: '^Brick fromStream: (RWBinaryOrTextStream on: data from: 0 to: (data size))'.
	
	aClass class compile: stream contents
		classified: 'instance creation' notifying: nil.! !

!Brick methodsFor: 'objects from disk' stamp: 'tb 3/17/2003 12:54'!
saveOnFile
	"Ask the user for a filename and save myself on a SmartReferenceStream file.  Writes out the version and class structure.  The file is fileIn-able.  UniClasses will be filed out."

	| aFileName fileStream ok |
	aFileName := ('my ' , self class name) asFileName.	"do better?"
	aFileName := FillInTheBlank 
				request: 'File name? (".morph" will be added to end)'
				initialAnswer: aFileName.
	aFileName isEmpty ifTrue: [^self beep].
	self allMorphsDo: [:m | m prepareToBeSaved].
	ok := aFileName endsWith: '.morph'.	"don't double them"
	ok := ok | (aFileName endsWith: '.sp').
	ok ifFalse: [aFileName := aFileName , '.morph'].
	fileStream := FileStream newFileNamed: aFileName.
	fileStream fileOutClass: nil andObject: self	"Puts UniClass definitions out anyway"! !

!Brick methodsFor: 'objects from disk' stamp: 'tb 3/17/2003 12:54'!
storeDataOn: aDataStream
	"Let all Morphs be written out.  All owners are weak references.  They only go out if the owner is in the tree being written."
	| cntInstVars cntIndexedVars ti localInstVars |

	"block my owner unless he is written out by someone else"
	cntInstVars _ self class instSize.
	cntIndexedVars _ self basicSize.
	localInstVars _ Morph instVarNames.
	ti _ 2.  
	((localInstVars at: ti) = 'owner') & (Morph superclass == Object) ifFalse:
			[self error: 'this method is out of date'].
	aDataStream
		beginInstance: self class
		size: cntInstVars + cntIndexedVars.
	1 to: ti-1 do:
		[:i | aDataStream nextPut: (self instVarAt: i)].
	aDataStream nextPutWeak: owner.	"owner only written if in our tree"
	ti+1 to: cntInstVars do:
		[:i | aDataStream nextPut: (self instVarAt: i)].
	1 to: cntIndexedVars do:
		[:i | aDataStream nextPut: (self basicAt: i)]! !

!Brick methodsFor: 'fileIn/out' stamp: 'tb 3/17/2003 15:30'!
prepareToBeSaved
	"Prepare this morph to be saved to disk. Subclasses should nil out any instance variables that holds state that should not be saved, such as cached Forms. Note that this operation may take more drastic measures than releaseCachedState; for example, it might discard the transcript of an interactive chat session."

	self releaseCachedState.
! !

!Brick methodsFor: 'printing' stamp: 'tb 2/24/2003 11:23'!
printOn: aStream 
	| aName |
	super printOn: aStream.
	(aName := self knownName) notNil 
		ifTrue: [aStream nextPutAll: '<' , aName , '>'].
	aStream nextPutAll: '('.
	aStream
		print: self identityHash;
		nextPutAll: ')'! !

!Brick methodsFor: 'private' stamp: 'tb 3/8/2003 12:02'!
privateAddMorph: aMorph atIndex: index

	| oldIndex myWorld itsWorld |
	((index >= 1) and: [index <= (submorphs size + 1)])
		ifFalse: [^ self error: 'index out of range'].
	myWorld _ self world.
	(aMorph owner == self and: [(oldIndex _ submorphs indexOf: aMorph) > 0])
		ifTrue:
		["aMorph's position changes within in the submorph chain"
		oldIndex < index
			ifTrue:
			["moving aMorph to back"
			submorphs replaceFrom: oldIndex to: index-2 with: submorphs startingAt: oldIndex+1.
			submorphs at: index-1 put: aMorph]
			ifFalse:
			["moving aMorph to front"
			oldIndex-1 to: index by: -1 do:[:i|
				submorphs at: i+1 put: (submorphs at: i)].
			submorphs at: index put: aMorph]]
		ifFalse:
		["adding a new morph"
		aMorph owner ifNotNil:
			[itsWorld _ aMorph world.
			itsWorld == myWorld ifFalse: [aMorph outOfWorld: itsWorld].
			aMorph owner privateRemoveMorph: aMorph].
		aMorph privateOwner: self.
		submorphs _ submorphs copyReplaceFrom: index to: index-1 with: (Array with: aMorph).
		itsWorld == myWorld ifFalse:[aMorph intoWorld: myWorld]].
	self layoutChanged.
	myWorld ifNotNil: [self addedOrRemovedSubmorph: aMorph].! !

!Brick methodsFor: 'private' stamp: 'tb 3/15/2003 11:56'!
privateBounds: boundsRect
	"Private!! Use position: and/or extent: instead."

	bounds _ boundsRect.! !

!Brick methodsFor: 'private' stamp: 'tb 3/8/2003 18:13'!
privateColor: aColor

	color _ aColor.
! !

!Brick methodsFor: 'private' stamp: 'tb 3/4/2003 09:46'!
privateFullMoveBy: delta
	"Private!! Relocate me and all of my subMorphs by recursion. Subclasses that implement different coordinate systems may override this method."

	self privateMoveBy: delta.
	1 to: submorphs size do: [:i |
		(submorphs at: i) privateFullMoveBy: delta].
	owner ifNotNil:[
		owner isTextMorph ifTrue:[owner adjustTextAnchor: self]].! !

!Brick methodsFor: 'private' stamp: 'tb 4/9/2003 14:56'!
privateMoveBy: delta 
	"Private!! Use 'position:' instead."
	| |
	self hasExtension
		ifTrue: [self extension player
				ifNotNil: ["Most cases eliminated fast by above test"
					self getPenDown
						ifTrue: ["If this is a costume for a player with its 
							pen down, draw a line."
							self moveWithPenDownBy: delta]]].
	bounds _ bounds translateBy: delta.
"
	fill _ self fillStyle.
	fill isOrientedFill
		ifTrue: [fill origin: fill origin + delta]"! !

!Brick methodsFor: 'private' stamp: 'tb 2/24/2003 11:40'!
privateOwner: aMorph
	"Private!! Should only be used by methods that maintain the ower/submorph invariant."

	owner _ aMorph.! !

!Brick methodsFor: 'private' stamp: 'tb 3/14/2003 13:19'!
privateRemoveMorph: aMorph
	"Private!! Should only be used by methods that maintain the ower/submorph invariant."

	self isInWorld ifTrue: [self addedOrRemovedSubmorph: aMorph].
	submorphs _ submorphs copyWithout: aMorph.
	self layoutChanged.
! !

!Brick methodsFor: 'miscellaneous' stamp: 'tb 3/9/2003 19:52'!
setExtentFromHalo: anExtent
	"The user has dragged the grow box such that the receiver's extent would be anExtent.  Do what's needed"

	self extent: anExtent.
	self updateLayoutProperties.
! !

!Brick methodsFor: 'stepping and presenter' stamp: 'tb 2/24/2003 11:50'!
step
	"Do some periodic activity. Use startStepping/stopStepping to start and stop getting sent this message. The time between steps is specified by this morph's answer to the stepTime message.  The generic version dispatches control to the player, if any.  The nasty circumlocation about owner's transformation is necessitated by the flexing problem that the player remains in the properties dictionary both of the flex and the real morph.  In the current architecture, only the top renderer's pointer to the player should actually be honored for the purpose of firing."
! !

!Brick methodsFor: 'stepping and presenter' stamp: 'tb 3/8/2003 18:18'!
stopSteppingSelector: aSelector
	"Stop getting sent the given message."
	| w |
	w _ self world.
	w ifNotNil: [w stopStepping: self selector: aSelector].
! !

!Brick methodsFor: 'genie-processing' stamp: 'tb 4/12/2003 15:45'!
allowsGestureStart: anEvent
	^ (anEvent hand allowsGestureStart: anEvent target: self) and:
		[self handlesGestureStart: anEvent]! !

!Brick methodsFor: 'genie-processing' stamp: 'tb 4/15/2003 10:47'!
defaultGestureDictionaryOrName
	"This method returns the default gesture dictionary name for the instances 
	of a Morph class. (It's also possible to directly return a dictionary but it's much
	more flexible to return the name).
	This generic implementation returns the class name if there is a dictionary 
	exported under this name. If not, it tries the name of the superclass, etc."

	| class |
	self gestureHandler ~~ self 
		ifTrue: [^ self gestureHandler defaultGestureDictionaryOrName].

	class _ self class.
	[class ~= Brick and: 
		[(CRDictionary exportedName: class name asSymbol) isNil]] whileTrue:
			[class _ class superclass].
	
	^ (CRDictionary exportedName: class name asSymbol) isNil
		ifTrue: [self class name asSymbol]
		ifFalse: [class name asSymbol].! !

!Brick methodsFor: 'genie-processing' stamp: 'tb 4/15/2003 10:45'!
gestureDictionary
	"This method is invoked to determine the gesture dictionary of the Morph.
	Usually, gesture dictionaries are identified by (exported) names and so this method just
	converts names to dictionaries if necessary"

	^ (self gestureDictionaryOrName isKindOf: CRDictionary)
		ifTrue: [self gestureDictionaryOrName]
		ifFalse: [CRDictionary exportedName: self gestureDictionaryOrName].! !

!Brick methodsFor: 'genie-processing' stamp: 'tb 4/15/2003 10:45'!
gestureDictionaryOrName
	"If there is an GestureHandler or an EventHandler assigned to the object, 
	return the gesture dictionary or name definied there. 
	If not, return the default dictionary or name."

	(self gestureHandler ~~ self)
		ifTrue: [^ self gestureHandler gestureDictionaryOrName].

	^self 
		valueOfProperty: #gestureDictionaryOrName
		ifAbsent:[self defaultGestureDictionaryOrName]! !

!Brick methodsFor: 'genie-processing' stamp: 'tb 4/15/2003 10:45'!
gestureHandler
	"Usually a morph handles gestures itself or lets an associated EventHandler do it.
	However, sometimes a morph wants to let another morph handle the gesture for it.
	Example: If a TextMorph is part of a pane (like PluggableTextMorph), 
	the PluggableTextMorph handles also the events for the TextMorph."

	^ self! !

!Brick methodsFor: 'genie-menu' stamp: 'tb 4/15/2003 10:45'!
addGenieMenuItems: aMenu hand: aHandMorph
	"If the receiver wishes the Genie menu items, add a line to the menu and then those Genie items, else do nothing"

	aMenu addLine.
	aMenu add: 'change gesture dictionary' action: #changeGestureDictionary.
	self gestureDictionary ifNotNil:
		[aMenu add: 'inspect gesture dictionary' action: #inspectGestureDictionary.
		self hasNotExportedGestureDictionary ifFalse: 
			[aMenu add: 'make own copy of gesture dictionary' 
				action: #makeOwnCopyOfGestureDictionary.
			aMenu add: 'make own sub-gesture dictionary' 
				action: #makeOwnSubGestureDictionary]].! !


!Brick class methodsFor: 'debugging' stamp: 'tb 2/13/2003 00:45'!
buildSelectorFaults

	Morph methodDictionary keys do: [:sel |
		((Object methodDictionary includesKey: sel) and: 
			[(self methodDictionary includesKey: sel) not]) ifTrue:
		[
			| src header |
			header := Morph methodHeaderFor: sel.
			src := (header, ' self cloneSelector: ', (sel printString), '. ^self ', header).
			self compile: src classified: 'object-overrides'.
		]
	]

			! !

!Brick class methodsFor: 'instance creation' stamp: 'tb 3/18/2003 00:25'!
fromStream: aStream

"Reconstitute an Assembly from the file, presumed to be represent a Brick or Morph saved
	via the SmartRefStream mechanism, and open it in an appropriate Morphic world"

 	| morphOrList |
	aStream reset.

	morphOrList _ aStream fileInObjectAndCode.

	(morphOrList isKindOf: SqueakPage) ifTrue: [morphOrList _ morphOrList contentsMorph].

	Smalltalk isMorphic
		ifTrue: [ActiveWorld addMorphsAndModel: morphOrList]
		ifFalse:
		[
			morphOrList isMorph 
			ifFalse: 
			[
				self inform: 'Can only load a single morph into an mvc project via this mechanism.'
			].
			morphOrList openInWorld
		].

	^morphOrList! !

!Brick class methodsFor: 'instance creation' stamp: 'tb 2/12/2003 22:40'!
new

	^ super new initialize! !

!Brick class methodsFor: 'instance creation' stamp: 'tb 2/12/2003 22:42'!
newBounds: bounds

	^ self new privateBounds: bounds! !

!Brick class methodsFor: 'instance creation' stamp: 'tb 2/12/2003 22:43'!
newBounds: bounds color: color

	^ (self new privateBounds: bounds) privateColor: color
! !

!Brick class methodsFor: 'instance creation' stamp: 'tb 2/12/2003 22:43'!
newSticky

	^ self new beSticky! !

!Brick class methodsFor: 'class initialization' stamp: 'tb 3/11/2003 16:44'!
initialize

	EmptyArray := #().
	EventDispatchers := Dictionary new.
	self buildSelectorFaults! !


!BrickEventDispatcher methodsFor: 'morph navigation' stamp: 'tb 3/14/2003 14:03'!
activeSubMorphAtPoint: aPoint in: aMorph event: anEvent

	"drill down to find the morph that should receive the click"

	| submorph |
	submorph := aMorph submorphs detect: [:m | m visible and: [m containsPoint: aPoint event: anEvent]] 
			ifNone:[aMorph].

	^submorph == aMorph 
		ifTrue: [submorph] 
		ifFalse: [self activeSubMorphAtPoint: aPoint in: submorph event: anEvent].! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 4/10/2003 14:14'!
dispatchDropEvent: anEvent with: aMorph

	| brick | 

	aMorph world ifNil: [^self].
	(stack isNil or: [stack isEmpty]) ifTrue: [^self].
	
	brick := stack last.
	(brick isKindOf: Brick) ifTrue:
	[
		(anEvent isKindOf: DropFilesEvent) ifTrue:
		[
			(brick respondsTo: #mouseDropFiles:) ifTrue:
			[
				brick mouseDropFiles: anEvent.
				"Transcript show: ((anEvent asString, ' ',(brick asString),' accepted: ', (anEvent wasHandled asString))); cr."
			]
		]
		ifFalse:
		[
			(anEvent contents last isKindOf: DragPainterBrick)
			ifTrue:
			[
				| holder |
				holder := anEvent contents last.
				brick removePainter: RolloverBorderPainter.

				(brick isKindOf: DragPainterBrick) ifFalse: 
				[
					holder removesPainter 
						ifTrue: [ brick removePainter: (holder painter) ]
						ifFalse: [ brick addPainter: (holder painter)].
				]
			]
			ifFalse:
			[
				(brick respondsTo: #mouseDrop:) ifTrue:
				[
					brick mouseDrop: anEvent.
					"Transcript show: ((anEvent asString, ' ',(brick asString),' accepted: ', (anEvent wasHandled))); cr."
					anEvent wasHandled ifTrue: [^self].
				]
			]
		]		
	].

	(anEvent contents last isKindOf: DragPainterBrick) ifTrue: 
	[
		anEvent contents last delete.
	].! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 3/23/2003 14:52'!
dispatchEvent: anEvent with: aMorph

	| |

	((anEvent == lastEvent) or:[aMorph isNil or: [anEvent isNil]]) ifTrue: [^self].

	"Generate a drop event for morphs - total hack based on the hand morph's submorphs changing"
	(lastHeld notNil and: [(lastHeld isEmpty not) and: [anEvent hand submorphs isEmpty]]) 
	ifTrue: 
	[
		self dispatchDropEvent: (DropEvent new setPosition: anEvent cursorPoint contents: lastHeld hand: anEvent hand) with: aMorph.
	].

	(anEvent isMouse) ifTrue: 
	[ 
		self dispatchMouseEvent: anEvent with: aMorph.
		lastMouseEvent := anEvent.
	].

	(anEvent isKeyboard) ifTrue:
	[
		"self dispatchKeyEvent: anEvent with: keyboardFocus."
		self dispatchMouseEvent: lastMouseEvent with: aMorph.
	].

	(anEvent isDropEvent) ifTrue:
	[
		self dispatchDropEvent: anEvent with: aMorph.
	].

	lastEvent := anEvent.
	lastHeld := anEvent hand submorphs.! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 3/23/2003 23:32'!
dispatchKeyEvent: anEvent with: aMorph

	(aMorph isKindOf: Brick) ifTrue:
	[
		anEvent isKeyUp 
			ifTrue:[^self tryToPerform: #keyUp: onBrick: aMorph withEvent: anEvent].

		anEvent isKeyDown 
			ifTrue:[^self tryToPerform: #keyDown: onBrick: aMorph withEvent: anEvent].

		anEvent isKeystroke 
			ifTrue:[^self tryToPerform: #keyStroke: onBrick: aMorph withEvent: anEvent].

	].

	(aMorph isKindOf: Morph) ifTrue:
	[
		^self tryToPerform: #handleFocusEvent: onMorph: aMorph withEvent: anEvent.		
	].

! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 3/24/2003 23:43'!
dispatchMouseDown: anEvent with: aMorph

	"for now - pass on events for halos"
	anEvent blueButtonPressed ifTrue: 
	[
		aMorph addHalo: anEvent.
		anEvent wasHandled: true.
		^self
	].

	"make yellowButton the grab button"
	anEvent yellowButtonPressed ifTrue: 
	[
		anEvent hand grabMorph: aMorph. 
		anEvent wasHandled: true. 
		^self
	].

	(anEvent hand submorphs notNil and: [anEvent hand submorphs isEmpty not]) ifTrue:
	[
		^anEvent hand dropMorphs.
	].

	mouseDownMorph := aMorph.

	(aMorph isKindOf: Brick) ifTrue:
	[	
		^self tryToPerform: #mouseDown: onBrick: aMorph withEvent: anEvent.
	].

	(aMorph isKindOf: Morph) ifTrue: 
	[
		^self tryToPerform: #handleFocusEvent: onMorph: aMorph withEvent: anEvent.
	].
	! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 3/23/2003 23:53'!
dispatchMouseEnterEvents: anEvent with: aMorph

	| |

	(stack notNil and: [stack last == aMorph]) ifTrue: [^self].
	stack := WeakArray withAll: (aMorph allOwners reversed copyWith: aMorph).
	
	anEvent isDraggingEvent
	ifTrue:
	[
		(aMorph isKindOf: Brick)
		ifTrue:
		[
			| held |
			held := anEvent contents.
			self log: ((anEvent asMouseEnter asString),' dragging: ',(held asString),' ',(aMorph asString)).

			((held isEmpty not) and: [(held last isKindOf: DragWrapperBrick) and: [(aMorph isKindOf: DragWrapperBrick) not and:[(aMorph == held last formerOwner) not and: [(aMorph submorphs detect: [:ea | ea isKindOf: DragWrapperBrick] ifNone: [nil]) isNil]]]])
			ifTrue:
			[
				aMorph addPainter: RolloverBorderPainter new.
			].

			^self tryToPerform: #mouseEnterDragging: onBrick: aMorph withEvent: (anEvent asMouseEnter).	
		]		
	]
	ifFalse:
	[
		(aMorph isKindOf: Brick)
		ifTrue:
		[
			self log: ((anEvent asMouseEnter asString),' ',(aMorph asString)).

			^self tryToPerform: #mouseEnter: onBrick: aMorph withEvent: (anEvent asMouseEnter).	
		]
	].

	"if we're still here, its likely a morph"

	(aMorph isKindOf: Morph) 
		ifTrue: [^self tryToPerform: #handleFocusEvent: onMorph: aMorph withEvent: (anEvent asMouseEnter)].



! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 3/19/2003 00:01'!
dispatchMouseEvent: anEvent with: aMorph

	| morph | 

	aMorph world ifNil: [^self].
	morph := self activeSubMorphAtPoint: (anEvent cursorPoint) in: (aMorph world) event: anEvent.	

	morph == aMorph ifFalse: [^morph processEvent: anEvent using: self].

	self dispatchMouseLeaveEvents: anEvent with: morph.
	self dispatchMouseEnterEvents: anEvent with: morph.

	(morph isKindOf: Brick) ifFalse: [^#rejected].

	anEvent isMouseMove ifTrue: [ ^self dispatchMouseMove: anEvent with: morph ].
	anEvent isMouseOver ifTrue: [ ^self dispatchMouseOver: anEvent with: morph ].
	anEvent isMouseDown ifTrue: [ ^self dispatchMouseDown: anEvent with: morph ].
	anEvent isMouseUp ifTrue: [ ^self dispatchMouseUp: anEvent with: morph ].
! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 3/19/2003 01:10'!
dispatchMouseLeaveEvents: anEvent with: aMorph

	| chain left |

	"stack is weak array starting with world and ending with interesting morph "

	(stack isNil or: [stack isEmpty]) ifTrue: [^self]. 

	chain := aMorph allOwners copyWith: aMorph.
	chain last == stack last ifTrue: [^self]. "No change - same brick".

	left := stack last.

	(left isKindOf: Brick) ifTrue:
	[
		"maybe we didn't have one - but just to be sure"
		left removePainter: RolloverBorderPainter.

		anEvent isDraggingEvent ifTrue:
		[
			self log: ((anEvent asMouseLeave asString),' dragging: ',(anEvent hand submorphs asString),' ',(left asString)).

			(left respondsTo: #mouseLeaveDragging:)
			ifTrue:
			[
				left mouseLeaveDragging: (anEvent asMouseLeave).
			]
		]
		ifFalse:
		[
			self log: ((anEvent asMouseLeave asString),' ',(left asString)).
			(left respondsTo: #mouseLeave:)
			ifTrue:
			[
				left mouseLeave: (anEvent asMouseLeave).
			]
		]
	]

"
	held := Set new.

	anEvent hand submorphs do: [:m | held add: m. held addAll: (m allOwners)].

	removed := OrderedCollection new.
	kept := OrderedCollection new.

	stack reverseDo: 
	[:m |
		(chain includes: m) 
			ifFalse: [m notNil ifTrue: [removed add: m]] 
			ifTrue: [m notNil ifTrue: [kept addFirst: m]]
	].  
	
	stack := WeakArray withAll: kept.

	anEvent isDraggingEvent ifTrue:
	[
		removed do: 
		[:left |	
			(left isKindOf:Brick)
			ifTrue:
			[
				left removePainter: RolloverBorderPainter.
				((left owner isKindOf: Brick) and: [(removed includes: (left owner)) not]) 
					ifTrue: [ left owner addPainter: RolloverBorderPainter new].
				
				((held includes: left) not and: [(left respondsTo: #mouseLeaveDragging:) and: [left visible]]) 
				ifTrue: 
				[
					left mouseLeaveDragging: evt.	
				]
			]
		] 
	]
	ifFalse:
	[
		removed do: 
		[:left |	
			((left isKindOf: Brick) and: [(held includes: left) not and: [(left respondsTo: #mouseLeave:) and: [left visible]]]) 
			ifTrue: 
			[
				left mouseLeave: evt.
			]
			ifFalse:
			[
				((left isKindOf: Morph) and: [left visible] )
					ifTrue: [self dispatchMouseLeaveEvent: anEvent withMorph: left].
			]
		] 
	]
"! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 4/9/2003 21:21'!
dispatchMouseMove: anEvent with: aMorph

	(aMorph isKindOf: Brick) ifTrue:
	[
		anEvent isDraggingEvent ifTrue:
		[
			^self tryToPerform: #startDrag: onBrick: aMorph withEvent: anEvent.
		]
		ifFalse:
		[
			^self tryToPerform: #mouseMove: onBrick: aMorph withEvent: anEvent.
		]
	].	

	(aMorph isKindOf: Morph) ifTrue: 
	[
		^self tryToPerform: #handleFocusEvent: onMorph: aMorph withEvent: anEvent.
	].! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 3/24/2003 00:05'!
dispatchMouseOver: anEvent with: aMorph

	(aMorph isKindOf: Brick) ifTrue:
	[
		^self tryToPerform: #mouseOver: onBrick: aMorph withEvent: anEvent.
	].

	(aMorph isKindOf: Morph) ifTrue: 
	[
		^self tryToPerform: #handleFocusEvent: onMorph: aMorph withEvent: (anEvent asMouseEnter)
	].! !

!BrickEventDispatcher methodsFor: 'dispatching' stamp: 'tb 3/24/2003 00:15'!
dispatchMouseUp: anEvent with: aMorph

	| |

	self log: ((anEvent asString), ' ', (aMorph asString), ' holding:', (anEvent hand submorphs asString)).

	mouseDownMorph == aMorph ifTrue:
	[
		mouseDownMorph := nil. "Regardless - time to forget this guy"

		(aMorph isKindOf: Brick) ifTrue:
		[
			^self tryToPerform: #mouseUp: onBrick: aMorph withEvent: anEvent.
		].

		(aMorph isKindOf: Morph) ifTrue: 
		[
			^self tryToPerform: #handleFocusEvent: onMorph: aMorph withEvent: anEvent.
		].
	].


	

! !

!BrickEventDispatcher methodsFor: 'dispatching morphs' stamp: 'tb 3/18/2003 11:26'!
dispatchMouseLeaveEvent: anEvent withMorph: aMorph

	| hand localEvt focus evt |
	
	aMorph ifNil: [^self].

	hand := anEvent hand.
	focus := hand mouseFocus.
	evt := anEvent asMouseLeave.

	(aMorph == focus or: [aMorph hasOwner: focus]) 
		ifTrue: 
		[
			localEvt := evt transformedBy: (aMorph transformedFrom: hand).
					aMorph handleEvent: localEvt.
		].
! !

!BrickEventDispatcher methodsFor: 'dispatching morphs' stamp: 'tb 3/23/2003 00:14'!
handleMorphEvent: anEvent
	| evt |

	evt _ anEvent.

	evt isMouseOver ifTrue:[^self sendMouseEvent: evt].

	evt isKeyboard ifTrue:[
		self sendListenEvent: evt to: self keyboardListeners.
		^self sendKeyboardEvent: evt.
		"^self mouseOverHandler processMouseOver: lastMouseEvent"].

	evt isDropEvent ifTrue:[
		^self sendEvent: evt focus: nil.
		"^self mouseOverHandler processMouseOver: lastMouseEvent"].

	evt isMouse ifTrue:[
		self sendListenEvent: evt to: self mouseListeners.
		lastMouseEvent _ evt].

	"Check for pending drag or double click operations."
	mouseClickState ifNotNil:[
		(mouseClickState handleEvent: evt from: self) ifFalse:[
			"Possibly dispatched #click: or something and will not re-establish otherwise"
			^self mouseOverHandler processMouseOver: lastMouseEvent]].

	evt isMove ifTrue:
	[
		self position: evt position.
		self sendMouseEvent: evt.
	] 
	ifFalse:
	[
		"Issue a synthetic move event if we're not at the position of the event"
		(evt position = self position) ifFalse:[self moveToEvent: evt].
		"Drop submorphs on button events"
		(self hasSubmorphs) 
			ifTrue:[self dropMorphs: evt]
			ifFalse:[self sendMouseEvent: evt].
	].
"	self mouseOverHandler processMouseOver: lastMouseEvent."
! !

!BrickEventDispatcher methodsFor: 'dispatching morphs' stamp: 'tb 3/23/2003 23:31'!
tryToPerform: aSelector onMorph: aMorph withEvent: anEvent

	| w |

	((aMorph respondsTo: aSelector) and: [(w := aMorph world) notNil]) 
		ifTrue: 
		[
			w becomeActiveDuring:
			[
				ActiveHand := anEvent hand.
				ActiveEvent := anEvent.
				^aMorph perform: aSelector with: anEvent.
			]
		]
		ifFalse:
		[
			ActiveEvent _ anEvent.
			^ActiveWorld processEvent: anEvent.
		]! !

!BrickEventDispatcher methodsFor: 'integration' stamp: 'tb 3/14/2003 14:04'!
handleEvent: anEvent

	| morph | 

	morph := self activeSubMorphAtPoint: (anEvent cursorPoint) in: (anEvent hand world) event: anEvent.	
	"Transcript show: ('handleListenEvent: ', (anEvent asString), ' ', (morph asString) ); cr."
	self dispatchEvent: anEvent with: morph.
! !

!BrickEventDispatcher methodsFor: 'integration' stamp: 'tb 3/14/2003 21:03'!
handleListenEvent: anEvent

	self handleEvent: anEvent.
! !

!BrickEventDispatcher methodsFor: 'initialization' stamp: 'tb 3/12/2003 14:12'!
initialize

	stack := #()! !

!BrickEventDispatcher methodsFor: 'accessing' stamp: 'tb 3/23/2003 14:17'!
keyboardFocus

	^keyboardFocus! !

!BrickEventDispatcher methodsFor: 'accessing' stamp: 'tb 3/23/2003 14:16'!
keyboardFocus: newFocus

	| oldFocus |

	oldFocus := keyboardFocus.

	"ask if we can lose the focus just now"
	((keyboardFocus respondsTo: #willLoseKeyboardFocus:) and: 
		[(keyboardFocus willLoseKeyboardFocus: lastMouseEvent) == false])
		ifTrue: [^self].

	keyboardFocus := nil.
	(oldFocus respondsTo: #didLoseKeyboardFocus:) 
		ifTrue: [oldFocus didLoseKeyboardFocus: lastMouseEvent].

	"see if new gizmo wants focus - assume it does if it doesn't say"
	((newFocus respondsTo: #willGetKeyboardFocus:) and: 
		[(newFocus willGetKeyboardFocus: lastMouseEvent) == false])	
		ifTrue: [^self].

	keyboardFocus := newFocus.

	(keyboardFocus respondsTo: #didGetKeyboardFocus: ) 
		ifTrue: [keyboardFocus didGetKeyboardFocus: lastMouseEvent].
! !

!BrickEventDispatcher methodsFor: 'accessing' stamp: 'tb 3/23/2003 15:53'!
mouseFocus

	^((stack notNil) and: [stack isEmpty not]) 
		ifTrue: [stack last] 
		ifFalse: [^nil]! !

!BrickEventDispatcher methodsFor: 'debugging' stamp: 'tb 3/24/2003 22:34'!
log: aString

	Transcript show: aString; cr.! !

!BrickEventDispatcher methodsFor: 'testing' stamp: 'tb 3/24/2003 22:42'!
runUntil: aBlock

	| sensor evt |

	sensor := BrickEventSensor new.
	
	[
		evt := nil.
		[evt isNil] whileTrue: [(evt := sensor nextEvent)]. 
		(aBlock value: evt).
	] 
	whileFalse:
	[
		self handleEvent: evt.
	]
	! !

!BrickEventDispatcher methodsFor: 'dispatching bricks' stamp: 'tb 3/23/2003 15:51'!
tryToPerform: aSelector onBrick: aBrick withEvent: anEvent

	| w |

	((aBrick respondsTo: aSelector) and: [(w := aBrick world) notNil]) 
		ifTrue: 
		[
			w becomeActiveDuring:
			[
				ActiveHand := anEvent hand.
				ActiveEvent := anEvent.
				aBrick perform: aSelector with: anEvent.
			]
		].! !


!BrickEventDispatcher class methodsFor: 'instance creation' stamp: 'tb 3/11/2003 20:28'!
forWorld: aWorld

	^DispatchersByWorld at: aWorld ifAbsentPut: [self new initialize].! !

!BrickEventDispatcher class methodsFor: 'class initialization' stamp: 'tb 3/11/2003 20:37'!
initialize

	"If the world goes away, release the dispatcher"
	DispatchersByWorld := WeakKeyDictionary new.! !


!BrickEventSensor methodsFor: 'event generation' stamp: 'tb 3/22/2003 17:40'!
generateDropFilesEvent: evtBuf 
	"Generate the appropriate mouse event for the given raw event buffer"

	"Note: This is still in an experimental phase and will need more work"
	| position oldPosition buttons modifiers stamp numFiles dragType |

	stamp := evtBuf second.
	stamp = 0 ifTrue: [stamp := Time millisecondClockValue].
	dragType := evtBuf third.
	position := evtBuf fourth @ evtBuf fifth.
	oldPosition := lastMouseEvent ifNil: [position] ifNotNil: [lastMouseEvent position].
	buttons := 0.
	modifiers := evtBuf sixth.
	buttons := buttons bitOr: (modifiers bitShift: 3).
	numFiles := evtBuf seventh.
	lastEventBuffer := evtBuf.
	dragType = 4 
		ifTrue: 
		["e.g., drop"

			"owner borderWidth: 0."
			^DropFilesEvent new 
				setPosition: position
				contents: numFiles
				hand: ActiveHand
		].
	"the others are currently not handled by morphs themselves"
	dragType = 1 
		ifTrue: 
		["experimental drag enter"

			^(MouseMoveEvent new 
				setType: #mouseMove
				startPoint: position
				endPoint: oldPosition
				trail: (Array with: position with: position)
				buttons: buttons
				hand: ActiveHand
				stamp: stamp) contents: numFiles.
		].
	dragType = 2 
		ifTrue: 
		["experimental drag move"

			^(MouseMoveEvent new 
				setType: #mouseMove
				startPoint: position
				endPoint: oldPosition
				trail: (Array with: position with: position)
				buttons: buttons
				hand: ActiveHand
				stamp: stamp) contents: numFiles.

		].
	dragType = 3 
		ifTrue: 
		["experimental drag leave"

			^(MouseMoveEvent new 
				setType: #mouseMove
				startPoint: position
				endPoint: oldPosition
				trail: (Array with: position with: position)
				buttons: buttons
				hand: ActiveHand
				stamp: stamp) contents: numFiles.

			"owner borderWidth: 0"
		].
	^nil! !

!BrickEventSensor methodsFor: 'event generation' stamp: 'tb 3/24/2003 22:45'!
generateKeyboardEvent: evtBuf 
	"Generate the appropriate mouse event for the given raw event buffer"

	| buttons modifiers type keyValue pressType stamp |

	stamp := evtBuf second.
	stamp = 0 ifTrue: [stamp := Time millisecondClockValue].
	keyValue := evtBuf third.
	pressType := evtBuf fourth.
	pressType = EventKeyDown ifTrue: [type := #keyDown].
	pressType = EventKeyUp ifTrue: [type := #keyUp].
	pressType = EventKeyChar ifTrue: [type := #keystroke].
	modifiers := evtBuf fifth.
	buttons := modifiers bitShift: 3.
	lastEventBuffer := evtBuf.
	^KeyboardEvent new 
		setType: type
		buttons: buttons
		position: (lastMouseEvent ifNil: [ nil ] ifNotNil: [ lastMouseEvent cursorPoint ])
		keyValue: keyValue
		hand: ActiveHand
		stamp: stamp! !

!BrickEventSensor methodsFor: 'event generation' stamp: 'tb 3/22/2003 17:33'!
generateMouseEvent: evtBuf 
	"Generate the appropriate mouse event for the given raw event buffer"

	| position buttons modifiers type trail stamp oldButtons |

	stamp := evtBuf second.
	stamp = 0 ifTrue: [stamp := Time millisecondClockValue].
	position := evtBuf third @ evtBuf fourth.
	buttons := evtBuf fifth.
	modifiers := evtBuf sixth.
	buttons = 0 
		ifTrue: 
		[
			(lastEventBuffer isNil or: [lastEventBuffer fifth = 0])
				ifTrue: [type := #mouseMove]
				ifFalse: [type := #mouseUp]
		]
		ifFalse: 
		[
			type := lastEventBuffer fifth = 0 
				ifTrue: [#mouseDown]
				ifFalse: [#mouseMove]
		].
	buttons := buttons bitOr: (modifiers bitShift: 3).
	oldButtons := (lastEventBuffer ifNil: [0] ifNotNil: [lastEventBuffer fifth]) 
				bitOr: ((lastEventBuffer sixth) bitShift: 3).
	lastEventBuffer := evtBuf.
	type == #mouseMove 
		ifTrue: 
		[
			trail := self mouseTrailFrom: evtBuf.
			^lastMouseEvent := MouseMoveEvent new 
				setType: type
				startPoint: trail first
				endPoint: trail last
				trail: trail
				buttons: buttons
				hand: ActiveHand
				stamp: stamp
		].
	^lastMouseEvent := MouseButtonEvent new 
		setType: type
		position: position
		which: (oldButtons bitXor: buttons)
		buttons: buttons
		hand: ActiveHand
		stamp: stamp! !

!BrickEventSensor methodsFor: 'event generation' stamp: 'tb 3/22/2003 17:19'!
isValidMouseEvent: evtBuf

	(lastEventBuffer notNil and: [evtBuf first = EventTypeMouse and: [evtBuf first = lastEventBuffer first]]) 
		ifTrue: 
		[	"Workaround for Mac VM bug, *always* generating 3 events on clicks"
			
			3 to: evtBuf size
				do: [:i | (lastEventBuffer at: i) = (evtBuf at: i) ifFalse: [^true]].
		
			^false 
		].

	^true	! !

!BrickEventSensor methodsFor: 'event generation' stamp: 'tb 3/22/2003 12:08'!
mouseTrailFrom: currentBuf 
	"Current event, a mouse event buffer, is about to be processed.  If there are other similar mouse events queued up, then drop them from the queue, and report the positions inbetween."

	| nextEvent trail |
	trail := WriteStream on: (Array new: 1).
	trail nextPut: currentBuf third @ currentBuf fourth.
	[(nextEvent := Sensor peekEvent) isNil] whileFalse: 
			[nextEvent first = currentBuf first 
				ifFalse: [^trail contents	"different event type"].
			nextEvent fifth = currentBuf fifth 
				ifFalse: [^trail contents	"buttons changed"].
			nextEvent sixth = currentBuf sixth 
				ifFalse: [^trail contents	"modifiers changed"].
			"nextEvent is similar.  Remove it from the queue, and check the next."
			nextEvent := Sensor nextEvent.
			trail nextPut: nextEvent third @ nextEvent fourth].
	^trail contents! !

!BrickEventSensor methodsFor: 'event generation' stamp: 'tb 3/22/2003 18:08'!
nextEvent
	"Process user input events from the local input devices."

	| evtBuf evt type |

	[(evtBuf := Sensor nextEvent) isNil] whileFalse:
	[ 
		lastEventBuffer ifNil: [lastEventBuffer := evtBuf].
		type := evtBuf first.

		evt := type caseOf: 
		{
			[EventTypeMouse]->
				[
					(self isValidMouseEvent: evtBuf) 
						ifTrue: [self generateMouseEvent: evtBuf]
						ifFalse: [nil]
				].
			[EventTypeKeyboard]->[self generateKeyboardEvent: evtBuf].
			[EventTypeDragDropFiles]->[self generateDropFilesEvent: evtBuf].
		}
		otherwise: [nil].

		evt notNil ifTrue: 
		[
			lastEventBuffer := evtBuf.
			^evt
		]

	].

	^nil! !

!BrickEventSensor methodsFor: 'event generation' stamp: 'tb 3/22/2003 16:51'!
nextKeyboardEvent

	"Quick check for more keyboard activity -- Allows, eg, many characters
	to be accumulated into a single replacement during type-in."

	| evtBuf |
	self flag: #arNote.	"Will not work if we don't examine event queue in Sensor"
	evtBuf := (Sensor eventQueue ifNil: [^nil]) nextOrNilSuchThat: 
					[:buf | 
					buf first = EventTypeKeyboard and: [(buf fourth) = EventKeyChar]].
	evtBuf ifNil: [^nil].
	^self generateKeyboardEvent: evtBuf! !


!BrickModel methodsFor: 'menus' stamp: 'tb 3/8/2003 16:17'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	model ifNotNil: [model addModelMenuItemsTo: aCustomMenu forMorph: self hand: aHandMorph].
	self isOpen ifTrue: [aCustomMenu add: 'close editing' action: #closeToEdits]
			ifFalse: [aCustomMenu add: 'open editing' action: #openToEdits].
! !

!BrickModel methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
addPartNameLike: className withValue: aMorph
	| otherNames i default partName stem |
	stem _ className first asLowercase asString , className allButFirst.
	otherNames _ self class allInstVarNames.
	i _ 1.
	[otherNames includes: (default _ stem, i printString)]
		whileTrue: [i _ i + 1].
	partName _ FillInTheBlank
		request: 'Please give this part a name'
		initialAnswer: default.
	(otherNames includes: partName)
		ifTrue: [self inform: 'Sorry, that name is already used'. ^ nil].
	self class addInstVarName: partName.
	self instVarAt: self class instSize put: aMorph.  "Assumes added as last field"
	^ partName! !

!BrickModel methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
compileAccessForSlot: aSlotName
	"Write the method to get at this inst var.  "
	"Instead call the right thing to make this happen?"

	| s  |
	s _ WriteStream on: (String new: 2000).
	s nextPutAll: aSlotName; cr; tab; nextPutAll: '^', aSlotName.
	self class
		compile: s contents
		classified: 'public access'
		notifying: nil.
! !

!BrickModel methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
compileInitMethods
	| s nodeDict varNames |
	nodeDict _ IdentityDictionary new.
	s _ WriteStream on: (String new: 2000).
	varNames _ self class allInstVarNames.
	s nextPutAll: 'initMorph'.
	3 to: self class instSize do:
		[:i | (self instVarAt: i) isMorph ifTrue:
			[s cr; tab; nextPutAll: (varNames at: i) , ' _ '.
			s nextPutAll: (self instVarAt: i) initString; nextPutAll: '.'.
			nodeDict at: (self instVarAt: i) put: (varNames at: i)]].
	submorphs do: 
		[:m | s cr; tab; nextPutAll: 'self addMorph: '.
		m printConstructorOn: s indent: 1 nodeDict: nodeDict.
		s nextPutAll: '.'].
	self class
		compile: s contents
		classified: 'initialization'
		notifying: nil.! !

!BrickModel methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
compilePropagationMethods
	| varName |
	(self class organization listAtCategoryNamed: 'private - propagation' asSymbol)
		do: [:sel | varName _ sel allButLast.
			model class compilePropagationForVarName: varName slotName: slotName]! !

!BrickModel methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
nameFor: aMorph
	"Return the name of the slot containing the given morph or nil if that morph has not been named."

	| allNames start |
	allNames _ self class allInstVarNames.
	start _ MorphicModel allInstVarNames size + 1.
	start to: allNames size do: [:i |
		(self instVarAt: i) == aMorph ifTrue: [^ allNames at: i]].
	^ nil
! !

!BrickModel methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
propagate: value as: partStoreSelector
	model ifNil: [^ self].
"
	Later we can cache this for more speed as follows...
	(partName == cachedPartName and: [slotName == cachedSlotName])
		ifFalse: [cachedPartName _ partName.
				cachedSlotName _ slotName.
				cachedStoreSelector _ (slotName , partStoreSelector) asSymbol].
	model perform: cachedStoreSelector with: value].
"
	model perform: (self slotSelectorFor: partStoreSelector) with: value! !

!BrickModel methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
removeAll
	"Clear out all script methods and subpart instance variables in me.  Start over."
	"self removeAll"
	"MorphicModel2 removeAll"

self class == MorphicModel ifTrue: [^ self].	"Must be a subclass!!"
self class removeCategory: 'scripts'.
self class instVarNames do: [:nn | self class removeInstVarName: nn].! !

!BrickModel methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
slotSelectorFor: selectorBody
	| selector |
	model ifNil: [^ nil].
	"Make up selector from slotname if any"
	selector _ (slotName ifNil: [selectorBody]
					ifNotNil: [slotName , selectorBody]) asSymbol.
	(model canUnderstand: selector) ifFalse:
		[self halt: 'Compiling a null response for ' , model class name , '>>' , selector].
	^ selector! !

!BrickModel methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
use: cachedSelector orMakeModelSelectorFor: selectorBody in: selectorBlock
	| selector |
	model ifNil: [^ nil].
	cachedSelector ifNil:
			["Make up selector from slotname if any"
			selector _ (slotName ifNil: [selectorBody]
								ifNotNil: [slotName , selectorBody]) asSymbol.
			(model class canUnderstand: selector) ifFalse:
				[(self confirm: 'Shall I compile a null response for'
							, Character cr asString
							, model class name , '>>' , selector)
						ifFalse: [self halt].
				model class compile: (String streamContents:
								[:s | selector keywords doWithIndex:
										[:k :i | s nextPutAll: k , ' arg' , i printString].
								s cr; nextPutAll: '"Automatically generated null response."'.
								s cr; nextPutAll: '"Add code below for appropriate behavior..."'.])
							classified: 'input events'
							notifying: nil]]
		ifNotNil:
			[selector _ cachedSelector].
	^ selectorBlock value: selector! !

!BrickModel methodsFor: 'submorphs-accessing' stamp: 'tb 3/8/2003 16:17'!
allKnownNames
	"Return a list of all known names based on the scope of the receiver.  If the receiver is a member of a uniclass, incorporate the original 1997 logic that queries the known names of the values of all the instance variables."

	| superNames |
	superNames := super allKnownNames.	"gather them from submorph tree"
	^self belongsToUniClass 
		ifTrue: 
			[superNames , (self instanceVariableValues 
						select: [:e | e notNil and: [e knownName notNil]]
						thenCollect: [:e | e knownName])]
		ifFalse: [superNames]! !

!BrickModel methodsFor: 'drag and drop' stamp: 'tb 3/8/2003 16:17'!
allowSubmorphExtraction
	^ self isOpen
! !

!BrickModel methodsFor: 'drag and drop' stamp: 'tb 3/8/2003 16:17'!
isOpen
	"Support drag/drop and other edits."
	^ open! !

!BrickModel methodsFor: 'naming' stamp: 'tb 3/8/2003 16:17'!
choosePartName
	"When I am renamed, get a slot, make default methods, move any existing methods.  ** Does not clean up old inst var name or methods**  "

	| old |
	old := slotName.
	super choosePartName.
	slotName ifNil: [^self].	"user chose bad slot name"
	self model: self world model slotName: slotName.
	old isNil
		ifTrue: [self compilePropagationMethods]
		ifFalse: [self copySlotMethodsFrom: old]
	"old ones not erased!!"! !

!BrickModel methodsFor: 'menu' stamp: 'tb 3/8/2003 16:17'!
closeToEdits
	"Disable this morph's ability to add and remove morphs via drag-n-drop."

	open _ false
! !

!BrickModel methodsFor: 'menu' stamp: 'tb 3/8/2003 16:17'!
openToEdits
	"Enable this morph's ability to add and remove morphs via drag-n-drop."

	open _ true
! !

!BrickModel methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:17'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color yellow! !

!BrickModel methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:17'!
defaultBounds
	^ 0 @ 0 corner: 200 @ 100.
	! !

!BrickModel methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:17'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color transparent! !

!BrickModel methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:17'!
duplicate: newGuy from: oldGuy
	"oldGuy has just been duplicated and will stay in this world.  Make sure all the MorphicModel requirements are carried out for the copy.  Ask user to rename it.  "

	newGuy installModelIn: oldGuy world.
	newGuy copySlotMethodsFrom: oldGuy slotName.! !

!BrickModel methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:17'!
initialize
	"initialize the state of the receiver"
	super initialize.
""
	open _ false! !

!BrickModel methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:17'!
model: anObject
	"Set my model and make me me a dependent of the given object."

	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model _ anObject.
! !

!BrickModel methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:17'!
model: thang slotName: nameOfThisPart
	model _ thang.
	slotName _ nameOfThisPart.
	open _ false.! !

!BrickModel methodsFor: 'submorphs-add/remove' stamp: 'tb 3/8/2003 16:17'!
delete
	(model isMorphicModel) ifFalse: [^super delete].
	slotName ifNotNil: 
			[(PopUpMenu confirm: 'Shall I remove the slot ' , slotName 
						, '
along with all associated methods?') 
				ifTrue: 
					[(model class selectors select: [:s | s beginsWith: slotName]) 
						do: [:s | model class removeSelector: s].
					(model class instVarNames includes: slotName) 
						ifTrue: [model class removeInstVarName: slotName]]
				ifFalse: 
					[(PopUpMenu 
						confirm: '...but should I at least dismiss this morph?
[choose no to leave everything unchanged]') 
							ifFalse: [^self]]].
	super delete! !

!BrickModel methodsFor: 'printing' stamp: 'tb 3/8/2003 16:17'!
initString

	^ String streamContents:
		[:s | s nextPutAll: self class name;
			nextPutAll: ' newBounds: (';
			print: bounds;
			nextPutAll: ') model: self slotName: ';
			print: slotName]! !

!BrickModel methodsFor: 'debug and other' stamp: 'tb 3/8/2003 16:17'!
installModelIn: aWorld

	self wantsSlot ifFalse: [^ self].  "No real need to install"
	slotName _ aWorld model addPartNameLike: self class name withValue: self.
	slotName ifNil: [^ self].  "user chose bad slot name"
	self model: aWorld model slotName: slotName.
	self compilePropagationMethods.
	aWorld model compileAccessForSlot: slotName.
! !

!BrickModel methodsFor: 'classification' stamp: 'tb 3/8/2003 16:17'!
isMorphicModel
	^true! !

!BrickModel methodsFor: 'access' stamp: 'tb 3/8/2003 16:17'!
model 
	^ model! !

!BrickModel methodsFor: 'access' stamp: 'tb 3/8/2003 16:17'!
slotName
	^ slotName! !

!BrickModel methodsFor: 'access' stamp: 'tb 3/8/2003 16:17'!
wantsSlot
	"Override this default for models that want to be installed in theri model"
	^ false! !

!BrickModel methodsFor: 'accessing' stamp: 'tb 3/8/2003 16:17'!
modelOrNil
	^ model! !

!BrickModel methodsFor: 'geometry' stamp: 'tb 3/8/2003 16:17'!
newBounds: newBounds
	self bounds: newBounds! !

!BrickModel methodsFor: 'geometry' stamp: 'tb 3/15/2003 11:54'!
recomputeBounds

	| bnds |
	bnds _ submorphs first bounds.
	bounds _ bnds origin corner: bnds corner. "copy it!!"
	bounds _ self fullBounds.
! !

!BrickModel methodsFor: 'caching' stamp: 'tb 3/8/2003 16:17'!
releaseCachedState
	"Release cached state of the receiver"

	(model ~~ self and: [model respondsTo: #releaseCachedState]) ifTrue:
		[model releaseCachedState].
	super releaseCachedState! !


!BrickModel class methodsFor: 'compiling' stamp: 'tb 3/8/2003 16:17'!
acceptsLoggingOfCompilation
	"Dont log sources for my automatically-generated subclasses.  Can easily switch this back when it comes to deal with Versions, etc."

	^ self == MorphicModel or: [(name last isDigit) not]! !

!BrickModel class methodsFor: 'compiling' stamp: 'tb 3/8/2003 16:17'!
wantsChangeSetLogging
	"Log changes for MorphicModel itself and for things like PlayWithMe2, but not for automatically-created subclasses like MorphicModel1, MorphicModel2, etc."

	^ self == MorphicModel or:
		[(self class name beginsWith: 'Morphic') not]! !

!BrickModel class methodsFor: 'queries' stamp: 'tb 3/8/2003 16:17'!
baseUniclass
	"Answer the uniclass that new instances should be instances of.  This protocol is primarily intended for the Player lineage, but can get sent to a MorphicModel subclass when the project-loading mechanism is scrambling to fix up projects that have naming conflicts with the project being loaded."

	| curr |
	curr _ self.
	[curr theNonMetaClass superclass name endsWithDigit]
		whileTrue:
			[curr _ curr superclass].
	^ curr

"PlayWithMe1 baseUniclass"! !

!BrickModel class methodsFor: 'queries' stamp: 'tb 3/8/2003 16:17'!
hasPrototype
	"Return true if there is a prototype for this morph."

	^ prototype ~~ nil
! !

!BrickModel class methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
categoryForSubclasses
	^ 'Morphic-Models'! !

!BrickModel class methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
chooseNewName
	"Choose a new name for the receiver, persisting until an acceptable name is provided or until the existing name is resubmitted"

	| oldName newName |
	oldName _ self name.
		[newName _ (FillInTheBlank request: 'Please give this Model a name'
					initialAnswer: oldName) asSymbol.
		newName = oldName ifTrue: [^ self].
		Smalltalk includesKey: newName]
		whileTrue:
		[self inform: 'Sorry, that name is already in use.'].
	self rename: newName.! !

!BrickModel class methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
compileAccessorsFor: varName
	self compile: (
'&var
	"Return the value of &var"
	^ &var'
			copyReplaceAll: '&var' with: varName)
		classified: 'public access' notifying: nil.
	self compile: (
'&varPut: newValue
	"Assign newValue to &var.
	Add code below to update related graphics appropriately..."

	&var _ newValue.'
			copyReplaceAll: '&var' with: varName)
		classified: 'public access' notifying: nil.
	self compile: (
'&var: newValue
	"Assigns newValue to &var and updates owner"
	&var _ newValue.
	self propagate: &var as: ''&var:'''
			copyReplaceAll: '&var' with: varName)
		classified: 'private - propagation' notifying: nil.
! !

!BrickModel class methodsFor: 'compilation' stamp: 'tb 3/8/2003 16:17'!
compilePropagationForVarName: varName slotName: slotName
	self compile: ((
'&slot&var: newValue
	"The value of &var in &slot has changed to newValue.
	This value can be read elsewhere in code with
		&slot &var
	and it can be stored into with
		&slot &varPut: someValue"

	"Add code for appropriate response here..."'
			copyReplaceAll: '&var' with: varName)
			copyReplaceAll: '&slot' with: slotName)
		classified: 'input events' notifying: nil.
! !

!BrickModel class methodsFor: 'new-morph participation' stamp: 'tb 3/8/2003 16:17'!
includeInNewMorphMenu
	"Only include Models that are appropriate"
	^ false! !

!BrickModel class methodsFor: 'instance creation' stamp: 'tb 3/8/2003 16:17'!
new
	"Return a copy of the prototype, if there is one.
	Otherwise create a new instance normally."

	self hasPrototype ifTrue: [^ prototype veryDeepCopy].
	^ super new
! !

!BrickModel class methodsFor: 'instance creation' stamp: 'tb 3/8/2003 16:17'!
newBounds: bounds model: thang slotName: nameOfThisPart
	^ (super new model: thang slotName: nameOfThisPart)
		newBounds: bounds! !

!BrickModel class methodsFor: 'subclass creation' stamp: 'tb 3/8/2003 16:17'!
newSubclass
	| i className |
	i _ 1.
	[className _ (self name , i printString) asSymbol.
	 Smalltalk includesKey: className]
		whileTrue: [i _ i + 1].

	^ self subclass: className
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Morphic-Models'! !

!BrickModel class methodsFor: 'testing' stamp: 'tb 3/8/2003 16:17'!
officialClass
	"We want to make a new instance of the receiver, which is a subclass of MorphicModel.  Answer who to make a new subclass of.  Also used to tell if a given class is a UniClass, existing only for its single instance."

	^ self name last isDigit ifTrue: [MorphicModel] ifFalse: [self]
		"MorphicModel7 can not have subclasses, but Slider and SystemWindow may"! !

!BrickModel class methodsFor: 'prototype access' stamp: 'tb 3/8/2003 16:17'!
prototype
	"Return the prototype for this morph."

	^ prototype
! !

!BrickModel class methodsFor: 'prototype access' stamp: 'tb 3/8/2003 16:17'!
prototype: aMorph
	"Store a copy of the given morph as a prototype to be copied to make new instances."

	aMorph ifNil: [prototype _ nil. ^ self].

	prototype _ aMorph veryDeepCopy.
	(prototype isMorphicModel) ifTrue: 
		[prototype model: nil slotName: nil].
! !

!BrickModel class methodsFor: 'housekeeping' stamp: 'tb 3/8/2003 16:17'!
removeUninstantiatedModels
	"With the user's permission, remove the classes of any models that have neither instances nor subclasses."
	"MorphicModel removeUninstantiatedModels"

	| candidatesForRemoval ok |
	Smalltalk garbageCollect.
	candidatesForRemoval _
		MorphicModel subclasses select: [:c |
			(c instanceCount = 0) and: [c subclasses size = 0]].
	candidatesForRemoval do: [:c |
		ok _ self confirm: 'Are you certain that you
want to delete the class ', c name, '?'.
		ok ifTrue: [c removeFromSystem]].
! !


!CornerRounder class methodsFor: '*bricks' stamp: 'tb 4/9/2003 15:32'!
forWidth: aWidth

	^aWidth caseOf: { [2]->[CR2]. [1]->[CR1]. } otherwise: [CR0]! !


!DragWrapperBrick methodsFor: 'event handling' stamp: 'tb 3/23/2003 22:07'!
dropOn: aBrick with: evt

	self subclassResponsibility! !

!DragWrapperBrick methodsFor: 'event handling' stamp: 'tb 4/10/2003 00:00'!
mouseDown: anEvent! !

!DragWrapperBrick methodsFor: 'event handling' stamp: 'tb 4/9/2003 21:23'!
startDrag: anEvent

	anEvent hand submorphs isEmpty ifTrue: 
	[
		anEvent hand grabMorph: (self copy).
	]! !

!DragWrapperBrick methodsFor: 'dropping/grabbing' stamp: 'tb 4/9/2003 17:39'!
dragEnabled
	^true! !

!DragWrapperBrick methodsFor: 'dropping/grabbing' stamp: 'tb 4/10/2003 00:01'!
dropEnabled
	^false! !

!DragWrapperBrick methodsFor: 'dropping/grabbing' stamp: 'tb 4/9/2003 21:13'!
justDroppedInto: aMorph event: anEvent

	^self dropOn: aMorph with: anEvent! !

!DragWrapperBrick methodsFor: 'dropping/grabbing' stamp: 'tb 4/10/2003 00:03'!
wantsDroppedMorph: aMorph event: evt

	^false! !


!DragPainterBrick methodsFor: 'event handling' stamp: 'tb 4/9/2003 21:16'!
dropOn: aBrick with: anEvent

	(aBrick isKindOf: Brick) 
	ifTrue:
	[
		self removesPainter 
			ifTrue: [ aBrick removePainter: (self painter)]
			ifFalse: [ aBrick addPainter: (self painter)].
	].

	self delete.! !

!DragPainterBrick methodsFor: 'event handling' stamp: 'tb 3/18/2003 13:31'!
mouseMoveDragging: evt

	| clone |
	evt hand submorphs isEmpty ifTrue: 
	[
		clone := self copy.
		evt hand attachMorph: clone openInWorld.
	]! !

!DragPainterBrick methodsFor: 'initialization' stamp: 'tb 3/19/2003 02:19'!
initialize

	super initialize.
	removesPainter := false.! !

!DragPainterBrick methodsFor: 'accessing' stamp: 'tb 3/19/2003 02:06'!
painter

	^self removesPainter 
		ifTrue: [painter class]
		ifFalse: [painter].
	! !

!DragPainterBrick methodsFor: 'accessing' stamp: 'tb 3/19/2003 02:45'!
painter: aPainter

	painter := aPainter.
	self replaceAllPaintersWithPainter: aPainter.	! !

!DragPainterBrick methodsFor: 'accessing' stamp: 'tb 3/19/2003 02:06'!
removesPainter

	^removesPainter ifNil: [ removesPainter := false ] ifNotNil: [ removesPainter ]! !

!DragPainterBrick methodsFor: 'accessing' stamp: 'tb 3/19/2003 02:44'!
removesPainter: aBoolean

	removesPainter := aBoolean! !


!DragPainterBrick class methodsFor: 'instance creation' stamp: 'tb 3/19/2003 02:19'!
forPainter: aPainter

	^self new painter: aPainter! !

!DragPainterBrick class methodsFor: 'instance creation' stamp: 'tb 3/19/2003 02:32'!
painter: aPainter

	^self new painter: aPainter! !

!DragPainterBrick class methodsFor: 'instance creation' stamp: 'tb 3/19/2003 02:32'!
unPainter: aPainter

	^(self new painter: aPainter) removesPainter: true! !


!GridBrick methodsFor: 'accessing' stamp: 'tb 4/10/2003 14:29'!
addMorph: aBrick

	
	self isVertical ifTrue:
	[
		"should probably check for hresizing and vresizing to see if its ok to resize the brick"
		aBrick width > (self width - (2* inset x)) ifTrue: 
		[
			aBrick hResizing == #rigid 
				ifTrue: [ self width: (aBrick width + (2* inset x))]
				ifFalse: [ aBrick width: (self width - (2* inset x)) ].
		].
		aBrick height > (self width - (2* inset y)) ifTrue:
		[
			aBrick vResizing == #rigid 
				ifFalse: [ aBrick height: (self width - (2* inset x)) ].
		].
		 
		(self submorphs isNil or: [self submorphs isEmpty]) 
			ifTrue: 
			[ 
				aBrick center: ((self center x)@((self top + ((aBrick height / 2) rounded) + (inset y)))). 
			]
			ifFalse: 
			[
				| x y |
				x := (self center x).
				y := ((self submorphs first bottom) + ((aBrick height / 2) rounded) + (inset y)).
				aBrick center: (x@y) 
			].
		aBrick leftToRightLayout: 's-s'.
	]
	ifFalse: "Horizontal"
	[
		aBrick width: (self height - (2 * inset x)).
		aBrick height: (self height - (2 * inset y)).

		aBrick height > (self height - (2* inset y)) ifTrue: 
		[
			aBrick vResizing == #rigid 
				ifTrue: [ self height: (aBrick height + (2* inset y))]
				ifFalse: [ aBrick height: (self height - (2* inset y)) ].
		].
		aBrick width > (self height - (2* inset x)) ifTrue:
		[
			aBrick hResizing == #rigid 
				ifFalse: [ aBrick width: (self height - (2* inset y)) ].
		].


		(self submorphs isNil or: [self submorphs isEmpty]) 
			ifTrue: 
			[ 
				aBrick center: (((self left + ((aBrick width / 2) rounded) + (inset x)))@(self center y)).  
			]
			ifFalse: 
			[
				| x y |
				y := (self center y).
				x := (self submorphs first right) + ((aBrick width / 2) rounded) + (inset x).
				aBrick center: (x@y) 
			].
		aBrick topToBottomLayout: 's-s'.
	].
	aBrick world ifNil: [ aBrick openInWorld ].
	super addMorph: aBrick.
	aBrick updateLayoutProperties.
	self changed.! !

!GridBrick methodsFor: 'accessing' stamp: 'tb 4/10/2003 14:29'!
beHorizontal

	| bricks h w |
	direction == #horizontal ifFalse:
	[
		
		direction := #horizontal.
		bricks := self submorphs copy.
		self removeAllMorphsIn: bricks.
		h := self height.
		w := self width.
		self height: w.
		self width: h.
		bricks reverseDo: [:m | self addMorph: m]. 	
	]! !

!GridBrick methodsFor: 'accessing' stamp: 'tb 4/10/2003 14:29'!
beVertical

	| bricks h w |
	direction == #vertical ifFalse:
	[
		
		direction := #vertical.
		bricks := self submorphs copy.
		self removeAllMorphsIn: bricks.
		h := self height.
		w := self width.
		self height: w.
		self width: h.
		bricks reverseDo: [:m | self addMorph: m]. 	
	]! !

!GridBrick methodsFor: 'accessing' stamp: 'tb 4/10/2003 14:29'!
inset: aPoint

	| newInset delta |

	aPoint isNumber ifTrue: [ newInset := ((aPoint asInteger)@(aPoint asInteger)) ]
	ifFalse: [ aPoint isPoint ifFalse: [^self]. newInset := aPoint].

	delta := newInset - inset.

	self submorphsDo: [:m | m bounds: (m bounds insetBy: delta). m updateLayoutProperties ].

	inset := newInset.! !

!GridBrick methodsFor: 'accessing' stamp: 'tb 4/10/2003 14:29'!
isHorizontal

	^direction == #horizontal! !

!GridBrick methodsFor: 'accessing' stamp: 'tb 4/10/2003 14:29'!
isVertical

	^direction == #vertical! !

!GridBrick methodsFor: 'accessing' stamp: 'tb 4/10/2003 14:29'!
sizeToFit
	
	self isVertical ifTrue:
	[
		self height: (self submorphs first bottom + (inset y) - (self top)).
	]
	ifFalse: "Horizontal"
	[
		self width: (self submorphs first right + (inset x) - (self left)).
	]! !

!GridBrick methodsFor: 'initialization' stamp: 'tb 4/10/2003 14:56'!
initialize

	super initialize.

	inset := 8@8.
	self beHorizontal.
	cells := Dictionary new.

	self addPainter: (BackgroundPainter color: #stainless).
	self addPainter: (BorderPainter etched).! !


!ImageBrick methodsFor: 'menus' stamp: 'tb 3/8/2003 17:33'!
addCustomMenuItems: aMenu hand: aHand
	super addCustomMenuItems: aMenu hand: aHand.
	aMenu addUpdating: #opacityString action: #changeOpacity! !

!ImageBrick methodsFor: 'testing' stamp: 'tb 3/8/2003 17:33'!
basicType
	"Answer a symbol representing the inherent type I hold"

	"Number String Boolean player collection sound color etc"
	^ #Image! !

!ImageBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
borderStyle: newStyle
	| newExtent |
	newExtent _ 2 * newStyle width + image extent.
	bounds extent = newExtent ifFalse:[super extent: newExtent].
	super borderStyle: newStyle.! !

!ImageBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
borderWidth: bw
	| newExtent |
	newExtent _ 2 * bw + image extent.
	bounds extent = newExtent ifFalse:[super extent: newExtent].
	super borderWidth: bw! !

!ImageBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
color: aColor
        super color: aColor.
        (image depth == 1 and: [aColor isColor]) ifTrue: [
                image colors: {Color transparent. aColor}.
                self changed]! !

!ImageBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
form
	"For compatability with SketchMorph."

	^ image
! !

!ImageBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
image

	^ image
! !

!ImageBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
image: anImage 
	self changed.
	image := anImage depth = 1 
				ifTrue: [ColorForm mappingWhiteToTransparentFrom: anImage]
				ifFalse: [anImage]. 
	super extent: image extent! !

!ImageBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
isOpaque
	"Return true if the receiver is marked as being completely opaque"
	^ self
		valueOfProperty: #isOpaque
		ifAbsent: [false]! !

!ImageBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
isOpaque: aBool
	"Mark the receiver as being completely opaque or not"
	aBool == false
		ifTrue:[self removeProperty: #isOpaque]
		ifFalse:[self setProperty: #isOpaque toValue: aBool].
	self changed! !

!ImageBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
setNewImageFrom: formOrNil
	"Change the receiver's image to be one derived from the supplied form.  If nil is supplied, clobber any existing image in the receiver, and in its place put a default graphic, either the one known to the receiver as its default value, else a squeaky mouse"

	|  defaultImage |
	formOrNil ifNotNil: [^ self image: formOrNil].
	defaultImage _ self defaultValueOrNil ifNil: [ScriptingSystem squeakyMouseForm].
	self image: defaultImage
! !

!ImageBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:33'!
changeOpacity
	self isOpaque: self isOpaque not! !

!ImageBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:33'!
opacityString
	^self isOpaque ifTrue:['<on>opaque'] ifFalse:['<off>opaque']! !

!ImageBrick methodsFor: 'card in a stack' stamp: 'tb 3/8/2003 17:33'!
couldHoldSeparateDataForEachInstance
	"Answer whether the receiver can potentially hold separate data for each instance"

	^ true! !

!ImageBrick methodsFor: 'player' stamp: 'tb 3/8/2003 17:33'!
currentDataValue
	"Answer the current data value of the receiver, to be stored in each card instance if appropriate"

	^ image! !

!ImageBrick methodsFor: 'player' stamp: 'tb 3/8/2003 17:33'!
variableDocks
	"Answer a list of VariableDock objects for docking up my data with an instance held in my containing playfield"

	^ Array with: (VariableDock new variableName: self defaultVariableName type: #form definingMorph: self morphGetSelector: #image morphPutSelector: #setNewImageFrom:)! !

!ImageBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 17:33'!
drawOn: aCanvas
	| style |
	(style _ self borderStyle) ifNotNil:[
		style frameRectangle: bounds on: aCanvas.
	].
	self isOpaque
		ifTrue:[aCanvas drawImage: image at: self innerBounds origin]
		ifFalse:[aCanvas paintImage: image at: self innerBounds origin]! !

!ImageBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 17:33'!
drawPostscriptOn: aCanvas

	| top f2 c2 clrs |

	clrs _ image colorsUsed.
	(clrs includes: Color transparent) 
		ifFalse: [^super drawPostscriptOn: aCanvas].		"no need for this, then"

	top _ aCanvas topLevelMorph.
	f2 _ Form extent: self extent depth: image depth.
	c2 _ f2 getCanvas.
	c2 fillColor: Color white.
	c2 translateBy: bounds origin negated clippingTo: f2 boundingBox during: [ :c |
		top fullDrawOn: c
	].
	aCanvas paintImage: f2 at: bounds origin

! !

!ImageBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:33'!
extent: aPoint
	"Do nothing; my extent is determined by my image Form."
! !

!ImageBrick methodsFor: 'menu commands' stamp: 'tb 3/8/2003 17:33'!
grabFromScreen

	self image: Form fromUser.
! !

!ImageBrick methodsFor: 'menu commands' stamp: 'tb 3/8/2003 17:33'!
readFromFile
	| fileName |
	fileName _ FillInTheBlank
		request: 'Please enter the image file name'
		initialAnswer: 'fileName'.
	fileName isEmpty ifTrue: [^ self].
	self image: (Form fromFileNamed: fileName).
! !

!ImageBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:33'!
initialize

	super initialize.
	self image: DefaultForm.
! !

!ImageBrick methodsFor: 'parts bin' stamp: 'tb 3/8/2003 17:33'!
initializeToStandAlone

	super initializeToStandAlone.
	self image: DefaultForm.
! !

!ImageBrick methodsFor: 'other' stamp: 'tb 3/8/2003 17:33'!
newForm: aForm
	self image: aForm! !

!ImageBrick methodsFor: 'other' stamp: 'tb 3/8/2003 17:33'!
wearCostume: anotherMorph

	self image: anotherMorph form.
! !

!ImageBrick methodsFor: 'caching' stamp: 'tb 3/8/2003 17:33'!
releaseCachedState

	super releaseCachedState.
	image hibernate.
! !


!ImageBrick class methodsFor: 'scripting' stamp: 'tb 3/8/2003 17:33'!
authoringPrototype
	| aMorph aForm |
	aMorph _ super authoringPrototype.
	aForm _ ScriptingSystem formAtKey: 'Image'.
	aForm ifNil: [aForm _ aMorph image rotateBy: 90].
	aMorph image: aForm.
	^ aMorph! !

!ImageBrick class methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:33'!
defaultForm
	^DefaultForm! !

!ImageBrick class methodsFor: 'parts bin' stamp: 'tb 3/8/2003 17:33'!
descriptionForPartsBin
	^ self partName:	'Image'
		categories:		#('Graphics' ' Basic 2 ')
		documentation:	'A non-editable picture.  If you use the Paint palette to make a picture, you can edit it afterwards.'! !

!ImageBrick class methodsFor: 'instance creation' stamp: 'tb 3/8/2003 17:33'!
fromString: aString 
	"Create a new ImageMorph which displays the input string in the standard button font"

	^ self fromString: aString font: Preferences standardButtonFont! !

!ImageBrick class methodsFor: 'instance creation' stamp: 'tb 3/8/2003 17:33'!
fromString: aString font: aFont
	"Create a new ImageMorph showing the given string in the given font"

	^ self new image: (StringMorph contents: aString font: aFont) imageForm! !

!ImageBrick class methodsFor: 'class initialization' stamp: 'tb 3/8/2003 17:33'!
initialize
	"ImageMorph initialize"

	| h p d |
	DefaultForm _ (Form extent: 80@40 depth: 16).
	h _ DefaultForm height // 2.
	0 to: h - 1 do: [:i |
		p _ (i * 2)@i.
		d _ i asFloat / h asFloat.
		DefaultForm fill:
			(p corner: DefaultForm extent - p)
			fillColor: (Color r: d g: 0.5 b: 1.0 - d)].
! !


!LabelBrick methodsFor: 'layout' stamp: 'tb 3/9/2003 00:34'!
centerMorph: aMorph

	self hCenterMorph: aMorph.
	self vCenterMorph: aMorph.! !

!LabelBrick methodsFor: 'layout' stamp: 'tb 3/9/2003 00:32'!
hCenterMorph: aMorph

	aMorph left: (self left + ((self width - aMorph width)/2) rounded).! !

!LabelBrick methodsFor: 'layout' stamp: 'tb 3/9/2003 00:33'!
vCenterMorph: aMorph

	aMorph top: (self top + ((self height - aMorph height)/2) rounded).! !

!LabelBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:41'!
defaultColor

	^Color transparent! !

!LabelBrick methodsFor: 'initialization' stamp: 'tb 3/17/2003 12:40'!
initialize

	super initialize.
	stringMorph := StringBrick contents: 'Label'.
	self addMorph: stringMorph.
	self width: (stringMorph width + (self borderWidth *2 )).
	self height: (stringMorph height + (self borderWidth * 2)).
	self centerMorph: stringMorph.! !


!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 18:21'!
closeBoxBounds

	^(self topLeft + (6@6)) extent: ((self extent //12) asPoint)! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 2/17/2003 01:51'!
defaultColor

	^Color tan! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 2/20/2003 16:23'!
layoutProperties

	^self morph assureLayoutProperties! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 2/14/2003 13:38'!
morph

	^morph! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 12:19'!
morph: aMorph

	morph := aMorph.
	layoutProperties := aMorph assureLayoutProperties.
	self position: ((aMorph right + 20)@(aMorph top)).
! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 2/15/2003 02:01'!
springColor

	^springColor! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 2/15/2003 02:00'!
springColor: aColor

	springColor := aColor! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 2/17/2003 01:52'!
springWidth

	^2! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 2/15/2003 02:01'!
strutColor

	^strutColor! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 2/15/2003 02:00'!
strutColor: aColor

	strutColor := aColor! !

!LayoutControlBrick methodsFor: 'accessing' stamp: 'tb 2/17/2003 01:52'!
strutWidth

	^2! !

!LayoutControlBrick methodsFor: 'drawing' stamp: 'tb 3/9/2003 18:21'!
drawCloseBoxOn: aCanvas

	| box c |

	c := Color black.
	box := self closeBoxBounds.
	"draw an X"
	
	aCanvas line: box topLeft to: box bottomRight width: (self strutWidth) color: c.
	aCanvas line: box topRight to: box bottomLeft width: (self strutWidth) color: c.
! !

!LayoutControlBrick methodsFor: 'drawing' stamp: 'tb 2/17/2003 01:54'!
drawHSpringOn: aCanvas from: p1 to: p2

	| p3 p4 c w |

	c := self springColor.
	w := self springWidth.

	"inner h spring"
	"left nib"
	aCanvas line: p1 to: (p1 + ((self width //24 )@0)) width: w color: c.	

	"right nib"
	aCanvas line: p2 to: (p2 - ((self width //24 )@0)) width: w color: c.

	"left center spring"
	p3 := (p1 + ((self width //24 )@0)).
	p4 :=  (p3 + ((self width // 24)@((self height // 24))-((self width //48 )@0))).	
	aCanvas line: p3 to: p4 width: w color: c.
	
	p3 := p4.
	p4 := (p4 + ((self width//24)@(0-(self height//12)))).
	aCanvas line: p3 to: p4 width: w color: c.
	
	p3 := p4.
	p4 := (p4 + (((self width//24))@(self height//12))).
	aCanvas line: p3 to: p4 width: w color: c.
	 
	p3 := p4.
	p4 := (p4 + (((self width//24))@(0-(self height//12)))).
	aCanvas line: p3 to: p4 width: w color: c.

	p3 := p4.
	p4 := (p2 - ((self width // 24)@0)).
	aCanvas line: p3 to: p4 width: w color: c.

! !

!LayoutControlBrick methodsFor: 'drawing' stamp: 'tb 2/15/2003 03:05'!
drawInnerHSpringOn: aCanvas

	self drawHSpringOn: aCanvas from: (self leftCenter + ((self width // 4)@0)) to: (self center).
	self drawHSpringOn: aCanvas from: (self center) to: (self rightCenter - ((self width//4)@0)).! !

!LayoutControlBrick methodsFor: 'drawing' stamp: 'tb 2/17/2003 01:54'!
drawInnerHStrutOn: aCanvas

	| p1 p2 |

	"inner h strut"
	p1 := (self center) - (((self width//4) - (self borderWidth))@0).
	p2 := (self center) + (((self width//4) - (self borderWidth))@0).
	aCanvas line: p1 to: p2 width: (self strutWidth) color: (self strutColor). 

! !

!LayoutControlBrick methodsFor: 'drawing' stamp: 'tb 2/15/2003 03:28'!
drawInnerVSpringOn: aCanvas

	self drawVSpringOn: aCanvas from:((self center) - (0@((self height//4) - (self borderWidth)))) to: (self center).

	self drawVSpringOn: aCanvas from: (self center) to: ((self center) + (0@((self height//4) - (self borderWidth)))).
 
	
! !

!LayoutControlBrick methodsFor: 'drawing' stamp: 'tb 2/17/2003 01:55'!
drawInnerVStrutOn: aCanvas

	| p1 p2 c |

	c := self strutColor.

	"inner v strut"
	p1 := (self center) - (0@((self height//4) - (self borderWidth))).
	p2 := (self center) + (0@((self height//4) - (self borderWidth))).
	aCanvas line: p1 to: p2 width: (self strutWidth) color: c.
	
! !

!LayoutControlBrick methodsFor: 'drawing' stamp: 'tb 4/9/2003 17:18'!
drawOn: aCanvas

	| |
	
	super drawOn: aCanvas.
	aCanvas frameAndFillRectangle: (self bounds insetBy: ((self width // 4)@(self height //4)))
		fillColor: (Color black alpha: 0.2)
		borderWidth: (2@2)
		borderColor: Color black.

	self drawCloseBoxOn: aCanvas.

	self morph leftFixed 
		ifTrue:
		[
			aCanvas line: (self leftCenter + ((self borderWidth)@0)) 
				to: (self leftCenter + ((self width//4)@0)) width: 2 color: (self strutColor).
		]
		ifFalse:
		[
			self drawHSpringOn: aCanvas from: (self leftCenter + ((self borderWidth)@0)) 
				to: (self leftCenter + ((self width//4)@0)). 
		].

	self morph rightFixed
		ifTrue:
		[
			aCanvas line: (self rightCenter - ((self width//4)@0)) 
				to: (self rightCenter - ((self borderWidth)@0)) width: 2 color: (self strutColor).
		]
		ifFalse:
		[
			self drawHSpringOn: aCanvas from: (self rightCenter - ((self width//4)@0)) 
				to: (self rightCenter - ((self borderWidth)@0)).
		].

	self morph topFixed
		ifTrue:
		[
			aCanvas line: (self topCenter + (0@(self borderWidth))) 
				to: (self topCenter + (0@(self height//4))) width: 2 color: (self strutColor).
		]
		ifFalse:
		[
			self drawVSpringOn: aCanvas from:(self topCenter + (0@(self borderWidth))) 
				to: (self topCenter + (0@(self height//4))).
		].

	self morph bottomFixed
		ifTrue:
		[
			aCanvas line: (self bottomCenter - (0@(self height//4))) 
				to: (self bottomCenter - (0@(self borderWidth))) width: 2 color: (self strutColor).
		]
		ifFalse:
		[
			self drawVSpringOn: aCanvas from: (self bottomCenter - (0@(self height//4))) 
				to: (self bottomCenter - (0@(self borderWidth))).
		].

	self morph hResizing == #rigid
		ifTrue:
		[
			self drawInnerHStrutOn: aCanvas.
		]
		ifFalse:
		[	
			self drawInnerHSpringOn: aCanvas.
		].	

	self morph vResizing == #rigid
		ifTrue:
		[
			self drawInnerVStrutOn: aCanvas.
		]
		ifFalse:
		[	
			self drawInnerVSpringOn: aCanvas.
		].! !

!LayoutControlBrick methodsFor: 'drawing' stamp: 'tb 2/17/2003 01:56'!
drawVSpringOn: aCanvas from: p1 to: p2

	| p3 p4 c w |

	c := self springColor.
	w := self springWidth.

	"inner v spring"
	"top nib"
	aCanvas line: p1 to: (p1 + (0@(self height //24 ))) width: w color: c.
	
	"bottom nib"
	aCanvas line: p2 to: (p2 - (0@(self height //24 ))) width: w color: c. 
	
	"upper center spring"
	p3 := (p1 + (0@(self height //24 ))).
	p4 :=  (p1 + (0@((self height //24 ))) + ((self width // 24)@((self height // 24))-(0@(self height //48 )))).	
	aCanvas line: p3 to: p4 width: w color: c.
	
	p3 := p4.
	p4 := (p4 + ((0-(self width//12))@(self height//24))).
	aCanvas line: p3 to: p4 width: w color: c.
	
	p3 := p4.
	p4 := (p4 + (((self width//12))@(self height//24))).
	aCanvas line: p3 to: p4 width: w color: c.
	 
	p3 := p4.
	p4 := (p4 + ((0-(self width//12))@(self height//24))).
	aCanvas line: p3 to: p4 width: w color: c.

	p3 := p4.
	p4 := (p2 - (0@(self height // 24))).
	aCanvas line: p3 to: p4 width: w color: c.

! !

!LayoutControlBrick methodsFor: 'event handling' stamp: 'tb 2/15/2003 04:09'!
handlesMouseDown: evt

	^true! !

!LayoutControlBrick methodsFor: 'event handling' stamp: 'tb 3/9/2003 20:00'!
mouseDown: evt

	| p |

	p := evt position.

	(self closeBoxBounds containsPoint: p) ifTrue: 
	[
		self morph updateLayoutProperties.
		self delete
	].

	((self bounds insetBy: ((self width // 4)@(self height //4))) containsPoint: p)
		ifTrue:
		[
			| p1 p2 |
			"skip clicks in the middle"
			p1 := (self center) - ((self width//24)@(self height//24)).
			p2 := (self center) +	((self width//24)@(self height//24)).		
 			((p1 corner: p2) containsPoint: p) ifTrue: [^self].
			
			"horizontal"
			(((self leftCenter) - (0@(self height//24)) 
				corner: ((self rightCenter) + (0@(self height//24)))) containsPoint: p)
			ifTrue: 
			[
				self morph hResizing = #rigid 
				ifTrue: [self morph hResizing: #spaceFill]
				ifFalse: [self morph hResizing: #rigid].
				self changed. 
			].
			"vertical"
			((((self topCenter) - ((self width//24)@0)) 
				corner: (((self bottomCenter) + ((self width//24)@0)))) containsPoint: p)
			ifTrue: 
			[
				self morph vResizing == #rigid 
				ifTrue: [self morph vResizing: #spaceFill]
				ifFalse: [self morph vResizing: #rigid].
				self changed. 
			].
		]
		ifFalse:
		[
			| p1 p2 |
			p1 := self leftCenter - (0@(self height//24)).
			p2 := self leftCenter + ((self width//4)@(self height//24)).
			((p1 corner: p2) containsPoint: p) 
				ifTrue: [ self morph leftFixed: (self morph leftFixed not). 
							self changed. ].

			p1 := self rightCenter - ((self width//4)@(self height//24)).
			p2 := self rightCenter + (0@(self height//24)).
			((p1 corner: p2) containsPoint: p) 
				ifTrue: [ self morph rightFixed: (self morph rightFixed not).
	 						self changed. ].

			p1 := self topCenter - ((self width//24)@0).
			p2 := self topCenter + ((self width//24)@(self height//4)).
			((p1 corner: p2) containsPoint: p) 
				ifTrue: [ self morph topFixed:(self morph topFixed not). 
							self changed. ].

			p1 := self bottomCenter - ((self width//24)@(self height//4)).
			p2 := self bottomCenter + ((self width//24)@0).
			((p1 corner: p2) containsPoint: p) 
				ifTrue: [ self morph bottomFixed: (self morph bottomFixed not). 
							self changed. ].

		]
	! !

!LayoutControlBrick methodsFor: 'initialization' stamp: 'tb 4/9/2003 17:26'!
initialize

	super initialize.
	bounds := ( 20@20 corner: 100@100).
	self strutColor: Color gray darker.
	self springColor: Color gray darker.

	self addPainter: (BackgroundPainter color: #stainless).
	self addPainter: (BorderPainter raised).
	self addPainter: self. "We want to do some painting in drawOn:"
! !


!LayoutControlBrick class methodsFor: 'instance creation' stamp: 'tb 2/19/2003 21:17'!
on: aMorph

	^super new morph: aMorph! !


!PSlider methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:59'!
computeSlider
	| r |
	r _ self roomToMove.
	self descending
		ifFalse:
			[slider position: (bounds isWide
				ifTrue: [r topLeft + ((r width * value) asInteger @ 0)]
				ifFalse: [r topLeft + (0 @ (r height * value)  asInteger)])]
		ifTrue:
			[slider position: (bounds isWide
				ifTrue:	[r bottomRight - ((r width * value) asInteger @ 0)]
				ifFalse:	[r bottomRight - ((0 @ (r height * value) asInteger))])].
	slider extent: self sliderExtent! !

!PSlider methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:59'!
extent: newExtent
	newExtent = bounds extent ifTrue: [^ self].
	bounds isWide
		ifTrue: [super extent: (newExtent x max: self sliderThickness * 2) @ newExtent y]
		ifFalse: [super extent: newExtent x @ (newExtent y max: self sliderThickness * 2)].
	self removeAllMorphs; initializeSlider! !

!PSlider methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:59'!
roomToMove
	^ self totalSliderArea insetBy: (0@0 extent: self sliderExtent)! !

!PSlider methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:59'!
sliderExtent
	^ bounds isWide
		ifTrue: [self sliderThickness @ self innerBounds height]
		ifFalse: [self innerBounds width @ self sliderThickness]! !

!PSlider methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:59'!
sliderThickness
	^ 7! !

!PSlider methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:59'!
totalSliderArea
	^ self innerBounds! !

!PSlider methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:59'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ #inset! !

!PSlider methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:59'!
defaultBorderWidth
	"answer the default border width for the receiver"
	^ 1! !

!PSlider methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:59'!
defaultBounds 
	^ 0 @ 0 corner: 16 @ 100! !

!PSlider methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:59'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color lightGray! !

!PSlider methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:59'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	value _ 0.0.
	descending _ false.
	self initializeSlider! !

!PSlider methodsFor: 'access' stamp: 'tb 3/8/2003 17:59'!
descending
	^ descending == true! !

!PSlider methodsFor: 'access' stamp: 'tb 3/8/2003 17:59'!
descending: aBoolean
	descending _ aBoolean.
	self value: value! !

!PSlider methodsFor: 'access' stamp: 'tb 3/8/2003 17:59'!
pagingArea
	^self! !

!PSlider methodsFor: 'access' stamp: 'tb 3/8/2003 17:59'!
sliderColor
	"color scheme for the whole slider widget"
	sliderColor ifNil: [^ (color alphaMixed: 0.7 with: Color white) slightlyLighter].
	^ sliderColor! !

!PSlider methodsFor: 'access' stamp: 'tb 3/8/2003 17:59'!
sliderColor: newColor

	sliderColor _ newColor.
	slider ifNotNil: [slider color: sliderColor]! !

!PSlider methodsFor: 'access' stamp: 'tb 3/8/2003 17:59'!
sliderShadowColor
	^ self sliderColor alphaMixed: 0.2 with: self pagingArea color! !

!PSlider methodsFor: 'access' stamp: 'tb 3/8/2003 17:59'!
thumbColor
	"Color of the draggable 'thumb'"
	^ self sliderColor! !

!PSlider methodsFor: 'access' stamp: 'tb 3/8/2003 17:59'!
wantsSlot
	"For now do it the old way, until we sort this out"
	^ true! !

!PSlider methodsFor: 'initialize' stamp: 'tb 3/15/2003 13:09'!
initializeSlider
	slider := PRectangleMorph newBounds: self totalSliderArea color: self thumbColor.
	sliderShadow := RectangleMorph newBounds: self totalSliderArea
						color: self pagingArea color.
	slider on: #mouseMove send: #scrollAbsolute: to: self.
	slider on: #mouseDown send: #mouseDownInSlider: to: self.
	slider on: #mouseUp send: #mouseUpInSlider: to: self.
	slider borderWidth: 1; borderColor: #raised.
	sliderShadow borderWidth: 1; borderColor: #inset.
	"(the shadow must have the pagingArea as its owner to highlight properly)"
	self pagingArea addMorph: sliderShadow.
	sliderShadow hide.
	self addMorph: slider.
	self computeSlider.
! !

!PSlider methodsFor: 'other events' stamp: 'tb 3/8/2003 17:59'!
mouseDownInSlider: event
	slider color: self thumbColor slightlyWhiter.
	sliderShadow color: self sliderShadowColor.
	sliderShadow cornerStyle: slider cornerStyle.
	sliderShadow bounds: slider bounds.
	sliderShadow show.
! !

!PSlider methodsFor: 'other events' stamp: 'tb 3/8/2003 17:59'!
mouseUpInSlider: event
	slider color: self thumbColor.
	sliderShadow hide.! !

!PSlider methodsFor: 'scrolling' stamp: 'tb 3/8/2003 17:59'!
scrollAbsolute: event
	| r p |
	r _ self roomToMove.
	bounds isWide
		ifTrue: [r width = 0 ifTrue: [^ self]]
		ifFalse: [r height = 0 ifTrue: [^ self]].
	p _ event targetPoint adhereTo: r.
	self descending
		ifFalse:
			[self setValue: (bounds isWide 
				ifTrue: [(p x - r left) asFloat / r width]
				ifFalse: [(p y - r top) asFloat / r height])]
		ifTrue:
			[self setValue: (bounds isWide
				ifTrue: [(r right - p x) asFloat / r width]
				ifFalse:	[(r bottom - p y) asFloat / r height])]! !

!PSlider methodsFor: 'model access' stamp: 'tb 3/8/2003 17:59'!
setValue: newValue
	"Called internally for propagation to model"
	self value: newValue.
	self use: setValueSelector orMakeModelSelectorFor: 'Value:'
		in: [:sel | setValueSelector _ sel.  model perform: sel with: value]! !

!PSlider methodsFor: 'model access' stamp: 'tb 3/8/2003 17:59'!
value: newValue
	"Drive the slider position externally..."
	value _ newValue min: 1.0 max: 0.0.
	self computeSlider! !


!PScrollBar methodsFor: 'accessing' stamp: 'tb 3/8/2003 18:00'!
adoptPaneColor: aColor
	"Adopt the given pane color"
	self alternativeScrollbarLook ifFalse:[^self].
	aColor ifNil:[^self].
	self sliderColor: aColor.! !

!PScrollBar methodsFor: 'access' stamp: 'tb 3/8/2003 18:00'!
alternativeScrollbarLook
	^Preferences alternativeScrollbarLook! !

!PScrollBar methodsFor: 'access' stamp: 'tb 3/8/2003 18:00'!
interval: d
	"Supply an optional floating fraction so slider can expand to indicate range"
	interval _ d min: 1.0.
	self expandSlider.
	self computeSlider.! !

!PScrollBar methodsFor: 'access' stamp: 'tb 3/8/2003 18:00'!
pagingArea
	^pagingArea! !

!PScrollBar methodsFor: 'access' stamp: 'tb 3/8/2003 18:00'!
roundedScrollbarLook
	"Rounded look currently only shows up in flop-out mode"
	^Preferences alternativeScrollbarLook and: [Preferences inboardScrollbars not and: [self class alwaysShowFlatScrollbarForAlternativeLook not]]
! !

!PScrollBar methodsFor: 'access' stamp: 'tb 3/8/2003 18:00'!
scrollDelta
	^ scrollDelta! !

!PScrollBar methodsFor: 'access' stamp: 'tb 3/8/2003 18:00'!
scrollDelta: d1 pageDelta: d2
	"Supply optional increments for better scrolling of, eg, text"
	scrollDelta _ d1.
	pageDelta _ d2.! !

!PScrollBar methodsFor: 'access' stamp: 'tb 3/8/2003 18:00'!
sliderColor: aColor
	"Change the color of the scrollbar to go with aColor."
	| buttonColor |
	super sliderColor: aColor.
	buttonColor _ self thumbColor.
	menuButton ifNotNil: [menuButton color: buttonColor].
	upButton color: buttonColor.
	downButton color: buttonColor.
	slider color: buttonColor.
	self alternativeScrollbarLook ifTrue:
		[self roundedScrollbarLook
			ifTrue:
				[self color: Color transparent.
				pagingArea color: aColor muchLighter.
				self borderStyle style == #simple 
					ifTrue:[self borderColor: aColor darker darker]
					ifFalse:[self borderStyle baseColor: aColor]]
			ifFalse:
				[pagingArea color: (aColor alphaMixed: 0.3 with: Color white).
				self borderWidth: 0]]
! !

!PScrollBar methodsFor: 'access' stamp: 'tb 3/8/2003 18:00'!
sliderShadowColor
	^ self roundedScrollbarLook
		ifTrue: [self sliderColor darker]
		ifFalse: [super sliderShadowColor]
! !

!PScrollBar methodsFor: 'access' stamp: 'tb 3/8/2003 18:00'!
thumbColor
	"Problem: Part of the ScrollBar/Slider code uses 'slider' to mean the entire scrollbar/slider widget, and part of it uses 'slider' to mean only the draggable 'thumb'.  This should be cleaned up so that 'thumb' is used instead of 'slider' where appropriate.  For now, the meaning of thumbColor is clear, at least."

	^ self alternativeScrollbarLook 
		ifTrue: [self sliderColor alphaMixed: 0.7 with: (Color gray: 0.95)]
		ifFalse: [Color veryLightGray]! !

!PScrollBar methodsFor: 'geometry' stamp: 'tb 3/8/2003 18:00'!
buttonExtent
	^ bounds isWide
		ifTrue: [11 @ self innerBounds height]
		ifFalse: [self innerBounds width @ 11]! !

!PScrollBar methodsFor: 'geometry' stamp: 'tb 3/8/2003 18:00'!
expandSlider
	"Compute the new size of the slider (use the old sliderThickness as a minimum)."
	| r |
	r _ self totalSliderArea.
	slider extent: (bounds isWide
		ifTrue: [((r width * interval) asInteger max: self sliderThickness) @ slider height]
		ifFalse: [slider width @ ((r height * interval) asInteger max: self sliderThickness)])! !

!PScrollBar methodsFor: 'geometry' stamp: 'tb 3/8/2003 18:00'!
extent: p
        p x > p y
                ifTrue: [super extent: (p max: 42@8)]
                ifFalse: [super extent: (p max: 8@42)]! !

!PScrollBar methodsFor: 'geometry' stamp: 'tb 3/8/2003 18:00'!
sliderExtent
	"The sliderExtent is now stored in the slider itself, not hardcoded as it is in the superclass."
	^slider extent! !

!PScrollBar methodsFor: 'geometry' stamp: 'tb 3/8/2003 18:00'!
sliderThickness
	^ self roundedScrollbarLook ifTrue:[15] ifFalse:[super sliderThickness]! !

!PScrollBar methodsFor: 'geometry' stamp: 'tb 3/8/2003 18:00'!
totalSliderArea
	| upperBoundsButton |
	upperBoundsButton _ menuButton ifNil: [upButton].
	upButton bottom > upperBoundsButton bottom
		ifTrue: [upperBoundsButton _ upButton].
	^ bounds isWide
		ifTrue: [upperBoundsButton bounds topRight corner: downButton bounds bottomLeft]
		ifFalse: [upperBoundsButton bounds bottomLeft corner: downButton bounds topRight].
! !

!PScrollBar methodsFor: 'as yet unclassified' stamp: 'tb 3/8/2003 18:00'!
cachedImageAt: aKey ifAbsentPut: aBlock

	CachedImages ifNil: [CachedImages _ Dictionary new].
	^CachedImages at: aKey ifAbsentPut: aBlock! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
doScrollByPage
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 300 delay2: 100) ifFalse: [^ self].
	nextPageDirection
		ifTrue: [self setValue: (value + pageDelta min: 1.0)]
		ifFalse: [self setValue: (value - pageDelta max: 0.0)]
! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
doScrollDown
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value + scrollDelta + 0.000001 min: 1.0)! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
doScrollUp
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value - scrollDelta - 0.000001 max: 0.0)! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
finishedScrolling
	self stopStepping.
	self scrollBarAction: nil.
	self roundedScrollbarLook ifTrue:[
		upButton borderStyle: (BorderStyle complexRaised width: upButton borderWidth).
		downButton borderStyle: (BorderStyle complexRaised width: downButton borderWidth).
	] ifFalse:[
		downButton borderRaised.
		upButton borderRaised.
	].

! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
scrollBarAction
	^self valueOfProperty: #scrollBarAction! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
scrollBarAction: aSymbol
	self setProperty: #scrollBarAction toValue: aSymbol! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
scrollDown
	self flag: #obsolete.
	downButton eventHandler: nil.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollDownInit! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
scrollDown: count
	self setValue: (value + (scrollDelta * count) + 0.000001 min: 1.0)! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
scrollDownInit
	downButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
scrollPageInit: evt
	self resetTimer.
	self setNextDirectionFromEvent: evt.
	self scrollBarAction: #doScrollByPage.
	self startStepping.! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
scrollUp
	self flag: #obsolete.
	upButton eventHandler: nil.
	upButton on: #mouseDown send: #scrollUpInit to: self.
	upButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollUpInit! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
scrollUp: count
	self setValue: (value - (scrollDelta * count) - 0.000001 max: 0.0)! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
scrollUpInit
	upButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.! !

!PScrollBar methodsFor: 'scrolling' stamp: 'tb 3/8/2003 18:00'!
setNextDirectionFromEvent: event

	nextPageDirection _ bounds isWide ifTrue: [
		event cursorPoint x >= slider center x
	]
	ifFalse: [
		event cursorPoint y >= slider center y
	]

! !

!PScrollBar methodsFor: 'initialization' stamp: 'tb 3/8/2003 18:00'!
initialize
	super initialize.
	scrollDelta _ 0.02.
	pageDelta _ 0.2.
	self roundedScrollbarLook ifTrue:[
		self borderStyle: ((BorderStyle complexFramed width: 2) "baseColor: Color gray")].! !

!PScrollBar methodsFor: 'initialize' stamp: 'tb 3/15/2003 13:07'!
initializeDownButton
	downButton := PRectangleMorph
		newBounds: (self innerBounds bottomRight - self buttonExtent extent: self buttonExtent)
		color: self thumbColor.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	downButton addMorphCentered: (ImageMorph new image: 
		(self 
			cachedImageAt: (bounds isWide ifTrue: ['right'] ifFalse: ['down']) 
			ifAbsentPut: [
				self upArrow8Bit
					rotateBy: (bounds isWide ifTrue: [#right] ifFalse: [#pi])
					centerAt: 0@0
			]
		)
	).
	self roundedScrollbarLook ifTrue:[
		downButton color: Color veryLightGray.
		downButton borderStyle: (BorderStyle complexRaised width: 3).
	] ifFalse:[
		downButton borderWidth: 1; borderColor: #raised.
	].
	self addMorph: downButton.
! !

!PScrollBar methodsFor: 'initialize' stamp: 'tb 3/8/2003 18:00'!
initializeEmbedded: aBool
	"aBool == true => inboard scrollbar
	aBool == false => flop-out scrollbar"
	self roundedScrollbarLook ifFalse:[^self].
	aBool ifTrue:[
		self borderStyle: (BorderStyle inset width: 2).
		self cornerStyle: #square.
	] ifFalse:[
		self borderStyle: (BorderStyle width: 1 color: Color black).
		self cornerStyle: #rounded.
	].
	self removeAllMorphs.
	self initializeSlider.! !

!PScrollBar methodsFor: 'initialize' stamp: 'tb 3/15/2003 13:07'!
initializeMenuButton
	"Preferences disable: #scrollBarsWithoutMenuButton"

	"Preferences enable: #scrollBarsWithoutMenuButton"

	(Preferences valueOfFlag: #scrollBarsWithoutMenuButton) ifTrue: [^self].
	menuButton := self roundedScrollbarLook 
		ifTrue: 
			[PRectangleMorph 
						newBounds: ((bounds isWide 
								ifTrue: [upButton bounds topRight]
								ifFalse: [upButton bounds bottomLeft]) extent: self buttonExtent)]
		ifFalse: 
			[PRectangleMorph 
						newBounds: (self innerBounds topLeft extent: self buttonExtent)
						color: self thumbColor].
	menuButton 
		on: #mouseEnter
		send: #menuButtonMouseEnter:
		to: self.
	menuButton 
		on: #mouseDown
		send: #menuButtonMouseDown:
		to: self.
	menuButton 
		on: #mouseLeave
		send: #menuButtonMouseLeave:
		to: self.
	menuButton 
		addMorphCentered: (PRectangleMorph newBounds: (0 @ 0 extent: 4 @ 2)
				color: Color black).
	self roundedScrollbarLook 
		ifTrue: 
			[menuButton color: Color veryLightGray.
			menuButton borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [menuButton borderWidth: 1; borderColor: #raised].
	self addMorph: menuButton! !

!PScrollBar methodsFor: 'initialize' stamp: 'tb 3/8/2003 18:12'!
initializePagingArea
	pagingArea := PRectangleMorph newBounds: self totalSliderArea
								color: (Color r: 0.6 g: 0.6 b: 0.8).
	pagingArea borderWidth: 0.
	pagingArea on: #mouseDown send: #scrollPageInit: to: self.
	pagingArea on: #mouseUp send: #finishedScrolling to: self.
	self addMorph: pagingArea.
	self roundedScrollbarLook 
		ifTrue:[pagingArea color: (Color gray: 0.9)].! !

!PScrollBar methodsFor: 'initialize' stamp: 'tb 3/8/2003 18:00'!
initializeSlider
	self roundedScrollbarLook ifTrue:[
		self 
			initializeUpButton;
			initializeMenuButton;
			initializeDownButton;
			initializePagingArea.
	] ifFalse:[
		self initializeMenuButton; 
			initializeUpButton; 
			initializeDownButton; 
			initializePagingArea.
	].
	super initializeSlider.
	self roundedScrollbarLook ifTrue:[
		slider cornerStyle: #rounded.
		slider borderStyle: (BorderStyle complexRaised width: 3).
		sliderShadow cornerStyle: #rounded.
	].
	self sliderColor: self sliderColor.! !

!PScrollBar methodsFor: 'initialize' stamp: 'tb 3/15/2003 13:07'!
initializeUpButton
	upButton := self roundedScrollbarLook 
				ifTrue:  
					[PRectangleMorph 
						newBounds: (self innerBounds topLeft extent: self buttonExtent)]
				ifFalse: 
					[PRectangleMorph 
						newBounds: ((menuButton ifNil: [self innerBounds topLeft]
								ifNotNil: 
									[bounds isWide 
										ifTrue: [menuButton bounds topRight]
										ifFalse: [menuButton bounds bottomLeft]]) 
									extent: self buttonExtent)].
	upButton color: self thumbColor.
	upButton 
		on: #mouseDown
		send: #scrollUpInit
		to: self.
	upButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	upButton 
		addMorphCentered: (ImageMorph new image: (self 
						cachedImageAt: (bounds isWide ifTrue: ['left'] ifFalse: ['up'])
						ifAbsentPut: 
							[bounds isWide 
								ifTrue: [self upArrow8Bit rotateBy: #left centerAt: 0 @ 0]
								ifFalse: [self upArrow8Bit]])).
	self roundedScrollbarLook 
		ifTrue: 
			[upButton color: Color veryLightGray.
			upButton borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [upButton borderWidth: 1; borderColor: #raised].
	self addMorph: upButton! !

!PScrollBar methodsFor: 'initialize' stamp: 'tb 3/8/2003 18:00'!
upArrow8Bit

	"convert to 8-bit and convert white to transparent to avoid gratuitous conversion every time we put one in an ImageMorph"

	^UpArrow8Bit ifNil: [
		UpArrow8Bit _ (ColorForm mappingWhiteToTransparentFrom: UpArrow) asFormOfDepth: 8
	]! !

!PScrollBar methodsFor: 'other events' stamp: 'tb 3/8/2003 18:00'!
menuButtonMouseDown: event
	event hand showTemporaryCursor: nil.
	self use: menuSelector orMakeModelSelectorFor: 'MenuButtonPressed:'
		in: [:sel | menuSelector _ sel.  model perform: sel with: event]! !

!PScrollBar methodsFor: 'other events' stamp: 'tb 3/8/2003 18:00'!
mouseDownInSlider: event
	interval = 1.0 ifTrue:
		["make the entire scrollable area visible if a full scrollbar is clicked on"
		self setValue: 0.
		self model hideOrShowScrollBar].
	super mouseDownInSlider: event! !

!PScrollBar methodsFor: 'scroll timing' stamp: 'tb 3/8/2003 18:00'!
resetTimer
	timeOfMouseDown _ Time millisecondClockValue.
	timeOfLastScroll _ timeOfMouseDown - 1000 max: 0.
	nextPageDirection _ nil.
	currentScrollDelay _ nil! !

!PScrollBar methodsFor: 'scroll timing' stamp: 'tb 3/8/2003 18:00'!
waitForDelay1: delay1 delay2: delay2 
	"Return true if an appropriate delay has passed since the last scroll operation.
	The delay decreases exponentially from delay1 to delay2."

	| now scrollDelay |
	timeOfLastScroll isNil ifTrue: [self resetTimer].	"Only needed for old instances"
	now := Time millisecondClockValue.
	(scrollDelay := currentScrollDelay) isNil 
		ifTrue: [scrollDelay := delay1	"initial delay"].
	currentScrollDelay := scrollDelay * 9 // 10 max: delay2.	"decrease the delay"
	timeOfLastScroll := now.
	^true! !

!PScrollBar methodsFor: 'model access' stamp: 'tb 3/8/2003 18:00'!
setValue: newValue
	"Using roundTo: instead of truncateTo: ensures that scrollUp will scroll the same distance as scrollDown."
	^ super setValue: (newValue roundTo: scrollDelta)! !

!PScrollBar methodsFor: 'stepping and presenter' stamp: 'tb 3/8/2003 18:00'!
step
	| action |
	action _ self scrollBarAction.
	action ifNotNil:[self perform: action].! !

!PScrollBar methodsFor: 'testing' stamp: 'tb 3/8/2003 18:00'!
stepTime
	^ currentScrollDelay ifNil: [300]! !

!PScrollBar methodsFor: 'testing' stamp: 'tb 3/8/2003 18:00'!
wantsSteps
	^self scrollBarAction notNil! !


!PSlider class methodsFor: 'new-morph participation' stamp: 'tb 3/8/2003 17:59'!
includeInNewMorphMenu
	"OK to instantiate"
	^ true! !


!PScrollBar class methodsFor: 'as yet unclassified' stamp: 'tb 3/8/2003 18:00'!
alwaysShowFlatScrollbarForAlternativeLook
	"Set this value to true, if you want to see the flat scrollbar look in flop-out mode as well as inboard.  Otherwise the flop-out scrollbar will be rounded and inboard will be flat."
	^ false! !

!PScrollBar class methodsFor: 'class initialization' stamp: 'tb 3/8/2003 18:00'!
initialize "ScrollBar initialize"

	UpArrow _ Form
		extent: 6@3
		fromArray: #(2r11e28 2r1111e27 2r111111e26)
		offset: 0@0.! !


!Painter methodsFor: 'layer' stamp: 'tb 3/17/2003 02:09'!
defaultLayer

	^self class defaultLayer! !

!Painter methodsFor: 'painting' stamp: 'tb 3/16/2003 18:18'!
didPaintBrick: aBrick onCanvas: aCanvas

	"Do cleaning up here"! !

!Painter methodsFor: 'painting' stamp: 'tb 3/16/2003 12:44'!
paintBrick: aBrick onCanvas: aCanvas

	self subclassResponsibility! !

!Painter methodsFor: 'painting' stamp: 'tb 3/16/2003 18:18'!
willPaintBrick: aBrick onCanvas: aCanvas

	"Here is your chance to do any preprocessing before drawing begins"! !

!Painter methodsFor: 'geometry' stamp: 'tb 3/17/2003 09:38'!
expandBounds: aRectangle inBrick: aBrick

	^aRectangle! !

!Painter methodsFor: 'caching' stamp: 'tb 3/17/2003 17:13'!
releaseCachedState! !


!BackgroundPainter methodsFor: 'accessing' stamp: 'tb 4/9/2003 17:09'!
defaultFillStyle

	^DefaultFillStyle := Backgrounds at: #brick ifAbsent: [Color red].
	
! !

!BackgroundPainter methodsFor: 'accessing' stamp: 'tb 4/9/2003 17:04'!
fillStyle

	^fillStyle ifNil: 
	[ 
		fillStyle := self defaultFillStyle. 
	] 
	ifNotNil: [fillStyle]! !

!BackgroundPainter methodsFor: 'accessing' stamp: 'tb 3/16/2003 14:57'!
fillStyle: aFillStyleOrColor

	fillStyle := aFillStyleOrColor.! !

!BackgroundPainter methodsFor: 'painting' stamp: 'tb 3/16/2003 17:36'!
paintBrick: aBrick onCanvas: aCanvas

	aCanvas fillRectangle: aBrick bounds fillStyle: self fillStyle.! !


!BorderPainter methodsFor: 'accessing' stamp: 'tb 3/16/2003 17:50'!
borderStyle

	^borderStyle ifNil: [borderStyle := (SimpleBorder new color: Color black) width: 1] ifNotNil: [borderStyle]! !

!BorderPainter methodsFor: 'accessing' stamp: 'tb 3/16/2003 17:32'!
borderStyle: aBorderStyle

	borderStyle := aBorderStyle! !

!BorderPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 00:23'!
width

	^self borderStyle width! !

!BorderPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 00:23'!
width: width

	self borderStyle width: width.! !

!BorderPainter methodsFor: 'painting' stamp: 'tb 3/17/2003 00:21'!
paintBrick: aBrick onCanvas: aCanvas

	| color |

	(self borderStyle isKindOf: ComplexBorder) ifTrue:
	[
		color := aBrick isInWorld
			ifTrue: [ aCanvas form colorAt: (aBrick pointInWorld: aBrick referencePosition) ]
			ifFalse: [ Color gray ].
		self borderStyle color = color ifFalse:
		[
			self borderStyle releaseCachedState.
			self borderStyle color: color.
		]
	].
	self borderStyle frameRectangle: aBrick bounds on: aCanvas! !


!CornerPainter methodsFor: 'accessing' stamp: 'tb 3/16/2003 18:48'!
borderWidth

	^borderWidth! !

!CornerPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 01:20'!
cornerRounder

	^rounder! !

!CornerPainter methodsFor: 'accessing' stamp: 'tb 3/16/2003 18:43'!
cornersToRound

	^cornersToRound ifNil: [ cornersToRound := #( 1 2 3 4 ) "all corners" ] ifNotNil: [ cornersToRound]! !

!CornerPainter methodsFor: 'accessing' stamp: 'tb 3/16/2003 19:33'!
cornersToRound: anArray

	cornersToRound := anArray! !

!CornerPainter methodsFor: 'painting' stamp: 'tb 3/16/2003 18:46'!
didPaintBrick: aBrick onCanvas: aCanvas

	rounder := nil.
	! !

!CornerPainter methodsFor: 'painting' stamp: 'tb 3/17/2003 03:09'!
paintBrick: aBrick onCanvas: aCanvas

	rounder ifNotNil: [
	rounder tweakCornersOf: aBrick on: aCanvas in: aBrick bounds borderWidth: self borderWidth corners: self cornersToRound]! !

!CornerPainter methodsFor: 'painting' stamp: 'tb 4/9/2003 15:26'!
willPaintBrick: aBrick onCanvas: aCanvas

	"Get a rounder set up based on the border width"

	| borderPainter |

	borderWidth := 0.
	borderPainter := aBrick painterAtLayer: Painter borderLayer.

	borderWidth := (borderPainter notNil) 
		ifTrue: [ borderPainter borderStyle width. ]
		ifFalse: [ 0 ].

	rounder := CornerRounder forWidth: borderWidth.	
	rounder saveBitsUnderCornersOf: aBrick on: aCanvas in: aBrick bounds corners: self cornersToRound.
! !


!HilightPainter methodsFor: 'accessing' stamp: 'tb 4/10/2003 16:21'!
bounds

	^bounds! !

!HilightPainter methodsFor: 'accessing' stamp: 'tb 4/10/2003 16:21'!
bounds: aRect

	bounds := aRect.! !

!HilightPainter methodsFor: 'accessing' stamp: 'tb 4/10/2003 16:17'!
color

	^color ifNil: 
	[ 
		color := self defaultColor. 
	] 
	ifNotNil: [color]! !

!HilightPainter methodsFor: 'accessing' stamp: 'tb 4/10/2003 16:17'!
color: aColor

	color := aColor.! !

!HilightPainter methodsFor: 'accessing' stamp: 'tb 4/10/2003 17:56'!
defaultColor

	^Color gray alpha: 0.4
	
! !

!HilightPainter methodsFor: 'painting' stamp: 'tb 4/10/2003 16:23'!
paintBrick: aBrick onCanvas: aCanvas

	aCanvas fillRectangle: (self bounds translateBy: (aBrick position)) fillStyle: self color.! !


!Painter class methodsFor: 'layerNumbers' stamp: 'tb 3/16/2003 17:05'!
backgroundLayer

	^100! !

!Painter class methodsFor: 'layerNumbers' stamp: 'tb 3/16/2003 17:06'!
borderLayer

	^200! !

!Painter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 12:32'!
brickLayer

	"when the brick's drawOn: gets called".

	^1000! !

!Painter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 17:17'!
canvasLayer

	^0! !

!Painter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 18:01'!
cornerLayer

	"This thing wants to do its thing last".

	^10000! !

!Painter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 00:26'!
defaultLayer

	self subclassResponsibility! !

!Painter class methodsFor: 'layerNumbers' stamp: 'tb 4/10/2003 16:13'!
hilightLayer

	"Pretty late - for painting color washes to show hilighting".

	^9000! !

!Painter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 10:13'!
rolloverBorderLayer

	^-300! !

!Painter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 10:13'!
shadowLayer

	^-500! !

!Painter class methodsFor: 'class initialization' stamp: 'tb 4/29/2003 16:42'!
initialize

	Backgrounds := Dictionary new.
! !

!Painter class methodsFor: 'images' stamp: 'tb 4/29/2003 20:47'!
at: aSymbol putInfiniteForm: anInfiniteForm

	Backgrounds at: aSymbol put: anInfiniteForm! !


!BackgroundPainter class methodsFor: 'instance creation' stamp: 'tb 3/18/2003 14:06'!
color: aColor

	^self new fillStyle: (Backgrounds at: aColor ifAbsent: [aColor])! !

!BackgroundPainter class methodsFor: 'instance creation' stamp: 'tb 3/18/2003 14:07'!
fillStyle: aColor

	^self new fillStyle: (Backgrounds at: aColor ifAbsent: [aColor])! !

!BackgroundPainter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 00:29'!
defaultLayer

	^self backgroundLayer! !


!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:43'!
color: aColor 

	| style |

	style := BorderStyle color: aColor width: 1.
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:39'!
color: aColor width: aWidth

	| style |

	style := BorderStyle color: aColor width: aWidth.
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:38'!
complexAltFramed

	| style |

	style := BorderStyle complexAltFramed width: 2.
	style color: (Color gray).
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:37'!
complexAltInset

	| style |

	style := BorderStyle complexAltInset width: 2.
	style color: (Color gray).
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:35'!
complexAltRaised

	| style |

	style := BorderStyle complexAltRaised width: 2.
	style color: (Color gray).
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 4/10/2003 00:12'!
complexFramed

	| style |

	style := BorderStyle complexFramed width: 2.
	style color: (Color gray).
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:22'!
complexInset

	| style |

	style := BorderStyle complexInset width: 2.
	style color: (Color gray).
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:30'!
complexRaised

	| style |

	style := BorderStyle complexRaised width: 2.
	style color: (Color gray).
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:33'!
etched

	| style |

	style := BorderStyle complexAltFramed width: 2.
	style color: (Color gray).
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/18/2003 18:20'!
inset

	| style |

	style := BorderStyle inset width: 2.
	style color: (Color black alpha: 0.7).
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 4/29/2003 22:52'!
openToolBar

| toolbar |
toolbar := ToolbarBrick new extent: 320@47.
toolbar inset: 8.
toolbar addPainter: (BackgroundPainter color: (Color tan)).
toolbar addPainter: (BorderPainter raised).
toolbar addMorph: (DragPainterBrick painter: (BorderPainter simple)).
toolbar addMorph: (DragPainterBrick painter: (BorderPainter raised)).
toolbar addMorph: (DragPainterBrick painter: (BorderPainter inset)).
toolbar addMorph: (DragPainterBrick painter: (BorderPainter complexRaised)).
toolbar addMorph: (DragPainterBrick painter: (BorderPainter complexInset)).
toolbar addMorph: (DragPainterBrick painter: (BorderPainter complexFramed)).
toolbar addMorph: (DragPainterBrick painter: (BorderPainter complexAltRaised)).
toolbar addMorph: (DragPainterBrick painter: (BorderPainter complexAltInset)).
toolbar addMorph: (DragPainterBrick painter: (BorderPainter complexAltFramed)).
toolbar addMorph: (DragPainterBrick unPainter: (BorderPainter color: (Color red) width: 4)).
toolbar sizeToFit.
toolbar position: (2@2).
^toolbar openInWorld.! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 4/10/2003 15:14'!
openToolBar2

| toolbar1 toolbar2 toolbar |
toolbar1 := ToolbarBrick new extent: 320@47.
toolbar1 inset: 8.
toolbar1 removePainter: BackgroundPainter.
toolbar1 removePainter: BorderPainter.

toolbar2 := ToolbarBrick new extent: 320@47.
toolbar2 inset: 8.
toolbar2 removePainter: BackgroundPainter.
toolbar2  removePainter: BorderPainter.

toolbar1 addMorph: (DragPainterBrick painter: (BorderPainter simple)).
toolbar1 addMorph: (DragPainterBrick painter: (BorderPainter raised)).
toolbar1 addMorph: (DragPainterBrick painter: (BorderPainter inset)).
toolbar1 addMorph: (DragPainterBrick painter: (BorderPainter complexRaised)).
toolbar1 addMorph: (DragPainterBrick painter: (BorderPainter complexInset)).
toolbar2 addMorph: (DragPainterBrick painter: (BorderPainter complexFramed)).
toolbar2 addMorph: (DragPainterBrick painter: (BorderPainter complexAltRaised)).
toolbar2 addMorph: (DragPainterBrick painter: (BorderPainter complexAltInset)).
toolbar2 addMorph: (DragPainterBrick painter: (BorderPainter complexAltFramed)).
toolbar2 addMorph: (DragPainterBrick unPainter: (BorderPainter color: (Color red) width: 4)).

toolbar1 sizeToFit.
toolbar2 sizeToFit.

toolbar := ToolbarBrick new extent: ((toolbar1 width)@(toolbar1 height * 2)).
toolbar inset: 0.
toolbar addPainter: (BackgroundPainter color: (Color tan)).
toolbar addPainter: (BorderPainter etched).
toolbar beVertical.
toolbar addMorph: toolbar1; addMorph: toolbar2.
toolbar sizeToFit.
toolbar openInWorld.! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/18/2003 18:21'!
raised

	| style |

	style := BorderStyle raised width: 2.
	style color: (Color black alpha: 0.4).
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:44'!
simple

	^self new.! !

!BorderPainter class methodsFor: 'instance creation' stamp: 'tb 3/17/2003 00:43'!
width: aWidth

	| style |

	style := BorderStyle color: Color black width: aWidth.
	^(self new borderStyle: style).! !

!BorderPainter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 00:28'!
defaultLayer

	^self borderLayer! !


!CornerPainter class methodsFor: 'instance creation' stamp: 'tb 3/16/2003 19:41'!
bottomCorners

	^(self new) cornersToRound: #(2 3)! !

!CornerPainter class methodsFor: 'instance creation' stamp: 'tb 4/10/2003 00:21'!
bottomLeft

	^(self new) cornersToRound: #(2)! !

!CornerPainter class methodsFor: 'instance creation' stamp: 'tb 4/10/2003 00:21'!
bottomRight

	^(self new) cornersToRound: #(3)! !

!CornerPainter class methodsFor: 'instance creation' stamp: 'tb 3/16/2003 19:41'!
leftCorners

	^(self new) cornersToRound: #(1 2)! !

!CornerPainter class methodsFor: 'instance creation' stamp: 'tb 4/29/2003 22:54'!
openToolBar

| toolbar holder |
toolbar := ToolbarBrick new extent: 320@47.
toolbar inset: 8.
toolbar addPainter: (BackgroundPainter color: Color tan).
toolbar addPainter: (BorderPainter raised).

holder := (DragPainterBrick painter: (CornerPainter new)).
holder addPainter: (BackgroundPainter color: (Color gray alpha: 0.7)).
toolbar addMorph: holder.

holder := (DragPainterBrick unPainter: (CornerPainter new cornersToRound: #())).
holder addPainter: (BackgroundPainter color: (Color gray alpha: 0.7)).
toolbar addMorph: holder.

toolbar sizeToFit.
toolbar position: (2@50).
^toolbar openInWorld.! !

!CornerPainter class methodsFor: 'instance creation' stamp: 'tb 3/16/2003 19:42'!
rightCorners

	^(self new) cornersToRound: #(3 4)! !

!CornerPainter class methodsFor: 'instance creation' stamp: 'tb 3/16/2003 19:38'!
topCorners

	^(self new) cornersToRound: #(1 4)! !

!CornerPainter class methodsFor: 'instance creation' stamp: 'tb 4/10/2003 00:20'!
topLeft

	^(self new) cornersToRound: #(1)! !

!CornerPainter class methodsFor: 'instance creation' stamp: 'tb 4/10/2003 00:21'!
topRight

	^(self new) cornersToRound: #(4)! !

!CornerPainter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 00:27'!
defaultLayer

	^self cornerLayer! !


!HilightPainter class methodsFor: 'instance creation' stamp: 'tb 4/10/2003 16:27'!
bounds: aRect

	^self new bounds: aRect! !

!HilightPainter class methodsFor: 'instance creation' stamp: 'tb 4/10/2003 16:14'!
color: aColor

	^self new fillStyle: (Backgrounds at: aColor ifAbsent: [aColor])! !

!HilightPainter class methodsFor: 'layerNumbers' stamp: 'tb 4/10/2003 16:14'!
defaultLayer

	^self hilightLayer! !


!PolygonBrick methodsFor: 'menus' stamp: 'tb 3/8/2003 16:47'!
addCustomMenuItems: aMenu hand: aHandMorph
	| lineName |
	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addUpdating: #handlesShowingPhrase target: self action: #showOrHideHandles.
	vertices size > 2 ifTrue:
		[aMenu addUpdating: #openOrClosePhrase target: self action: #makeOpenOrClosed.
		lineName _ closed ifTrue: ['outline'] ifFalse: ['line'].
		self isCurve
			ifTrue: [aMenu add: 'make segmented ', lineName action: #toggleSmoothing]
			ifFalse: [aMenu add: 'make smooth ', lineName action: #toggleSmoothing]]. 
	aMenu add: 'specify dashed line' action:  #specifyDashedLine.

	self isOpen ifTrue:
		[aMenu addLine.
		aMenu addWithLabel: '---' enablement: [self isOpen and: [arrows ~~ #none]] action:  #makeNoArrows.
		aMenu addWithLabel: '-->' enablement: [self isOpen and: [arrows ~~ #forward]] action:  #makeForwardArrow.
		aMenu addWithLabel: '<--' enablement: [self isOpen and: [arrows ~~ #back]] action:  #makeBackArrow.
		aMenu addWithLabel: '<->' enablement: [self isOpen and: [arrows ~~ #both]] action:  #makeBothArrows.
		aMenu add: 'customize arrows' action: #customizeArrows:.
		(self hasProperty: #arrowSpec)
			ifTrue: [aMenu add: 'standard arrows' action: #standardArrows]].! !

!PolygonBrick methodsFor: 'menus' stamp: 'tb 3/8/2003 16:47'!
setRotationCenterFrom: aPoint
	"Polygons store their referencePosition."
	self setProperty: #referencePosition toValue: aPoint! !

!PolygonBrick methodsFor: 'rotate scale and flex' stamp: 'tb 3/8/2003 16:47'!
addFlexShellIfNecessary
	"When scaling or rotating from a halo, I can do this without a flex shell"

	^ self
! !

!PolygonBrick methodsFor: 'rotate scale and flex' stamp: 'tb 3/8/2003 16:47'!
rotationDegrees

	^ self forwardDirection! !

!PolygonBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 16:47'!
addHandles
	| handle newVert tri |
	self removeHandles.
	handles _ OrderedCollection new.
	tri _ Array with: 0@-4 with: 4@3 with: -3@3.
	vertices withIndexDo:
		[:vertPt :vertIndex |
		handle _ EllipseMorph newBounds: (Rectangle center: vertPt extent: 8@8)
				color: Color yellow.
		handle on: #mouseMove send: #dragVertex:event:fromHandle:
				to: self withValue: vertIndex.
		handle on: #mouseUp send: #dropVertex:event:fromHandle:
				to: self withValue: vertIndex.
		self addMorph: handle.
		handles addLast: handle.
		(closed or: [vertIndex < vertices size]) ifTrue:
			[newVert _ PolygonMorph
					vertices: (tri collect: [:p | p + (vertPt + (vertices atWrap: vertIndex+1) // 2)])
					color: Color green borderWidth: 1 borderColor: Color black.
			newVert on: #mouseDown send: #newVertex:event:fromHandle:
					to: self withValue: vertIndex.
			self addMorph: newVert.
			handles addLast: newVert]].
	smoothCurve ifTrue: [self updateHandles; layoutChanged].
	self changed! !

!PolygonBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 16:47'!
dragVertex: ix event: evt fromHandle: handle
	| p |
	p _ self isCurve
		ifTrue: [evt cursorPoint]
		ifFalse: [self griddedPoint: evt cursorPoint].
	handle position: p - (handle extent//2).
	self verticesAt: ix put: p.
! !

!PolygonBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 16:47'!
dragVertex: arg1 fromHandle: arg2 vertIndex: arg3
	"Reorder the arguments for existing event handlers"
	(arg3 isMorph and:[arg3 eventHandler notNil]) ifTrue:[arg3 eventHandler fixReversedValueMessages].
	^self dragVertex: arg1 event: arg2 fromHandle: arg3! !

!PolygonBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 16:47'!
dropVertex: ix event: evt fromHandle: handle
	| p |
	p _ vertices at: ix.
	(((vertices atWrap: ix-1) dist: p) < 3 or:
		[((vertices atWrap: ix+1) dist: p) < 3])
		ifTrue: ["Drag a vertex onto its neighbor means delete"
				self setVertices: (vertices copyReplaceFrom: ix to: ix with: Array new)].
	evt shiftPressed
		ifTrue: [self removeHandles]
		ifFalse: [self addHandles "remove then add to recreate"]! !

!PolygonBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 16:47'!
dropVertex: arg1 fromHandle: arg2 vertIndex: arg3
	"Reorder the arguments for existing event handlers"
	(arg3 isMorph and:[arg3 eventHandler notNil]) ifTrue:[arg3 eventHandler fixReversedValueMessages].
	^self dropVertex: arg1 event: arg2 fromHandle: arg3! !

!PolygonBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 16:47'!
newVertex: ix event: evt fromHandle: handle
	"Insert a new vertex and fix everything up!! Install the drag-handle of the new vertex as recipient of further mouse events."

	| pt |
	(self hasProperty: #noNewVertices) ifFalse:
		[pt _ evt cursorPoint.
		self setVertices: (vertices copyReplaceFrom: ix + 1 to: ix with: (Array with: pt)).
		evt hand newMouseFocus: (handles at: ((ix + 1) * 2) - 1)]
! !

!PolygonBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 16:47'!
newVertex: arg1 fromHandle: arg2 afterVert: arg3
	"Reorder the arguments for existing event handlers"
	(arg3 isMorph and:[arg3 eventHandler notNil]) ifTrue:[arg3 eventHandler fixReversedValueMessages].
	^self newVertex: arg1 event: arg2 fromHandle: arg3! !

!PolygonBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 16:47'!
updateHandles
	| newVert oldVert midPts nextVertIx tweens |
	smoothCurve
		ifTrue: [
			handles first center: vertices first.
			handles last center: vertices last.
			midPts _ OrderedCollection new.
			nextVertIx _ 2.
			tweens _ OrderedCollection new.
			self
				lineSegmentsDo: [:p1 :p2 | 
					tweens addLast: p2 asIntegerPoint.
					p2
							= (vertices atWrap: nextVertIx)
						ifTrue: ["Found endPoint."
							midPts addLast: (tweens at: tweens size // 2)
									+ (tweens at: tweens size + 1 // 2) // 2.
							tweens _ OrderedCollection new.
							nextVertIx _ nextVertIx + 1]].
			midPts
				withIndexDo: [:midPt :vertIndex | (closed
							or: [vertIndex < vertices size])
						ifTrue: [newVert _ handles at: vertIndex * 2.
							newVert position: midPt - (newVert extent // 2)]]]
		ifFalse: [vertices
				withIndexDo: [:vertPt :vertIndex | 
					oldVert _ handles at: vertIndex * 2 - 1.
					oldVert position: vertPt - (oldVert extent // 2).
					(closed
							or: [vertIndex < vertices size])
						ifTrue: [newVert _ handles at: vertIndex * 2.
							newVert position: vertPt
									+ (vertices atWrap: vertIndex + 1) - newVert extent // 2 + (1 @ -1)]]]! !

!PolygonBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 16:47'!
verticesAt: ix put: newPoint
	vertices at: ix put: newPoint.
	self computeBounds! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
areasRemainingToFill: aRectangle
	"Could be improved by quick check of inner rectangle"

	^ Array with: aRectangle! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawArrowOn: aCanvas at: endPoint from: priorPoint 
	"Draw a triangle oriented along the line from priorPoint to  
	endPoint. Answer the wingBase."

	| pts spec wingBase |
	pts := self arrowBoundsAt: endPoint from: priorPoint.
	wingBase := pts size = 4 
				ifTrue: [pts third]
				ifFalse: [(pts copyFrom: 2 to: 3) average].
	spec := self valueOfProperty: #arrowSpec ifAbsent: [5 @ 4].
	spec x sign = spec y sign 
		ifTrue: [aCanvas drawPolygon: pts fillStyle: borderColor]
		ifFalse: 
			[aCanvas 
				drawPolygon: pts
				fillStyle: Color transparent
				borderWidth: (borderWidth + 1) // 2
				borderColor: borderColor].
	^wingBase! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawArrowsOn: aCanvas 
	"Answer (possibly modified) endpoints for border drawing"
	"ArrowForms are computed only upon demand"
	| array |
	(closed
			or: [arrows == #none
					or: [vertices size < 2]])
		ifTrue: [^ self].
	"Nothing to do"
	borderColor isColor
		ifFalse: [^ self].
	array _ Array new: 2.
	"Prevent crashes for #raised or #inset borders"
	array at: 2 put: ((arrows == #forward
			or: [arrows == #both])
		ifTrue: [ self
				drawArrowOn: aCanvas
				at: vertices last
				from: self nextToLastPoint]
		ifFalse: [ vertices last ]).
	array at: 1 put: ((arrows == #back
			or: [arrows == #both])
		ifTrue: [self
				drawArrowOn: aCanvas
				at: vertices first
				from: self nextToFirstPoint]
		ifFalse: [ vertices first ]).
	^array! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawBorderOn: aCanvas 
	self
		drawClippedBorderOn: aCanvas
		usingEnds: (Array with: vertices first with: vertices last)! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawBorderOn: aCanvas usingEnds: anArray 
	"Display my border on the canvas."
	"NOTE: Much of this code is also copied in drawDashedBorderOn:  
	(should be factored)"
	| bigClipRect p1i p2i style |
	borderDashSpec
		ifNotNil: [^ self drawDashedBorderOn: aCanvas usingEnds: anArray].
	style _ self borderStyle.
	bigClipRect _ aCanvas clipRect expandBy: self borderWidth + 1 // 2.
	self lineSegmentsDo: [:p1 :p2 | 
		p1i _ p1 asIntegerPoint.
		p2i _ p2 asIntegerPoint.
		(arrows ~= #none and: [closed not])
			ifTrue: ["Shorten line ends so as not to interfere with tip of arrow."
					((arrows == #back
								or: [arrows == #both])
							and: [p1 = vertices first])
						ifTrue: [p1i _ anArray first asIntegerPoint].
					((arrows == #forward
								or: [arrows == #both])
							and: [p2 = vertices last])
						ifTrue: [p2i _ anArray last asIntegerPoint]].
		(closed or: ["bigClipRect intersects: (p1i rect: p2i) optimized:"
			((p1i min: p2i) max: bigClipRect origin)
				<= ((p1i max: p2i) min: bigClipRect corner)])
				ifTrue: [style drawLineFrom: p1i to: p2i on: aCanvas]]! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawClippedBorderOn: aCanvas usingEnds: anArray 
	aCanvas clipBy: self bounds during:[:cc| self drawBorderOn: cc usingEnds: anArray].! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawDashedBorderOn: aCanvas 
	self
		drawDashedBorderOn: aCanvas
		usingEnds: (Array with: vertices first with: vertices last)! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawDashedBorderOn: aCanvas usingEnds: anArray 
	"Display my border on the canvas. NOTE: mostly copied from  
	drawBorderOn:"

	| lineColor bevel topLeftColor bottomRightColor bigClipRect p1i p2i segmentOffset |
	(borderColor isNil 
		or: [borderColor isColor and: [borderColor isTransparent]]) ifTrue: [^self].
	lineColor := borderColor.
	bevel := false.
	"Border colors for bevelled effects depend on CW ordering of  
	vertices"
	borderColor == #raised 
		ifTrue: 
			[topLeftColor := color lighter.
			bottomRightColor := color darker.
			bevel := true].
	borderColor == #inset 
		ifTrue: 
			[topLeftColor := owner colorForInsets darker.
			bottomRightColor := owner colorForInsets lighter.
			bevel := true].
	bigClipRect := aCanvas clipRect expandBy: (self borderWidth + 1) // 2.
	segmentOffset := self borderDashOffset.
	self lineSegmentsDo: 
			[:p1 :p2 | 
			p1i := p1 asIntegerPoint.
			p2i := p2 asIntegerPoint.
			(arrows ~= #none and: [closed not]) 
				ifTrue: 
					["Shorten line ends so as not to interfere with tip  
					of arrow."

					((arrows == #back or: [arrows == #both]) and: [p1 = vertices first]) 
						ifTrue: [p1i := anArray first asIntegerPoint].
					((arrows == #forward or: [arrows == #both]) and: [p2 = vertices last]) 
						ifTrue: [p2i := anArray last asIntegerPoint]].
			(closed or: 
					["bigClipRect intersects: (p1i rect: p2i) optimized:"

					((p1i min: p2i) max: bigClipRect origin) 
						<= ((p1i max: p2i) min: bigClipRect corner)]) 
				ifTrue: 
					[bevel 
						ifTrue: 
							[lineColor := (p1i quadrantOf: p2i) > 2 
										ifTrue: [topLeftColor]
										ifFalse: [bottomRightColor]].
					segmentOffset := aCanvas 
								line: p1i
								to: p2i
								width: borderWidth
								color: lineColor
								dashLength: borderDashSpec first
								secondColor: borderDashSpec third
								secondDashLength: borderDashSpec second
								startingOffset: segmentOffset]]! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawOn: aCanvas 
	"Display the receiver, a spline curve, approximated by straight 
	line segments."
	| array |
	vertices size < 1
		ifTrue: [self error: 'a polygon must have at least one point'].
	closed ifTrue:
		[aCanvas drawPolygon: self getVertices fillStyle: self fillStyle.
		aCanvas isShadowDrawing ifTrue: [^ self]].
	array _ self drawArrowsOn: aCanvas.
	self drawClippedBorderOn: aCanvas usingEnds: array.
! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawOnFormCanvas: aCanvas 
	"Display the receiver, a spline curve, approximated by straight line segments."

	| |
	vertices size < 1 ifTrue: [self error: 'a polygon must have at least one point'].
	closed & color isTransparent not
		ifTrue: [aCanvas stencil: self filledForm at: bounds topLeft - 1 color: color].
	(borderColor isColor and: [borderColor isTranslucentColor])
		ifTrue: [aCanvas stencil: self borderForm at: bounds topLeft
						color: borderColor]
		ifFalse: [self drawBorderOn: aCanvas].
	self arrowForms do:
		[:f | aCanvas stencil: f at: f offset
			color: (borderColor isColor ifTrue: [borderColor] ifFalse: [color])]! !

!PolygonBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 16:47'!
drawPostscriptOn: aCanvas 
	"Display the receiver, a spline curve, approximated by straight 
	line segments."
	| array |
	vertices size < 1
		ifTrue: [self error: 'a polygon must have at least one point'].
	array _ self drawArrowsOn: aCanvas.
	closed
		ifTrue: [aCanvas
				drawPolygon: self getVertices
				color: self color
				borderWidth: self borderWidth
				borderColor: self borderColor]
		ifFalse: [self drawClippedBorderOn: aCanvas usingEnds: array].
! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
arrowBoundsAt: endPoint from: priorPoint 
	"Answer a triangle oriented along the line from priorPoint to endPoint."
	| d v angle wingBase arrowSpec length width |
	v _ endPoint - priorPoint.
	angle _ v degrees.
	d _ borderWidth max: 1.
	arrowSpec _ self valueOfProperty: #arrowSpec ifAbsent: [5@4].
	length _ arrowSpec x abs.  width _ arrowSpec y abs.
	wingBase _ endPoint + (Point r: d * length degrees: angle + 180.0).
	arrowSpec x >= 0
		ifTrue: [^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase + (Point r: d * width degrees: angle - 125.0) }]
		ifFalse: ["Negative length means concave base."
				^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase.
					wingBase + (Point r: d * width degrees: angle - 125.0) }]! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
arrowForms
	"ArrowForms are computed only upon demand"
	arrowForms ifNotNil: [^ arrowForms].

	arrowForms _ Array new.
	(closed or: [arrows == #none or: [vertices size < 2]]) ifTrue:
		[^ arrowForms].
	(arrows == #forward or: [arrows == #both]) ifTrue:
		[arrowForms _ arrowForms copyWith:
			(self computeArrowFormAt: vertices last from: self nextToLastPoint)].
	(arrows == #back or: [arrows == #both]) ifTrue:
		[arrowForms _ arrowForms copyWith:
			(self computeArrowFormAt: vertices first from: self nextToFirstPoint)].
	^ arrowForms! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
borderForm
	"A form must be created for drawing the border whenever the borderColor is translucent."

	| borderCanvas |
	borderForm ifNotNil: [^ borderForm].
	borderCanvas _ (Display defaultCanvasClass extent: bounds extent depth: 1)
		shadowColor: Color black.
	borderCanvas translateBy: bounds topLeft negated
		during:[:tempCanvas| self drawBorderOn: tempCanvas].
	borderForm _ borderCanvas form.
	self arrowForms do:
		[:f |  "Eliminate overlap between line and arrowheads if transparent."
		borderForm copy: f boundingBox from: f to: f offset - self position rule: Form erase].
	^ borderForm! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
computeArrowFormAt: endPoint from: priorPoint 
	"Compute a triangle oriented along the line from priorPoint to  
	endPoint. Then draw those lines in a form and return that  
	form, with appropriate offset"

	| p1 pts box arrowForm bb origin |
	pts := self arrowBoundsAt: endPoint from: priorPoint.
	box := ((pts first rect: pts last) encompass: (pts second)) expandBy: 1.
	arrowForm := Form extent: box extent asIntegerPoint.
	bb := (BitBlt current toForm: arrowForm)
				sourceForm: nil;
				fillColor: Color black;
				combinationRule: Form over;
				width: 1;
				height: 1.
	origin := box topLeft.
	p1 := pts last - origin.
	pts do: 
			[:p | 
			bb drawFrom: p1 to: p - origin.
			p1 := p - origin].
	arrowForm convexShapeFill: Color black.
	^arrowForm offset: box topLeft! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:57'!
computeBounds
	| oldBounds excludeHandles newBounds |
	vertices ifNil: [^ self].

	self changed.
	oldBounds _ bounds.
	self releaseCachedState.

	newBounds _ self curveBounds truncated.

	self arrowForms do:
		[:f | newBounds _ newBounds merge: (f offset extent: f extent)].
	handles ifNotNil: [self updateHandles].

	"since we are directly updating bounds, see if any ordinary submorphs exist and move them accordingly"
	(oldBounds notNil and: ["(delta _ newBounds origin - oldBounds origin) ~= (0@0)" oldBounds ~= newBounds ]) ifTrue: [
		excludeHandles _ IdentitySet new.
		handles ifNotNil: [excludeHandles addAll: handles].
		self submorphsDo: [ :each |
			(excludeHandles includes: each) ifFalse: [
				self layoutChild: each in: newBounds.
				"each position: each position + delta"
			].
		].
	].
	bounds := newBounds.
	self layoutChanged.
	self changed.
! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
curveBounds
	| curveBounds pointAfterFirst pointBeforeLast |
	smoothCurve 
		ifFalse: 
			[^(Rectangle encompassing: vertices) expandBy: (borderWidth + 1) // 2].

	"Compute the bounds from actual curve traversal, with leeway for borderWidth.
	Also note the next-to-first and next-to-last points for arrow directions."
	curveState := nil.	"Force recomputation"
	curveBounds := vertices first corner: vertices last.
	pointAfterFirst := nil.
	self lineSegmentsDo: 
			[:p1 :p2 | 
			pointAfterFirst isNil 
				ifTrue: 
					[pointAfterFirst := p2 asIntegerPoint.
					curveBounds := curveBounds encompass: p1 asIntegerPoint].
			curveBounds := curveBounds encompass: p2 asIntegerPoint.
			pointBeforeLast := p1 asIntegerPoint].
	curveState at: 2 put: pointAfterFirst.
	curveState at: 3 put: pointBeforeLast.
	^curveBounds expandBy: (borderWidth + 1) // 2! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
filledForm
	"Note: The filled form is actually 2 pixels bigger than bounds, and the point corresponding to this morphs' position is at 1@1 in the form.  This is due to the details of the fillig routines, at least one of which requires an extra 1-pixel margin around the outside.  Computation of the filled form is done only on demand."
	| bb origin |
	closed ifFalse: [^ filledForm _ nil].
	filledForm ifNotNil: [^ filledForm].
	filledForm _ Form extent: bounds extent+2.

	"Draw the border..."
	bb _ (BitBlt current toForm: filledForm) sourceForm: nil; fillColor: Color black;
			combinationRule: Form over; width: 1; height: 1.
	origin _ bounds topLeft asIntegerPoint-1.
	self lineSegmentsDo: [:p1 :p2 | bb drawFrom: p1 asIntegerPoint-origin
										to: p2 asIntegerPoint-origin].

	"Fill it in..."
	filledForm convexShapeFill: Color black.

	(borderColor isColor and: [borderColor isTranslucentColor]) ifTrue:
		["If border is stored as a form, then erase any overlap now."
		filledForm copy: self borderForm boundingBox from: self borderForm
			to: 1@1 rule: Form erase].

	^ filledForm! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
getVertices

	smoothCurve ifFalse: [^ vertices].

	"For curves, enumerate the full set of interpolated points"
	^ Array streamContents:
		[:s | self lineSegmentsDo: [:pt1 :pt2 | s nextPut: pt1]]! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
includesHandle: aMorph

	handles ifNil: [^ false].
	^ handles includes: aMorph! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
lineSegments
	| lineSegments |
	lineSegments _ OrderedCollection new.
	self lineSegmentsDo: [:p1 :p2 | lineSegments addLast: (Array with: p1 with: p2)].
	^ lineSegments! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
privateMoveBy: delta
	super privateMoveBy: delta.
	vertices _ vertices collect: [:p | p + delta].
	self arrowForms do: [:f | f offset: f offset + delta].
	curveState _ nil.  "Force recomputation"
	(self valueOfProperty: #referencePosition) doIfNotNil:
		[:oldPos | self setProperty: #referencePosition toValue: oldPos + delta]! !

!PolygonBrick methodsFor: 'private' stamp: 'tb 3/8/2003 16:47'!
setVertices: newVertices
	vertices _ newVertices.
	handles ifNotNil: [self removeHandles; addHandles].
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
arrowLength: aLength
	"Assumes that I have exactly two vertices"

	| theta horizontalOffset verticalOffset newTip delta |
	delta _ vertices second - vertices first.
	theta _ delta theta.
	horizontalOffset _ aLength * (theta cos).
	verticalOffset _ aLength * (theta sin).
	newTip _ vertices first + (horizontalOffset @ verticalOffset).
	self verticesAt: 2 put: newTip! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
arrowSpec: specPt
	"Specify a custom arrow for this line.
	specPt x abs gives the length of the arrow (point to base) in terms of borderWidth.
	If specPt x is negative, then the base of the arrow will be concave.
	specPt y abs gives the width of the arrow.
	The standard arrow is equivalent to arrowSpec: 5@4.
	See arrowBoundsAt:From: for details."

	self setProperty: #arrowSpec toValue: specPt.
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
customizeArrows: evt
	| handle origin aHand |
	aHand _ evt ifNil: [self primaryHand] ifNotNil: [evt hand].
	origin _ aHand position.
	handle _ HandleMorph new
		forEachPointDo:
			[:newPoint | handle removeAllMorphs.
			handle addMorph:
				(LineMorph from: origin to: newPoint color: Color black width: 1).
			self arrowSpec: (newPoint - origin) / 5.0]
		lastPointDo:
			[:newPoint | handle deleteBalloon.
			self halo doIfNotNil: [:halo | halo addHandles].].
	aHand attachMorph: handle.
	handle setProperty: #helpAtCenter toValue: true.
	handle showBalloon:
'Move cursor left and right
to change arrow length and style.
Move it up and down to change width.
Click when done.' hand: evt hand.
	handle startStepping! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
handlesShowingPhrase
	^ self showingHandles
		ifTrue:
			['hide handles']
		ifFalse:
			['show handles']! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
makeBackArrow
	arrows _ #back.
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
makeBothArrows
	arrows _ #both.
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
makeClosed
	closed _ true.
	handles ifNotNil: [self removeHandles; addHandles].
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
makeForwardArrow
	arrows _ #forward.
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
makeNoArrows
	arrows _ #none.
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
makeOpen
	closed _ false.
	handles ifNotNil: [self removeHandles; addHandles].
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
quickFill: ignored! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
removeHandles
	"tk 9/2/97 allow it to be called twice (when nil already)"

	handles ifNotNil: [
		handles do: [:h | h delete].
		handles _ nil].! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
showOrHideHandles
	self showingHandles
		ifTrue:	[self removeHandles]
		ifFalse:	[self addHandles]! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
showingHandles
	^ handles notNil! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
specifyDashedLine

	| executableSpec newSpec |
	executableSpec _ FillInTheBlank
		request:
'Enter a dash specification as
{ major dash length. minor dash length. minor dash color }
The major dash will have the normal border color.
A blank response will remove the dash specification.
[Note: You may give 5 items as, eg, {10. 5. Color white. 0. 3}
where the 4th ityem is zero, and the 5th is the number of pixels
by which the dashes will move in each step of animation]'
		initialAnswer: '{ 10. 5. Color red }'.
	executableSpec isEmpty ifTrue:
		[^ self stopStepping; dashedBorder: nil].
	newSpec _ [Compiler evaluate: executableSpec] ifError:
		[^ self stopStepping; dashedBorder: nil].
	newSpec first isNumber & newSpec second isNumber & newSpec third isColor ifFalse:
		[^ self stopStepping; dashedBorder: nil].
	newSpec size = 3 ifTrue:
		[^ self stopStepping; dashedBorder: newSpec].
	(newSpec size = 5 and: [newSpec fourth isNumber & newSpec fifth isNumber]) ifTrue:
		[^ self dashedBorder: newSpec; startStepping].
! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
standardArrows

	self removeProperty: #arrowSpec.
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
toggleHandles

	handles ifNil: [self addHandles] ifNotNil: [self removeHandles].

! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
toggleSmoothing

	smoothCurve _ smoothCurve not.
	handles ifNotNil: [self removeHandles; addHandles].
	self computeBounds! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
unrotatedLength
	"If the receiver bears rotation without a transformation morph, answer what its length in the direction it is headed is"

	vertices size == 2 ifTrue:
		[^ (vertices second - vertices first) r].

	^ ((PolygonMorph new setVertices: vertices) rotationDegrees: self rotationDegrees negated) height! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
unrotatedLength: aLength
	"If the receiver bears rotation without a transformation morph, answer what its length in the direction it is headed is"

	vertices size == 2 ifTrue: [^ self arrowLength: aLength].

	self setVertices: ((((PolygonMorph new setVertices: vertices) rotationDegrees: self rotationDegrees negated) height: aLength) rotationDegrees: 0) vertices! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
unrotatedWidth
	"If the receiver bears rotation without a transformation morph, answer what its length in the direction it is headed is"
	
	vertices size == 2 ifTrue: [^ self borderWidth].
	^ ((PolygonMorph new setVertices: vertices) rotationDegrees: self rotationDegrees negated) width! !

!PolygonBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 16:47'!
unrotatedWidth: aWidth
	"If the receiver bears rotation without a transformation morph, answer what its length in the direction it is headed is"

	self borderWidth: aWidth! !

!PolygonBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:47'!
beSmoothCurve

	smoothCurve == true ifFalse:
		[smoothCurve _ true.
		self computeBounds]! !

!PolygonBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:47'!
beStraightSegments

	smoothCurve == false ifFalse:
		[smoothCurve _ false.
		self computeBounds]! !

!PolygonBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:47'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color
		r: 0.0
		g: 0.419
		b: 0.935! !

!PolygonBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:47'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color orange! !

!PolygonBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:47'!
initialize
"initialize the state of the receiver"
	super initialize.
""
	vertices _ Array
				with: 5 @ 0
				with: 20 @ 10
				with: 0 @ 20.
	closed _ true.
	smoothCurve _ false.
	arrows _ #none.
	self computeBounds! !

!PolygonBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 16:47'!
vertices: verts color: aColor borderWidth: borderWidthInteger borderColor: anotherColor 
	super initialize.
""
	vertices _ verts.
	color _ aColor.
	borderWidth _ borderWidthInteger.
	borderColor _ anotherColor.
	closed _ vertices size > 2.
	arrows _ #none.
	self computeBounds! !

!PolygonBrick methodsFor: 'access' stamp: 'tb 3/8/2003 16:47'!
borderColor: aColor 

	super borderColor: aColor.
	(borderColor isColor and: [borderColor isTranslucentColor]) 
		== (aColor isColor and: [aColor isTranslucentColor]) 
			ifFalse: 
				["Need to recompute fillForm and borderForm
					if translucency of border changes."

				self releaseCachedState]! !

!PolygonBrick methodsFor: 'access' stamp: 'tb 3/8/2003 16:47'!
isClosed
	^ closed! !

!PolygonBrick methodsFor: 'access' stamp: 'tb 3/8/2003 16:47'!
isCurve
	^ smoothCurve! !

!PolygonBrick methodsFor: 'access' stamp: 'tb 3/8/2003 16:47'!
isOpen
	^ closed not! !

!PolygonBrick methodsFor: 'access' stamp: 'tb 3/8/2003 16:47'!
makeOpenOrClosed
	"toggle the open/closed status of the receiver"
	closed ifTrue: [self makeOpen] ifFalse: [self makeClosed]! !

!PolygonBrick methodsFor: 'access' stamp: 'tb 3/8/2003 16:47'!
openOrClosePhrase
	| curveName |
	curveName _ self isCurve ifTrue: ['curve'] ifFalse: ['polygon'].
	^ closed
		ifTrue: ['make open ' , curveName]
		ifFalse: ['make closed ' , curveName]! !

!PolygonBrick methodsFor: 'access' stamp: 'tb 3/8/2003 16:47'!
vertices
	^ vertices! !

!PolygonBrick methodsFor: 'dashes' stamp: 'tb 3/8/2003 16:47'!
borderDashOffset
	borderDashSpec size < 4 ifTrue: [^0.0].
	^(borderDashSpec fourth) asFloat! !

!PolygonBrick methodsFor: 'dashes' stamp: 'tb 3/8/2003 16:47'!
dashedBorder: dashSpec
	"A dash spec is a 3- or 5-element array with
		{ length of normal border color.
		length of alternate border color.
		alternate border color.
		starting offset.
		amount to add to offset at each step }
	Starting offset is usually = 0, but changing it moves the dashes along the curve."

	borderDashSpec _ dashSpec.
	self changed! !

!PolygonBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 16:47'!
borderWidth: anInteger

	borderColor ifNil: [borderColor _ Color black].
	borderWidth _ anInteger.
	self computeBounds! !

!PolygonBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 16:47'!
couldHaveRoundedCorners
	^ false! !

!PolygonBrick methodsFor: 'visual properties' stamp: 'tb 3/8/2003 16:47'!
canHaveFillStyles
	"Return true if the receiver can have general fill styles; not just colors.
	This method is for gradually converting old morphs."
	^true! !

!PolygonBrick methodsFor: 'visual properties' stamp: 'tb 3/8/2003 16:47'!
fillStyle

	self isOpen
		ifTrue: [^ self borderColor  "easy access to line color from halo"]
		ifFalse: [^ super fillStyle]! !

!PolygonBrick methodsFor: 'visual properties' stamp: 'tb 3/8/2003 16:47'!
fillStyle: newColor

	self isOpen
		ifTrue: [^ self borderColor: newColor  "easy access to line color from halo"]
		ifFalse: [^ super fillStyle: newColor]! !

!PolygonBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 16:47'!
closestPointTo: aPoint 
	| curvePoint closestPoint dist minDist |
	closestPoint := minDist := nil.
	self lineSegmentsDo: 
			[:p1 :p2 | 
			curvePoint := aPoint nearestPointOnLineFrom: p1 to: p2.
			dist := curvePoint dist: aPoint.
			(closestPoint isNil or: [dist < minDist]) 
				ifTrue: 
					[closestPoint := curvePoint.
					minDist := dist]].
	^closestPoint! !

!PolygonBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 16:47'!
extent: newExtent 
	"Not really advisable, but we can preserve most of the geometry if we don't
	shrink things too small."
	| safeExtent center |
	center _ self referencePosition.
	safeExtent _ newExtent max: 20@20.
	self setVertices: (vertices collect:
		[:p | p - center * (safeExtent asFloatPoint / (bounds extent max: 1@1)) + center])! !

!PolygonBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 16:47'!
merge: aPolygon 
	"Expand myself to enclose the other polygon.  (Later merge overlapping or disjoint in a smart way.)  For now, the two polygons must share at least two vertices.  Shared vertices must come one after the other in each polygon.  Polygons must not overlap."

	| shared mv vv hv xx |
	shared := vertices select: [:mine | aPolygon vertices includes: mine].
	shared size < 2 ifTrue: [^nil].	"not sharing a segment"
	mv := vertices asOrderedCollection.
	[shared includes: mv first] whileFalse: 
			["rotate them"

			vv := mv removeFirst.
			mv addLast: vv].
	hv := aPolygon vertices asOrderedCollection.
	[mv first = hv first] whileFalse: 
			["rotate him until same shared vertex is first"

			vv := hv removeFirst.
			hv addLast: vv].
	[shared size > 2] whileTrue: 
			[shared := shared asOrderedCollection.
			(self 
				mergeDropThird: mv
				in: hv
				from: shared) ifNil: [^nil]].
	"works by side effect on the lists"
	(mv second) = hv last 
		ifTrue: 
			[mv
				removeFirst;
				removeFirst.
			^self setVertices: (hv , mv) asArray].
	(hv second) = mv last 
		ifTrue: 
			[hv
				removeFirst;
				removeFirst.
			^self setVertices: (mv , hv) asArray].
	(mv second) = (hv second) 
		ifTrue: 
			[hv removeFirst.
			mv remove: (mv second).
			xx := mv removeFirst.
			^self setVertices: (hv , (Array with: xx) , mv reversed) asArray].
	mv last = hv last 
		ifTrue: 
			[mv removeLast.
			hv removeFirst.
			^self setVertices: (mv , hv reversed) asArray].
	^nil! !

!PolygonBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 16:47'!
mergeDropThird: mv in: hv from: shared 
	"We are merging two polygons.  In this case, they have at least three identical shared vertices.  Make sure they are sequential in each, and drop the middle one from vertex lists mv, hv, and shared.  First vertices on lists are identical already."

	"know (mv first = hv first)"

	| mdrop vv |
	(shared includes: (mv at: mv size - 2)) 
		ifTrue: [(shared includes: mv last) ifTrue: [mdrop := mv last]]
		ifFalse: 
			[(shared includes: mv last) 
				ifTrue: [(shared includes: mv second) ifTrue: [mdrop := mv first]]].
	(shared includes: (mv third)) 
		ifTrue: [(shared includes: mv second) ifTrue: [mdrop := mv second]].
	mdrop ifNil: [^nil].
	mv remove: mdrop.
	hv remove: mdrop.
	shared remove: mdrop.
	[shared includes: mv first] whileFalse: 
			["rotate them"

			vv := mv removeFirst.
			mv addLast: vv].
	[mv first = hv first] whileFalse: 
			["rotate him until same shared vertex is first"

			vv := hv removeFirst.
			hv addLast: vv]! !

!PolygonBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 16:47'!
transformedBy: aTransform
	self setVertices: (self vertices collect:[:v| aTransform localPointToGlobal: v])! !

!PolygonBrick methodsFor: 'smoothing' stamp: 'tb 3/8/2003 16:47'!
coefficients
	"Compute an array for the coefficients.  This is copied from Flegal's old
	code in the Spline class."

	| length extras verts coefficients |
	curveState ifNotNil: [^curveState first].
	verts := closed 
				ifTrue: [vertices copyWith: vertices first]
				ifFalse: [vertices].
	length := verts size.
	extras := 0.
	coefficients := Array new: 8.
	1 to: 8 do: [:i | coefficients at: i put: (Array new: length + extras)].
	1 to: 5
		by: 4
		do: 
			[:k | 
			1 to: length
				do: 
					[:i | 
					(coefficients at: k) at: i
						put: (k = 1 
								ifTrue: [(verts at: i) x asFloat]
								ifFalse: [(verts at: i) y asFloat])].
			1 to: extras
				do: 
					[:i | 
					(coefficients at: k) at: length + i put: ((coefficients at: k) at: i + 1)].
			self 
				derivs: (coefficients at: k)
				first: (coefficients at: k + 1)
				second: (coefficients at: k + 2)
				third: (coefficients at: k + 3)].
	extras > 0 
		ifTrue: 
			[1 to: 8
				do: 
					[:i | 
					coefficients at: i put: ((coefficients at: i) copyFrom: 2 to: length + 1)]].
	curveState := { 
				coefficients.
				nil.
				nil}.
	self computeNextToEndPoints.
	^coefficients! !

!PolygonBrick methodsFor: 'smoothing' stamp: 'tb 3/8/2003 16:47'!
computeNextToEndPoints
	| pointAfterFirst pointBeforeLast |
	pointAfterFirst := nil.
	self lineSegmentsDo: 
			[:p1 :p2 | 
			pointAfterFirst isNil ifTrue: [pointAfterFirst := p2 asIntegerPoint].
			pointBeforeLast := p1 asIntegerPoint].
	curveState at: 2 put: pointAfterFirst.
	curveState at: 3 put: pointBeforeLast! !

!PolygonBrick methodsFor: 'smoothing' stamp: 'tb 3/8/2003 16:47'!
derivs: a first: point1 second: point2 third: point3 
	"Compute the first, second and third derivitives (in coeffs) from
	the Points in this Path (coeffs at: 1 and coeffs at: 5)."

	| len v anArray |
	len := a size.
	len < 2 ifTrue: [^self].
	len > 2 
		ifTrue: 
			[v := Array new: len.
			v at: 1 put: 4.0.
			anArray := Array new: len.
			anArray at: 1 put: 6.0 * (a first - (a second * 2.0) + (a third)).
			2 to: len - 2
				do: 
					[:i | 
					v at: i put: 4.0 - (1.0 / (v at: i - 1)).
					anArray at: i
						put: 6.0 * ((a at: i) - ((a at: i + 1) * 2.0) + (a at: i + 2)) 
								- ((anArray at: i - 1) / (v at: i - 1))].
			point2 at: len - 1 put: (anArray at: len - 2) / (v at: len - 2).
			len - 2 to: 2
				by: 0 - 1
				do: 
					[:i | 
					point2 at: i
						put: ((anArray at: i - 1) - (point2 at: i + 1)) / (v at: i - 1)]].
	point2 at: 1 put: (point2 at: len put: 0.0).
	1 to: len - 1
		do: 
			[:i | 
			point1 at: i
				put: (a at: i + 1) - (a at: i) 
						- (((point2 at: i) * 2.0 + (point2 at: i + 1)) / 6.0).
			point3 at: i put: (point2 at: i + 1) - (point2 at: i)]! !

!PolygonBrick methodsFor: 'smoothing' stamp: 'tb 3/8/2003 16:47'!
lineSegmentsDo: endPointsBlock 
	"Emit a sequence of segment endpoints into endPointsBlock."

	| n t x y x1 x2 x3 y1 y2 y3 beginPoint endPoint cs |
	smoothCurve 
		ifFalse: 
			[beginPoint := nil.
			vertices do: 
					[:vert | 
					beginPoint ifNotNil: [endPointsBlock value: beginPoint value: vert].
					beginPoint := vert].
			(closed or: [vertices size = 1]) 
				ifTrue: [endPointsBlock value: beginPoint value: vertices first].
			^self].

	"For curves we include all the interpolated sub segments."
	vertices size < 1 ifTrue: [^self].
	cs := self coefficients.
	beginPoint := (x := cs first first) @ (y := cs fifth first).
	1 to: cs first size - 1
		do: 
			[:i | 
			"taylor series coefficients"

			x1 := cs second at: i.
			y1 := cs sixth at: i.
			x2 := (cs third at: i) / 2.0.
			y2 := (cs seventh at: i) / 2.0.
			x3 := (cs fourth at: i) / 6.0.
			y3 := ((cs eighth) at: i) / 6.0.
			"guess n"
			n := 5 
						max: (((x2 abs + y2 abs) * 2.0 + (cs third at: i + 1) abs 
								+ (cs seventh at: i + 1) abs) / 100.0) 
								rounded.
			1 to: n - 1
				do: 
					[:j | 
					t := j asFloat / n.
					endPoint := (((x3 * t + x2) * t + x1) * t + x) 
								@ (((y3 * t + y2) * t + y1) * t + y).
					endPointsBlock value: beginPoint value: endPoint.
					beginPoint := endPoint].
			endPoint := (x := cs first at: i + 1) @ (y := cs fifth at: i + 1).
			endPointsBlock value: beginPoint value: endPoint.
			beginPoint := endPoint]! !

!PolygonBrick methodsFor: 'smoothing' stamp: 'tb 3/8/2003 16:47'!
nextToFirstPoint
	"For arrow direction"

	smoothCurve 
		ifTrue: 
			[curveState ifNil: [self coefficients].
			^curveState second]
		ifFalse: [^vertices second]! !

!PolygonBrick methodsFor: 'smoothing' stamp: 'tb 3/8/2003 16:47'!
nextToLastPoint
	"For arrow direction"

	smoothCurve 
		ifTrue: 
			[curveState ifNil: [self coefficients].
			^curveState third]
		ifFalse: [^vertices at: vertices size - 1]! !

!PolygonBrick methodsFor: 'geometry testing' stamp: 'tb 3/8/2003 16:47'!
containsPoint: aPoint
	(super containsPoint: aPoint) ifFalse: [^ false].

	closed & color isTransparent not ifTrue:
		[^ (self filledForm pixelValueAt: aPoint - bounds topLeft + 1) > 0].

	self lineSegmentsDo:
		[:p1 :p2 |
		(aPoint onLineFrom: p1 to: p2 within: (3 max: borderWidth+1//2) asFloat)
				ifTrue: [^ true]].

	self arrowForms do:
		[:f | (f pixelValueAt: aPoint - f offset) > 0 ifTrue: [^ true]].

	^ false! !

!PolygonBrick methodsFor: 'objects from disk' stamp: 'tb 3/8/2003 16:47'!
convertToCurrentVersion: varDict refStream: smartRefStrm
	
	smoothCurve ifNil: [smoothCurve _ false].
	^super convertToCurrentVersion: varDict refStream: smartRefStrm.

! !

!PolygonBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 16:47'!
handlesMouseDown: evt

	^ (super handlesMouseDown: evt) or: [evt shiftPressed]! !

!PolygonBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 16:47'!
mouseDown: evt

	^ evt shiftPressed
		ifTrue: [((owner isKindOf: PolygonMorph) and: [owner includesHandle: self])
					ifTrue: ["Prevent insertion handles from getting edited"
							^ super mouseDown: evt].
				self toggleHandles.
				handles ifNil: [^ self].
				vertices withIndexDo:  "Check for click-to-drag at handle site"
					[:vertPt :vertIndex |
					((handles at: vertIndex*2-1 ifAbsent: [ ^self ]) containsPoint: evt cursorPoint) ifTrue:
						["If clicked near a vertex, jump into drag-vertex action"
						evt hand newMouseFocus: (handles at: vertIndex*2-1)]]]
		ifFalse: [super mouseDown: evt]! !

!PolygonBrick methodsFor: 'geometry eToy' stamp: 'tb 3/8/2003 16:47'!
heading: newHeading
	"Set the receiver's heading (in eToy terms).
	Note that polygons never use flex shells."
	self rotationDegrees: newHeading.! !

!PolygonBrick methodsFor: 'geometry eToy' stamp: 'tb 3/8/2003 16:47'!
referencePosition 
	"Return the current reference position of the receiver"
	^ self valueOfProperty: #referencePosition ifAbsent: [super referencePosition]
! !

!PolygonBrick methodsFor: 'geometry eToy' stamp: 'tb 3/8/2003 16:47'!
rotationCenter
	"Return the rotation center of the receiver. The rotation center defines the relative offset inside the receiver's bounds for locating the reference position."
	| refPos |
	refPos _ self valueOfProperty: #referencePosition
		ifAbsent: [^ 0.5@0.5].
	^ (refPos - self bounds origin) / self bounds extent asFloatPoint! !

!PolygonBrick methodsFor: 'geometry eToy' stamp: 'tb 3/8/2003 16:47'!
rotationCenter: aPointOrNil
	"Set the new rotation center of the receiver. The rotation center defines the relative offset inside the receiver's bounds for locating the reference position."
	| box |
	aPointOrNil isNil
		ifTrue: [self removeProperty: #referencePosition]
		ifFalse: [box _ self bounds.
				self setProperty: #referencePosition
					toValue: box origin + (aPointOrNil * box extent)]
! !

!PolygonBrick methodsFor: 'debug and other' stamp: 'tb 3/8/2003 16:47'!
installModelIn: aWorld
	aWorld isWorldMorph ifTrue: [self addHandles]! !

!PolygonBrick methodsFor: 'dropping/grabbing' stamp: 'tb 3/8/2003 16:47'!
justDroppedInto: newOwner event: evt

	| delta |
	(newOwner isKindOf: PasteUpMorph) ifTrue:
		["Compensate for border width so that gridded drop
			is consistent with gridded drag of handles."
		delta _ borderWidth+1//2.
		self position: (newOwner gridPoint: self position + delta) - delta].
	^ super justDroppedInto: newOwner event: evt! !

!PolygonBrick methodsFor: 'caching' stamp: 'tb 3/8/2003 16:47'!
loadCachedState
	"Prepare for fast response -- next page of a book?"
	self filledForm.
	self arrowForms! !

!PolygonBrick methodsFor: 'caching' stamp: 'tb 3/8/2003 16:47'!
releaseCachedState
	super releaseCachedState.
	filledForm _ nil.
	arrowForms _ nil.
	borderForm _ nil.
	curveState _ nil.
	(self hasProperty: #flex) ifTrue:
		[self removeProperty: #unflexedVertices;
			removeProperty: #flex].
! !

!PolygonBrick methodsFor: 'halo control' stamp: 'tb 3/8/2003 16:47'!
rotationDegrees: degrees 
	| flex center |
	(center _ self valueOfProperty: #referencePosition) ifNil:
		[self setProperty: #referencePosition toValue: (center _ self bounds center)].
	flex _ (MorphicTransform offset: center negated)
			withAngle: (degrees - self forwardDirection) degreesToRadians.
	self setVertices: (vertices collect: [:v | (flex transform: v) - flex offset]).
	self forwardDirection: degrees.

! !

!PolygonBrick methodsFor: 'stepping and presenter' stamp: 'tb 3/8/2003 16:47'!
step
	borderDashSpec ifNil: [^super step].
	borderDashSpec size < 5 ifTrue: [^super step].

	"Only for dashed lines with creep"
	borderDashSpec at: 4 put: (borderDashSpec fourth) + borderDashSpec fifth.
	self changed.
	^super step! !

!PolygonBrick methodsFor: 'testing' stamp: 'tb 3/8/2003 16:47'!
stepTime

	^ 100! !

!PolygonBrick methodsFor: 'testing' stamp: 'tb 3/8/2003 16:47'!
wantsSteps
	super wantsSteps ifTrue: [^true].

	"For crawling ants effect of dashed line."
	borderDashSpec ifNil: [^false].
	^borderDashSpec size = 5 and: [(borderDashSpec fifth) > 0]! !


!PolygonBrick class methodsFor: 'instance creation' stamp: 'tb 3/8/2003 16:47'!
arrowPrototype
	"Answer an instance of the receiver that will serve as a prototypical arrow"

	| aa |
	aa _ self new. 
	aa vertices: (Array with: 0@0 with: 40@40) 
		color: Color black 
		borderWidth: 2 
		borderColor: Color black.
	aa setProperty: #noNewVertices toValue: true.
	aa makeForwardArrow.		"is already open"
	aa computeBounds.
	^ aa! !

!PolygonBrick class methodsFor: 'instance creation' stamp: 'tb 3/8/2003 16:47'!
fromHand: hand
	"Let the user draw a polygon, clicking at each vertex, and ending
		by clicking within 5 of the first point..."
	| p1 poly oldVerts pN opposite |
	Cursor crossHair showWhile:
		[[Sensor anyButtonPressed] whileFalse:
			[self currentWorld displayWorldSafely; runStepMethods].
		p1 _ Sensor cursorPoint].
	opposite _ (Display colorAt: p1) negated.
	opposite = Color transparent ifTrue: [opposite _ Color red].
	(poly _ LineMorph from: p1 to: p1 color: opposite width: 2) openInWorld.
	oldVerts _ {p1}.
	self currentWorld displayWorldSafely; runStepMethods.
	[true] whileTrue:
		[[Sensor anyButtonPressed] whileTrue:
			[pN _ Sensor cursorPoint.
			poly setVertices: (oldVerts copyWith: pN).
			self currentWorld displayWorldSafely; runStepMethods].
		(oldVerts size > 1 and: [(pN dist: p1) < 5]) ifTrue:
			[hand position: Sensor cursorPoint.  "Done -- update hand pos"
			^ (poly setVertices: (poly vertices copyWith: p1)) delete].
		oldVerts _ poly vertices.
		[Sensor anyButtonPressed] whileFalse:
			[pN _ Sensor cursorPoint.
			poly setVertices: (oldVerts copyWith: pN).
			self currentWorld displayWorldSafely; runStepMethods]].
! !

!PolygonBrick class methodsFor: 'instance creation' stamp: 'tb 3/8/2003 16:47'!
fromHandFreehand: hand
	"Let the user draw a polygon, holding the mouse down, and ending
		by clicking within 5 of the first point..."
	| p1 poly pN opposite |
	Cursor crossHair showWhile:
		[[Sensor anyButtonPressed] whileFalse:
			[self currentWorld displayWorldSafely; runStepMethods].
		p1 _ Sensor cursorPoint].
	opposite _ (Display colorAt: p1) negated.
	opposite = Color transparent ifTrue: [opposite _ Color red].
	(poly _ LineMorph from: p1 to: p1 color: opposite width: 2) openInWorld.
	self currentWorld displayWorldSafely; runStepMethods.
	[Sensor anyButtonPressed] whileTrue:
			[pN _ Sensor cursorPoint.
			(pN dist: poly vertices last) > 3 ifTrue:
				[poly setVertices: (poly vertices copyWith: pN).
				self currentWorld displayWorldSafely; runStepMethods]].
	hand position: Sensor cursorPoint.  "Done -- update hand pos"
	^ (poly setVertices: (poly vertices copyWith: p1)) delete! !

!PolygonBrick class methodsFor: 'instance creation' stamp: 'tb 3/8/2003 16:47'!
shapeFromPen: penBlock color: c borderWidth: bw borderColor: bc
	"World addMorph: (PolygonMorph
		shapeFromPen: [:p | p hilbert: 4 side: 5. p go: 5.
						p hilbert: 4 side: 5. p go: 5]
		color: Color red borderWidth: 1 borderColor: Color black)"

	| pen |
	penBlock value: (pen _ PenPointRecorder new).
	^ (self vertices: pen points asArray color: c borderWidth: bw borderColor: bc)
		quickFill: false! !

!PolygonBrick class methodsFor: 'instance creation' stamp: 'tb 3/8/2003 16:47'!
vertices: verts color: c borderWidth: bw borderColor: bc
	^ self basicNew beStraightSegments vertices: verts color: c borderWidth: bw borderColor: bc! !

!PolygonBrick class methodsFor: 'parts bin' stamp: 'tb 3/8/2003 16:47'!
descriptionForPartsBin
	^ self partName:	'Polygon'
		categories:		#('Graphics' ' Basic 1 ')
		documentation:	'A series of connected line segments, which may be a closed solid, or a zig-zag line.  Shift-click to get handles and move the points.'! !

!PolygonBrick class methodsFor: 'parts bin' stamp: 'tb 3/8/2003 16:47'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Arrow'
		categoryList: #(' Basic 1 ' 'Graphics')
		documentation: 'A line with an arrowhead.  Shift-click to get handles and move the ends.'
		globalReceiverSymbol: #PolygonMorph
		nativitySelector: #arrowPrototype}
! !


!ProtoWorld methodsFor: 'drawing' stamp: 'tb 3/11/2003 14:13'!
drawOn: aCanvas
	"draw my own 'display'"
	super drawOn: aCanvas.
	"aCanvas drawImage: myDisplay at: (bounds origin)."! !

!ProtoWorld methodsFor: 'event handling' stamp: 'tb 3/11/2003 14:09'!
handleEvent: anEvent
	"pass those events that we care about into our own environment"
	| evt |
	(#(mouseDown mouseUp mouseMove
	keyDown keyUp keystroke) includes: anEvent type) ifTrue:[
		"pass them into our own environment"
	].
	^super handleEvent: anEvent
! !

!ProtoWorld methodsFor: 'event handling' stamp: 'tb 3/11/2003 14:10'!
handlerForMouseDown: anEvent
	"answer self so we don't have to implement the entire wantsXYZ
stuff"
	^self

! !

!ProtoWorld methodsFor: 'event handling' stamp: 'tb 3/11/2003 14:10'!
handlesMouseOver: evt
	"answer true"
	^true

! !

!ProtoWorld methodsFor: 'event handling' stamp: 'tb 3/11/2003 14:11'!
mouseEnter: evt
	"grab keyboard"
	evt hand newKeyboardFocus: self.
! !


!RolloverBorderPainter methodsFor: 'geometry' stamp: 'tb 3/17/2003 10:50'!
expandBounds: aRectangle inBrick: aBrick 

	^aRectangle expandBy: self rolloverWidth.

! !

!RolloverBorderPainter methodsFor: 'painting' stamp: 'tb 3/17/2003 12:15'!
paintBrick: aBrick onCanvas: aCanvas

	| colorToUse offsetToUse myShadow newForm f myShadowCanvas |

	"Try to get out of it"
	(aCanvas seesNothingOutside: aBrick bounds) ifTrue: [^self].

	colorToUse _ self rolloverColor.
	offsetToUse _ self rolloverWidth.

	"Get the shadow of the brick as a form"
	myShadowCanvas _ (Display defaultCanvasClass extent: aBrick bounds extent depth: 1)
				asShadowDrawingCanvas: Color black. "Color black represents one for 1bpp"
	myShadowCanvas translateBy: aBrick bounds topLeft negated
		during:[:tempCanvas | aBrick paintOn: tempCanvas ].
	myShadow := myShadowCanvas form offset: aBrick bounds topLeft.

	myShadow offset: 0@0.
	f _ ColorForm extent: myShadow extent depth: 1.
	myShadow displayOn: f.
	f colors: {Color transparent. colorToUse}.

	newForm _ Form extent: offsetToUse * 2 + myShadow extent depth: 32.
     (WarpBlt current toForm: newForm)
		sourceForm: f;
		cellSize: 2; 
		combinationRule: 3;
		copyQuad: f boundingBox innerCorners toRect: newForm boundingBox.
	aCanvas 
		translateBy: offsetToUse negated
		during: [ :shadowCanvas |
			shadowCanvas shadowColor: colorToUse.
			shadowCanvas paintImage: newForm at: aBrick position.
		].

! !

!RolloverBorderPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 10:18'!
rolloverColor

	 ^rolloverColor 
		ifNil: [rolloverColor := Color blue alpha: 0.5] 
		ifNotNil: [ rolloverColor ].! !

!RolloverBorderPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 10:28'!
rolloverColor: aColor

	rolloverColor := aColor! !

!RolloverBorderPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 10:19'!
rolloverWidth

	 ^rolloverWidth
		ifNil: [rolloverWidth := 10@10] 
		ifNotNil: [ rolloverWidth ].! !

!RolloverBorderPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 10:28'!
rolloverWidth: aPoint

	rolloverWidth := aPoint! !


!RolloverBorderPainter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 10:14'!
defaultLayer

	^self rolloverBorderLayer! !


!ShadowPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 02:47'!
borderWidth

	^borderWidth! !

!ShadowPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 11:51'!
color

	^color ifNil: [color := Color black alpha: 0.5] ifNotNil: [ color ]! !

!ShadowPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 11:52'!
color: aColor

	color := aColor! !

!ShadowPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 02:21'!
shadowColor

	^shadowColor ifNil: [shadowColor := Color black] ifNotNil: [ shadowColor ]! !

!ShadowPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 02:21'!
shadowColor: aColor

	shadowColor := aColor! !

!ShadowPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 02:54'!
shadowOffset

	^shadowOffset ifNil: [shadowOffset := 5@5] ifNotNil: [shadowOffset]! !

!ShadowPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 02:19'!
shadowOffset: aNumberOrPoint

	shadowOffset := aNumberOrPoint! !

!ShadowPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 11:52'!
width

	^width ifNil: [width := 3@3] ifNotNil: [width]! !

!ShadowPainter methodsFor: 'accessing' stamp: 'tb 3/17/2003 11:55'!
width: aPointOrNumber

	| |

	aPointOrNumber isPoint 
		ifFalse: [ width := ((aPointOrNumber@aPointOrNumber)asIntegerPoint)]
		ifTrue: [width := aPointOrNumber asIntegerPoint].
! !

!ShadowPainter methodsFor: 'geometry' stamp: 'tb 3/17/2003 09:39'!
expandBounds: aRectangle inBrick: aBrick

	"Return an expanded rectangle for an eventual drop shadow"

	| delta box |

	box _ aRectangle.
	delta _ self shadowOffset.
	box _ delta x >= 0 
		ifTrue:[box right: aRectangle right + delta x]
		ifFalse:[box left: aRectangle left + delta x].

	box _ delta y >= 0
		ifTrue:[box bottom: aRectangle bottom + delta y]
		ifFalse:[box top: aRectangle top + delta y].

	^box! !

!ShadowPainter methodsFor: 'painting' stamp: 'tb 3/17/2003 12:00'!
paintBrick: aBrick onCanvas: aCanvas

	"avoid double drawing shadows"
	aBrick owner == aBrick activeHand ifTrue: [^self].
	aCanvas 
		translateBy: self width 
		during: [ :shadowCanvas |
			shadowCanvas shadowColor: self color. 
			(shadowCanvas isVisible: aBrick bounds) ifTrue: 
			[
				aBrick paintOn: shadowCanvas. 
			]
		]
		
! !


!ShadowPainter class methodsFor: 'class initialization' stamp: 'tb 3/17/2003 12:04'!
color: aColor width: aPoint

	| me |
	me := self new color: aColor.
	^me width: aPoint
	! !

!ShadowPainter class methodsFor: 'layerNumbers' stamp: 'tb 3/17/2003 00:53'!
defaultLayer

	^self shadowLayer! !


!StringBrick methodsFor: 'editing' stamp: 'tb 3/9/2003 00:13'!
acceptContents
	"The message is sent when the user hits enter or Cmd-S. Accept the current contents and end editing. This default implementation does nothing."
! !

!StringBrick methodsFor: 'editing' stamp: 'tb 3/9/2003 00:13'!
acceptValue: aValue
	| val |
	self contents: (val _ aValue asString).
	^ val! !

!StringBrick methodsFor: 'editing' stamp: 'tb 3/9/2003 00:13'!
cancelEdits

	self doneWithEdits! !

!StringBrick methodsFor: 'editing' stamp: 'tb 3/9/2003 00:13'!
doneWithEdits

	hasFocus _ false! !

!StringBrick methodsFor: 'editing' stamp: 'tb 3/9/2003 00:13'!
launchMiniEditor: evt

	| textMorph |
	hasFocus _ true.  "Really only means edit in progress for this morph"
	textMorph _ StringMorphEditor new contentsAsIs: contents.
	textMorph beAllFont: self fontToUse.
	textMorph bounds: (self bounds expandBy: 0@2).
	self addMorphFront: textMorph.
	evt hand newMouseFocus: textMorph. self flag: #arNote. "Why???"
	evt hand newKeyboardFocus: textMorph.
	textMorph editor selectFrom: 1 to: textMorph paragraph text string size! !

!StringBrick methodsFor: 'editing' stamp: 'tb 3/9/2003 00:13'!
lostFocusWithoutAccepting
	"The message is sent when the user, having been in an editing episode on the receiver, changes the keyboard focus -- typically by clicking on some editable text somewhere else -- without having accepted the current edits."

	self acceptContents! !

!StringBrick methodsFor: 'editing' stamp: 'tb 3/9/2003 00:13'!
wantsKeyboardFocusOnShiftClick
	^ owner topRendererOrSelf wantsKeyboardFocusFor: self
! !

!StringBrick methodsFor: 'menus' stamp: 'tb 3/9/2003 00:13'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'change font' action: #changeFont.
	aCustomMenu add: 'change emphasis' action: #changeEmphasis.
! !

!StringBrick methodsFor: 'halos and balloon help' stamp: 'tb 3/9/2003 00:13'!
addOptionalHandlesTo: aHalo box: box
	self flag: #deferred.

	"Eventually...
	self addFontHandlesTo: aHalo box: box"! !

!StringBrick methodsFor: 'halos and balloon help' stamp: 'tb 3/9/2003 00:13'!
boundsForBalloon
	"Some morphs have bounds that are way too big.  This is a contorted way of making things work okay in PluggableListMorphs, whose list elements historically have huge widths"

	| ownerOwner |
	^ ((owner notNil and: [(ownerOwner _ owner owner) notNil]) and:
			[ownerOwner isKindOf: PluggableListMorph])
		ifTrue:
			[self boundsInWorld intersect: ownerOwner boundsInWorld]
		ifFalse:
			[super boundsForBalloon]! !

!StringBrick methodsFor: 'printing' stamp: 'tb 3/9/2003 00:13'!
balloonTextForClassAndMethodString
	"Answer suitable balloon text for the receiver thought of as an encoding of the form
		<className>  [ class ] <selector>"

	| aComment |
	Preferences balloonHelpInMessageLists
		ifFalse: [^ nil].
	MessageSet parse: self contents asString toClassAndSelector:
		[:aClass :aSelector |
			(aClass notNil and: [aSelector notNil]) ifTrue:
				[aComment _ aClass precodeCommentOrInheritedCommentFor: aSelector]].
	^ aComment
! !

!StringBrick methodsFor: 'printing' stamp: 'tb 3/9/2003 00:13'!
balloonTextForLexiconString
	"Answer suitable balloon text for the receiver thought of as an encoding (used in Lexicons) of the form
		<selector> <spaces> (<className>>)"

	| aComment contentsString aSelector aClassName |
	Preferences balloonHelpInMessageLists
		ifFalse: [^ nil].
	contentsString _ self contents asString.
	aSelector _ contentsString upTo: $ .
	aClassName _ contentsString copyFrom: ((contentsString indexOf: $() + 1) to: ((contentsString indexOf: $)) - 1).
	MessageSet parse: (aClassName, ' dummy') toClassAndSelector:
		[:cl :sel | cl ifNotNil:
			[aComment _ cl precodeCommentOrInheritedCommentFor: aSelector]].
	^ aComment
! !

!StringBrick methodsFor: 'printing' stamp: 'tb 3/9/2003 00:13'!
balloonTextForMethodString
	"Answer suitable balloon text for the receiver thought of as a method belonging to the currently-selected class of a browser tool."

	| aWindow aCodeHolder aClass |
	Preferences balloonHelpInMessageLists
		ifFalse: [^ nil].
	aWindow _ self ownerThatIsA: SystemWindow.
	(aWindow isNil or: [((aCodeHolder _ aWindow model) isKindOf: CodeHolder) not])
		ifTrue:	[^ nil].
	((aClass _ aCodeHolder selectedClassOrMetaClass) isNil or:
		[(aClass includesSelector: contents asSymbol) not])
			ifTrue: [^ nil].
	^ aClass precodeCommentOrInheritedCommentFor: contents asSymbol
! !

!StringBrick methodsFor: 'printing' stamp: 'tb 3/9/2003 00:13'!
fullPrintOn: aStream

	aStream nextPutAll: '('.
	super fullPrintOn: aStream.
	aStream nextPutAll: ') contents: '; print: contents! !

!StringBrick methodsFor: 'printing' stamp: 'tb 3/9/2003 00:13'!
printOn: aStream

	super printOn: aStream.
	aStream print: contents.
! !

!StringBrick methodsFor: 'menu' stamp: 'tb 3/9/2003 00:13'!
changeEmphasis
	| reply aList |
	aList _ #(plain bold italic narrow underlined struckOut).
	reply _ (SelectionMenu labelList: aList selections: aList) startUp.
	reply ifNotNil:[
		self emphasis: (TextEmphasis perform: reply) emphasisCode.
	].! !

!StringBrick methodsFor: 'menu' stamp: 'tb 3/9/2003 00:13'!
changeFont
	| newFont |
	newFont _ StrikeFont fromUser: self fontToUse.
	newFont ifNotNil:[self font: newFont].! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
contents

	^ contents! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
contents: newContents 
contents := 	newContents isText 
		ifTrue: 
			[emphasis := newContents emphasisAt: 1.
			 newContents string]
		ifFalse: 
			[contents = newContents ifTrue: [^self].	"no substantive change"
			newContents].
	self fitContents! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
contentsClipped: aString
	"Change my text, but do not change my size as a result"
	contents = aString ifTrue: [^ self].  "No substantive change"
	contents _ aString.
	self changed! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
fitContents

	| newBounds boundsChanged |
	newBounds _ self measureContents.
	boundsChanged _ bounds extent ~= newBounds.
	self extent: newBounds.		"default short-circuits if bounds not changed"
	boundsChanged ifFalse: [self changed]! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
font
	"who came up with #fontToUse rather than font?!!"
	^self fontToUse! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
font: aFont

	^ self font: aFont emphasis: 0! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
font: aFont emphasis: emphasisCode
	font _ aFont.
	emphasis _ emphasisCode.
	self fitContents.
"
in inspector say,
	 self font: (TextStyle default fontAt: 2) emphasis: 1
"! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
fontName: fontName size: fontSize

	^ self font: (StrikeFont familyName: fontName size: fontSize) 
			emphasis: 0! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
fontToUse
	| fontToUse |
	fontToUse := font isNil ifTrue: [TextStyle defaultFont] ifFalse: [font].
	(emphasis isNil or: [emphasis = 0]) 
		ifTrue: [^fontToUse]
		ifFalse: [^fontToUse emphasized: emphasis]! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
handsWithMeForKeyboardFocus
	| foc |
	"Answer the hands that have me as their keyboard focus"

	hasFocus ifFalse: [^ #()].
	^ self currentWorld hands select:
		[:aHand | (foc _ aHand keyboardFocus) notNil and: [foc owner == self]]! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
interimContents: aString
	"The receiver is under edit and aString represents the string the user sees as she edits, which typically will not have been accepted and indeed may be abandoned"

	self contents: aString! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
measureContents
	| f |
	f _ self fontToUse.
	^(((f widthOfString: contents) max: self minimumWidth)  @ f height).! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
minimumWidth
	"Answer the minimum width that the receiver can have.  A nonzero value here keeps the receiver from degenerating into something that cannot ever be seen or touched again!!  Obeyed by fitContents."

	^ 3! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
setWidth: width

	self extent: width @ (font ifNil: [TextStyle defaultFont]) height! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
userString
	"Do I have a text string to be searched on?"

	^ contents! !

!StringBrick methodsFor: 'accessing' stamp: 'tb 3/9/2003 00:13'!
valueFromContents
	"Return a new value from the current contents string."
	^ contents! !

!StringBrick methodsFor: 'initialization' stamp: 'tb 3/9/2003 00:13'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color black! !

!StringBrick methodsFor: 'initialization' stamp: 'tb 3/17/2003 12:46'!
initWithContents: aString font: aFont emphasis: emphasisCode 
	self initialize.
	
	font _ aFont.
	emphasis _ emphasisCode.
	hasFocus _ false.
	self contents: aString! !

!StringBrick methodsFor: 'initialization' stamp: 'tb 3/17/2003 14:23'!
initialize
	
"initialize the state of the receiver"

	super initialize.
	self removePainter: BackgroundPainter.
	self addPainter: self.
	font _ nil.
	emphasis _ 0.
	hasFocus _ false! !

!StringBrick methodsFor: 'drawing' stamp: 'tb 3/9/2003 00:13'!
drawOn: aCanvas

	aCanvas drawString: contents in: bounds font: self fontToUse color: color.! !

!StringBrick methodsFor: 'drawing' stamp: 'tb 3/9/2003 00:13'!
lookTranslucent

	"keep the text the same color (black)"! !

!StringBrick methodsFor: 'font' stamp: 'tb 3/9/2003 00:13'!
emphasis: aNumber
	"Set the receiver's emphasis as indicated"

	"0 -> plain.  
1 -> bold.  2 -> italic.  3 -> bold italic.  4 -> underlined  
5 -> bold underlined.  6 -> italic underlined.   7 -> bold italic underlined   
8 -> narrow.  9 -> bold narrow.10 -> italic narrow.  11 -> bold italic narrow.   
12 -> underlined narrow.  13 -> bold underlined narrow.  14 -> italic underlined narrow.  
15 -> bold underlined italic narrow.  16 -> struckOut.  17 -> bold struckOut. 18 -> italic struckOut
etc...."

	self font: (TextStyle defaultFont emphasized: aNumber)

"	1	bold
	2	italic
	4	underlined
	8	narrow
	16	struckOut"! !

!StringBrick methodsFor: 'layout' stamp: 'tb 3/9/2003 00:13'!
fullBounds
	self contents ifNil: [ self contents: 'String Morph' ].
	^super fullBounds! !

!StringBrick methodsFor: 'layout' stamp: 'tb 3/9/2003 00:13'!
minHeight
"answer the receiver's minHeight"
	^ self fontToUse height! !

!StringBrick methodsFor: 'event handling' stamp: 'tb 3/9/2003 00:13'!
handlesMouseDown: evt
	^ (evt shiftPressed and: [self wantsKeyboardFocusOnShiftClick])
		ifTrue: [true]
		ifFalse: [super handlesMouseDown: evt].
! !

!StringBrick methodsFor: 'event handling' stamp: 'tb 3/9/2003 00:13'!
hasFocus
	^ hasFocus! !

!StringBrick methodsFor: 'event handling' stamp: 'tb 3/9/2003 00:13'!
mouseDown: evt
	"If the shift key is pressed, make this string the keyboard input focus."

	(evt shiftPressed and: [self wantsKeyboardFocusOnShiftClick])
		ifTrue: [self launchMiniEditor: evt]
		ifFalse: [super mouseDown: evt].
! !

!StringBrick methodsFor: 'event handling' stamp: 'tb 3/9/2003 00:13'!
wouldAcceptKeyboardFocus
	^ self isLocked not! !

!StringBrick methodsFor: 'parts bin' stamp: 'tb 3/9/2003 00:13'!
initializeToStandAlone
	super initializeToStandAlone.
	
	font _ nil.
	emphasis _ 0.
	hasFocus _ false.
	self contents: 'String: Shift-click on me to edit'! !


!StringBrick class methodsFor: 'scripting' stamp: 'tb 3/9/2003 00:13'!
authoringPrototype
	^ super authoringPrototype contents: 'String'! !

!StringBrick class methodsFor: 'instance creation' stamp: 'tb 3/9/2003 00:13'!
contents: aString
	" 'StringMorph contents: str' is faster than 'StringMorph new contents: str' "
	^ self contents: aString font: nil! !

!StringBrick class methodsFor: 'instance creation' stamp: 'tb 3/9/2003 00:13'!
contents: aString font: aFont
	^ self basicNew initWithContents: aString font: aFont emphasis: 0! !

!StringBrick class methodsFor: 'instance creation' stamp: 'tb 3/9/2003 00:13'!
contents: aString font: aFont emphasis: emphasisCode
	^ self basicNew initWithContents: aString font: aFont emphasis: emphasisCode! !

!StringBrick class methodsFor: 'parts bin' stamp: 'tb 3/9/2003 00:13'!
descriptionForPartsBin
	^ self partName:	'String'
		categories:		#('Text')
		documentation:	'A single line of characters, all in the same font.  Can be edited by shift-clicking on it.'! !

!StringBrick class methodsFor: 'testing' stamp: 'tb 3/9/2003 00:13'!
test
	"Return a morph with lots of strings for testing display speed."
	| c |
	c _ AlignmentMorph newColumn.
	SystemOrganization categories do:
		[:cat | c addMorph: (StringMorph new contents: cat)].
	^ c! !

!StringBrick class methodsFor: 'testing' stamp: 'tb 3/9/2003 00:13'!
test2
	"Return a morph with lots of strings for testing display speed."
	| c r |
	c _ AlignmentMorph newColumn.
	SystemOrganization categories reverseDo:
		[:cat | c addMorph: (StringMorph new contents: cat)].
	r _ RectangleMorph new extent: c fullBounds extent.
	c submorphsDo: [:m | r addMorph: m].
	^ r
! !


!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
acceptContents
	"The message is sent when the user hits enter or Cmd-S.
	Accept the current contents and end editing.
	This default implementation does nothing."
	self updateFromParagraph! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
acceptOnCR
	"Answer whether the receiver wants to accept when the Return key is hit.  Generic TextMorph has no such feature, but subclasses may."

	^ false! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
cancelEdits
	"The message is sent when the user hits enter or Cmd-L.
	Cancel the current contents and end editing.
	This default implementation does nothing."
	self releaseParagraph! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
chooseAlignment
	self editor changeAlignment.
	self updateFromParagraph! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
chooseEmphasis
	self editor changeEmphasis.
	self updateFromParagraph! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
chooseEmphasisOrAlignment
	self editor changeEmphasisOrAlignment.
	self updateFromParagraph! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
chooseFont
	self editor changeTextFont.
	self updateFromParagraph.! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
chooseStyle
	self editor changeTextFont.
	self updateFromParagraph.! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
enterClickableRegion: evt
	| index isLink |
	evt hand hasSubmorphs ifTrue:[^self].
	evt hand temporaryCursor ifNotNil:[^self].
	paragraph ifNotNil:[
		index _ (paragraph characterBlockAtPoint: evt position) stringIndex.
		isLink _ (paragraph text attributesAt: index forStyle: paragraph textStyle) 
					anySatisfy:[:attr| attr mayActOnClick].
		isLink ifTrue:[Cursor webLink show] ifFalse:[Cursor normal show].
	].
! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
handleEdit: editBlock
	"Ensure that changed areas get suitably redrawn"
	self selectionChanged.  "Note old selection"
		editBlock value.
	self selectionChanged.  "Note new selection"
	self updateFromParagraph  "Propagate changes as necessary"! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
handleInteraction: interactionBlock fromEvent: evt
	"Perform the changes in interactionBlock, noting any change in selection
	and possibly a change in the size of the paragraph (ar 9/22/2001 - added for TextPrintIts)"
	"Also couple ParagraphEditor to Morphic keyboard events"
	| oldEditor oldParagraph oldSize |
	self editor sensor: (KeyboardBuffer new startingEvent: evt).
	oldEditor _ editor.
	oldParagraph _ paragraph.
	oldSize _ oldParagraph text size.

	self selectionChanged.  "Note old selection"

		interactionBlock value.

	(oldParagraph == paragraph) ifTrue:[
		"this will not work if the paragraph changed"
		editor _ oldEditor.     "since it may have been changed while in block"
	].
	self selectionChanged.  "Note new selection"
	(oldSize = paragraph text size)
		ifFalse:[self updateFromParagraph].
! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
hasUnacceptedEdits: aBoolean
	"Ignored here, but noted in TextMorphForEditView"
! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
passKeyboardFocusTo: otherMorph 
	| w |
	self flag: #arNote.	"Do we need this?!!"
	(w := self world) isNil 
		ifFalse: 
			[w 
				handsDo: [:h | h keyboardFocus == self ifTrue: [h newKeyboardFocus: otherMorph]]]! !

!TextBrick methodsFor: 'editing' stamp: 'tb 3/8/2003 17:42'!
xeqLinkText: sourceString withParameter: param
	self confirm: 'xeqLinkText:
' asText allBold , sourceString asText! !

!TextBrick methodsFor: 'layout' stamp: 'tb 3/8/2003 17:42'!
acceptDroppingMorph: aMorph event: evt
	"This message is sent when a morph is dropped onto me."

	self addMorphFront: aMorph fromWorldPosition: aMorph position.
		"Make a TextAnchor and install it in a run."! !

!TextBrick methodsFor: 'menus' stamp: 'tb 3/8/2003 17:42'!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	| outer |
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'text color...' action: #changeTextColor.
	aCustomMenu 
		addUpdating: #autoFitString
		target: self
		action: #autoFitOnOff.
	aCustomMenu 
		addUpdating: #wrapString
		target: self
		action: #wrapOnOff.
	aCustomMenu add: 'text margins...' action: #changeMargins:.
	aCustomMenu add: 'add predecessor' action: #addPredecessor:.
	aCustomMenu add: 'add successor' action: #addSuccessor:.
	(Preferences valueOfFlag: #noviceMode) not 
		& (Preferences valueOfFlag: #simpleMenus) not 
			ifTrue: 
				[aCustomMenu add: 'code pane menu...' action: #yellowButtonActivity.
				aCustomMenu add: 'code pane shift menu....'
					action: #shiftedYellowButtonActivity].
	outer := self owner.
	((outer isKindOf: PolygonMorph) and: [outer isOpen]) 
		ifTrue: 
			[container isNil 
				ifTrue: [aCustomMenu add: 'follow owner''s curve' action: #followCurve]
				ifFalse: 
					[aCustomMenu add: 'reverse direction' action: #reverseCurveDirection.
					aCustomMenu add: 'set baseline' action: #setCurveBaseline:]]
		ifFalse: 
			[(container isNil or: [container fillsOwner not]) 
				ifTrue: [aCustomMenu add: 'fill owner''s shape' action: #fillingOnOff]
				ifFalse: [aCustomMenu add: 'rectangluar bounds' action: #fillingOnOff].
			(container isNil or: [container avoidsOcclusions not]) 
				ifTrue: [aCustomMenu add: 'avoid occlusions' action: #occlusionsOnOff]
				ifFalse: [aCustomMenu add: 'ignore occlusions' action: #occlusionsOnOff]]! !

!TextBrick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/8/2003 17:42'!
addMorphFront: aMorph fromWorldPosition: wp 
	"Overridden for more specific re-layout and positioning"
	aMorph textAnchorType == #document 
		ifFalse:[^self anchorMorph: aMorph at: wp type: aMorph textAnchorType].
	self addMorphFront: aMorph.
! !

!TextBrick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/8/2003 17:42'!
delete
	predecessor ifNotNil: [predecessor setSuccessor: successor].
	successor ifNotNil: [successor setPredecessor: predecessor.
						successor recomposeChain].
	super delete! !

!TextBrick methodsFor: 'submorphs-add/remove' stamp: 'tb 3/8/2003 17:42'!
goBehind
	"We need to save the container, as it knows about fill and run-around"
	| cont |
	container ifNil: [^ super goBehind].
	self releaseParagraph.  "Cause recomposition"
	cont _ container.  "Save the container"
	super goBehind.  "This will change owner, nilling the container"
	container _ cont.  "Restore the container"
	self changed! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
addPredecessor: evt
	| newMorph |
	newMorph _ self copy predecessor: predecessor successor: self.
	newMorph extent: self width @ 100.
	predecessor ifNotNil: [predecessor setSuccessor: newMorph].
	self setPredecessor: newMorph.
	predecessor recomposeChain.
	evt hand attachMorph: newMorph! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
addSuccessor: evt
	| newMorph |
	newMorph _ self copy predecessor: self successor: successor.
	newMorph extent: self width @ 100.
	successor ifNotNil: [successor setPredecessor: newMorph].
	self setSuccessor: newMorph.
	successor recomposeChain.
	evt hand attachMorph: newMorph! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
firstCharacterIndex
	^ self paragraph firstCharacterIndex! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
firstInChain
	"Return the first morph in a chain of textMorphs"

	| first |
	first := self.
	[first predecessor isNil] whileFalse: [first := first predecessor].
	^first! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
isLinkedTo: aMorph
	self firstInChain withSuccessorsDo:
		[:m | m == aMorph ifTrue: [^ true]].
	^ false! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
lastCharacterIndex
	^ self paragraph lastCharacterIndex! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
predecessor
	^ predecessor! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
recomposeChain
	"Recompose this textMorph and all that follow it."
	self withSuccessorsDo:
		[:m |  m text: text textStyle: textStyle;  "Propagate new style if any"
				releaseParagraph;  "Force recomposition"
				fit  "and propagate the change"]! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
startingIndex
	predecessor isNil
		ifTrue: [^ 1].
	^ predecessor lastCharacterIndex + 1 ! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
successor
	^ successor! !

!TextBrick methodsFor: 'linked frames' stamp: 'tb 3/8/2003 17:42'!
withSuccessorsDo: aBlock 
	"Evaluate aBlock for each morph in my successor chain"

	| each |
	each := self.
	[each isNil] whileFalse: 
			[aBlock value: each.
			each := each successor]! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
adjustLineIndicesBy: delta
	paragraph ifNotNil: [paragraph adjustLineIndicesBy: delta]! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
clippingRectangle
	^ self innerBounds! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
composeToBounds
	"Compose my text to fit my bounds.
	If any text lies outside my bounds, it will be clipped, or
	if I have successors, it will be shown in the successors."
	| |
	self releaseParagraph; paragraph.
	container ifNotNil:
		[self privateBounds: container bounds truncated].
	self paragraph positionWhenComposed: self position.
	successor ifNotNil:
		[successor predecessorChanged].

! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
compositionRectangle
	| compRect |
	compRect _ self innerBounds.
	margins ifNotNil: [compRect _ compRect insetBy: margins].
	compRect width < 9 ifTrue: [compRect _ compRect withWidth: 9].
	compRect height < 16 ifTrue: [compRect _ compRect withHeight: 16].
	^ compRect! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
fit
	"Adjust my bounds to fit the text.  Should be a no-op if autoFit is not specified.
	Required after the text changes,
	or if wrapFlag is true and the user attempts to change the extent."

	| newExtent para cBounds lastOfLines heightOfLast |
	self isAutoFit 
		ifTrue: 
			[newExtent := (self paragraph extent max: 9 @ textStyle lineGrid) + (0 @ 2).
			newExtent := newExtent + (2 * borderWidth).
			margins 
				ifNotNil: [newExtent := ((0 @ 0 extent: newExtent) expandBy: margins) extent].
			newExtent ~= bounds extent 
				ifTrue: 
					[(container isNil and: [successor isNil]) 
						ifTrue: 
							[para := paragraph.	"Save para (layoutChanged smashes it)"
							super extent: newExtent.
							paragraph := para]].
			container notNil & successor isNil 
				ifTrue: 
					[cBounds := container bounds truncated.
					"23 sept 2000 - try to allow vertical growth"
					lastOfLines := self paragraph lines last.
					heightOfLast := lastOfLines bottom - lastOfLines top.
					(lastOfLines last < text size 
						and: [lastOfLines bottom + heightOfLast >= self bottom]) 
							ifTrue: 
								[container releaseCachedState.
								cBounds := cBounds origin corner: cBounds corner + (0 @ heightOfLast)].
					self privateBounds: cBounds]].

	"These statements should be pushed back into senders"
	self paragraph positionWhenComposed: self position.
	successor ifNotNil: [successor predecessorChanged].
	self changed	"Too conservative: only paragraph composition
					should cause invalidation."! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
installEditor


	self flag: #bob.		"I don't see any senders (16 Feb 2001)"


	"Install an editor for my paragraph.  This constitutes 'hasFocus'."
	editor ifNotNil: [^ editor].
	^ self installEditorToReplace: nil! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
installEditorToReplace: priorEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray _ priorEditor stateArray].
	editor _ TextMorphEditor new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
paragraph
	"Paragraph instantiation is lazy -- create it only when needed"
	paragraph ifNotNil: [^ paragraph].

self setProperty: #CreatingParagraph toValue: true.

	self setDefaultContentsIfNil.

	"...Code here to recreate the paragraph..."
	paragraph _ (self paragraphClass new textOwner: self owner).
	paragraph wantsColumnBreaks: successor notNil.
	paragraph
		compose: text
		style: textStyle copy
		from: self startingIndex
		in: self container.
	wrapFlag ifFalse:
		["Was given huge container at first... now adjust"
		paragraph adjustRightX].
	self fit.
self removeProperty: #CreatingParagraph.


	^ paragraph! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
paragraphClass
	container ifNil: [^ NewParagraph].
	^ container paragraphClass! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
predecessor: pred successor: succ
	"Private -- for use only in morphic duplication"
	predecessor _ pred.
	successor _ succ.
! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
predecessorChanged
	| newStart oldStart |
	(self hasProperty: #CreatingParagraph) ifTrue: [^self].
	newStart := predecessor isNil 
				ifTrue: [1]
				ifFalse: [predecessor lastCharacterIndex + 1].
	(self paragraph adjustedFirstCharacterIndex ~= newStart 
		or: [newStart >= text size]) 
			ifTrue: 
				[paragraph composeAllStartingAt: newStart.
				self fit]
			ifFalse: 
				["If the offset to end of text has not changed, just slide"

				oldStart := self firstCharacterIndex.
				self withSuccessorsDo: [:m | m adjustLineIndicesBy: newStart - oldStart]]! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
privateOwner: newOwner
	"Nil the container when text gets extracted"
	super privateOwner: newOwner.
	container ifNotNil: [
		newOwner ifNotNil: [
			newOwner isWorldOrHandMorph ifTrue: [self setContainer: nil]]]! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
privateRemoveMorph: aMorph
	| range |
	range _ text find: (TextAnchor new anchoredMorph: aMorph).
	range ifNotNil:
		[self paragraph replaceFrom: range first to: range last
				with: Text new displaying: false.
		self fit].
	aMorph textAnchorType: nil.
	aMorph relativeTextAnchorPosition: nil.
	super privateRemoveMorph: aMorph! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
releaseEditor 
	"Release the editor for my paragraph.  This morph no longer 'hasFocus'."
	editor ifNotNil:
		[self selectionChanged.
		self paragraph selectionStart: nil selectionStop: nil.
		editor _ nil].! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
releaseParagraph

	"a slight kludge so subclasses can have a bit more control over whether the paragraph really 
	gets released. important for GeeMail since the selection needs to be accessible even if the 
	hand is outside me"

	self releaseParagraphReally.
! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
releaseParagraphReally

	"a slight kludge so subclasses can have a bit more control over whether the paragraph really 
	gets released. important for GeeMail since the selection needs to be accessible even if the 
	hand is outside me"

	"Paragraph instantiation is lazy -- it will be created only when needed"
	self releaseEditor.
	paragraph ifNotNil:
		[paragraph _ nil].
	container ifNotNil:
		[container releaseCachedState]! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
selectionChanged
	self paragraph selectionRects do: [:r | self invalidRect: r]! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
setDefaultContentsIfNil
	"Set the default contents"

	| toUse |
	text ifNil:
		[toUse _ self valueOfProperty: #defaultContents.
		toUse ifNil: [toUse _'abc' asText "allBold"].	"try it plain for a while"
		text _ toUse]! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
setPredecessor: newPredecessor
	predecessor _ newPredecessor! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
setSuccessor: newSuccessor

	successor _ newSuccessor.
	paragraph ifNotNil: [paragraph wantsColumnBreaks: successor notNil].
! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
text: t textStyle: s
	"Private -- for use only in morphic duplication"
	text _ t.
	textStyle _ s.
	paragraph ifNotNil: [paragraph textStyle: s]! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
text: t textStyle: s wrap: wrap color: c
	predecessor: pred successor: succ
	"Private -- for use only in morphic duplication"
	text _ t.
	textStyle _ s.
	wrapFlag _ wrap.
	color _ c.
	paragraph _ editor _ container _ nil.
	self predecessor: pred successor: succ! !

!TextBrick methodsFor: 'private' stamp: 'tb 3/8/2003 17:42'!
updateFromParagraph
	"A change has taken place in my paragraph, as a result of editing and I must be updated.  If a line break causes recomposition of the current paragraph, or it the selection has entered a different paragraph, then the current editor will be released, and must be reinstalled with the resulting new paragraph, while retaining any editor state, such as selection, undo state, and current typing emphasis."

	| newStyle sel oldLast oldEditor back |
	paragraph ifNil: [^self].
	wrapFlag ifNil: [wrapFlag := true].
	editor ifNotNil: 
			[oldEditor := editor.
			sel := editor selectionInterval.
			editor storeSelectionInParagraph].
	text := paragraph text.
	paragraph textStyle = textStyle 
		ifTrue: [self fit]
		ifFalse: 
			["Broadcast style changes to all morphs"

			newStyle := paragraph textStyle.
			(self firstInChain text: text textStyle: newStyle) recomposeChain.
			editor ifNotNil: [self installEditorToReplace: editor]].
	super layoutChanged.
	sel ifNil: [^self].

	"If selection is in top line, then recompose predecessor for possible ripple-back"
	predecessor ifNotNil: 
			[sel first <= (self paragraph lines first last + 1) 
				ifTrue: 
					[oldLast := predecessor lastCharacterIndex.
					predecessor paragraph 
						recomposeFrom: oldLast
						to: text size
						delta: 0.
					oldLast = predecessor lastCharacterIndex 
						ifFalse: 
							[predecessor changed.	"really only last line"
							self predecessorChanged]]].
	((back := predecessor notNil 
				and: [sel first <= self paragraph firstCharacterIndex]) or: 
				[successor notNil 
					and: [sel first > (self paragraph lastCharacterIndex + 1)]]) 
		ifTrue: 
			["The selection is no longer inside this paragraph.
		Pass focus to the paragraph that should be in control."

			back ifTrue: [predecessor recomposeChain] ifFalse: [self recomposeChain].
			self firstInChain withSuccessorsDo: 
					[:m | 
					(sel first between: m firstCharacterIndex and: m lastCharacterIndex + 1) 
						ifTrue: 
							[m installEditorToReplace: oldEditor.
							^self passKeyboardFocusTo: m]].
			self error: 'Inconsistency in text editor'	"Must be somewhere in the successor chain"].
	editor ifNil: 
			["Reinstate selection after, eg, style change"

			self installEditorToReplace: oldEditor]! !

!TextBrick methodsFor: 'anchors' stamp: 'tb 3/8/2003 17:42'!
adjustTextAnchor: aMorph
	"Later compute the new relative position of aMorph if it is #paragraph anchored."! !

!TextBrick methodsFor: 'anchors' stamp: 'tb 3/8/2003 17:42'!
anchorMorph: aMorph at: aPoint type: anchorType
	| relPt index newText block |
	aMorph owner == self ifTrue:[self privateRemoveMorph: aMorph].
	aMorph textAnchorType: nil.
	aMorph relativeTextAnchorPosition: nil.
	self addMorphFront: aMorph.
	aMorph textAnchorType: anchorType.
	aMorph relativeTextAnchorPosition: nil.
	anchorType == #document ifTrue:[^self].
	relPt _ self transformFromWorld globalPointToLocal: aPoint.
	index _ (self paragraph characterBlockAtPoint: relPt) stringIndex.
	newText _ Text string: (String value: 1) attribute: (TextAnchor new anchoredMorph: aMorph).
	anchorType == #inline ifTrue:[
		self paragraph replaceFrom: index to: index-1 with: newText displaying: false.
	] ifFalse:[
		index _ index min: paragraph text size.
		index _ paragraph text string lastIndexOf: Character cr startingAt: index ifAbsent:[0].
		block _ paragraph characterBlockForIndex: index+1.
		aMorph relativeTextAnchorPosition: (relPt x - bounds left) @ (relPt y - block top ).
		self paragraph replaceFrom: index+1 to: index with: newText displaying: false.
	].
	self fit.! !

!TextBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 17:42'!
areasRemainingToFill: aRectangle
	"Overridden from BorderedMorph to test backgroundColor instead of (text) color."
	(backgroundColor isNil or: [backgroundColor isTranslucent])
		ifTrue: [^ Array with: aRectangle].
	self wantsRoundedCorners
	ifTrue: [(borderWidth > 0 and: [borderColor isColor and: [borderColor isTranslucent]])
				ifTrue: [^ aRectangle areasOutside: (self innerBounds intersect: self boundsWithinCorners)]
				ifFalse: [^ aRectangle areasOutside: self boundsWithinCorners]]
	ifFalse: [(borderWidth > 0 and: [borderColor isColor and: [borderColor isTranslucent]])
				ifTrue: [^ aRectangle areasOutside: self innerBounds]
				ifFalse: [^ aRectangle areasOutside: self bounds]]! !

!TextBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 17:42'!
debugDrawLineRectsOn: aCanvas
	"Shows where text line rectangles are"
	self paragraph lines do:
		[:line | aCanvas frameRectangle: line rectangle color: Color brown]
! !

!TextBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 17:42'!
drawNullTextOn: aCanvas
	"make null text frame visible"

	aCanvas fillRectangle: bounds color: 
		((Color black) alpha: 0.1).
! !

!TextBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 17:42'!
drawOn: aCanvas
	"Draw the receiver on a canvas"

	| fauxBounds |
	self setDefaultContentsIfNil.
	super drawOn: aCanvas.  "Border and background if any"
	false ifTrue: [self debugDrawLineRectsOn: aCanvas].  "show line rects for debugging"
	(self startingIndex > text size)
		ifTrue: [self drawNullTextOn: aCanvas].
	"Hack here:  The canvas expects bounds to carry the location of the text, but we also need to communicate clipping."
	fauxBounds _ self bounds topLeft corner: self innerBounds bottomRight.
	aCanvas paragraph: self paragraph bounds: fauxBounds color: color! !

!TextBrick methodsFor: 'drawing' stamp: 'tb 3/8/2003 20:28'!
selectionColor

	Display depth = 1 ifTrue: [^ Color veryLightGray].
	Display depth = 2 ifTrue: [^ Color gray].
	^ Preferences textHighlightColor! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
asText
	^ text! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
autoFit: trueOrFalse
	self isAutoFit = trueOrFalse ifTrue: [^ self].
	self autoFitOnOff! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
backgroundColor
	^ backgroundColor! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
backgroundColor: newColor
	backgroundColor _ newColor.
	self changed! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
borderWidth: newWidth
	super borderWidth: newWidth.
	paragraph ifNotNil: [self composeToBounds].! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
contents

	^ text! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
contents: stringOrText
	^ self contentsAsIs: stringOrText! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
contents: stringOrText wrappedTo: width
	"Accept new text contents.  Lay it out, wrapping to width.
	Then fit my height to the result."
	self newContents: ''.
	wrapFlag _ true.
	super extent: width truncated@self height.
	self newContents: stringOrText! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
contentsAsIs: stringOrText
	"Accept new text contents with line breaks only as in the text.
	Fit my width and height to the result."
	wrapFlag _ false.
	container ifNotNil: [container fillsOwner ifTrue: [wrapFlag _ true]].
	self newContents: stringOrText! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
contentsWrapped: stringOrText
	"Accept new text contents.  Lay it out, wrapping within my current width.
	Then fit my height to the result."
	wrapFlag _ true.
	self newContents: stringOrText! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
crAction
	"Return the action to perform when encountering a CR in the input"
	^self valueOfProperty: #crAction! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
crAction: aMessageSend
	"Return the action to perform when encountering a CR in the input"
	^self setProperty: #crAction toValue: aMessageSend! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
editor
	"Return my current editor, or install a new one."
	editor ifNotNil: [^ editor].
	^ self installEditorToReplace: nil! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/17/2003 20:42'!
fontName: fontName size: fontSize

	| newTextStyle |
	newTextStyle _ (TextStyle named: fontName asSymbol) copy.
	newTextStyle ifNil: [self halt: 'Error: font ', fontName, ' not found.'].

	textStyle _ newTextStyle.
	text addAttribute: (TextFontChange fontNumber: (newTextStyle fontIndexOfSize: fontSize)).
	paragraph ifNotNil: [paragraph textStyle: newTextStyle]! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
getCharacters
	"obtain a string value from the receiver"

	^ self text string copy! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
getFirstCharacter
	"obtain the first character from the receiver if it is empty, return a  
	black dot"
	| aString |
	^ (aString _ text string) isEmpty
		ifTrue: ['']
		ifFalse: [aString first] ! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
hasTranslucentColor
	"Overridden from BorderedMorph to test backgroundColor instead of (text) color."

	backgroundColor ifNil: [^ true].
	(backgroundColor isColor and: [backgroundColor isTranslucentColor]) ifTrue: [^ true].
	(borderColor isColor and: [borderColor isTranslucentColor]) ifTrue: [^ true].
	^ false
! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
isAutoFit
	^ self valueOfProperty: #autoFitContents ifAbsent: [true]
! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
isWrapped
	
	^wrapFlag! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
margins

	^margins! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
margins: newMargins
	"newMargins can be a number, point or rectangle, as allowed by, eg, insetBy:."

	margins _ newMargins.
	self composeToBounds! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
newContents: stringOrText 
	"Accept new text contents."
	| newText embeddedMorphs |
	"If my text is all the same font, use the font for my new contents"
	newText _ stringOrText isString ifTrue: [ | textSize |
		(text notNil
		  and: [ (textSize _ text size) > 0
		    and: [ (text runLengthFor: 1) = textSize ]]) ifTrue: [ | attribs |
			attribs _ text attributesAt: 1 forStyle: textStyle.
			Text string: stringOrText copy attributes: attribs.
		]
		ifFalse: [ Text fromString: stringOrText copy ]
	]
	ifFalse: [ stringOrText copy asText.	"should be veryDeepCopy?" ].

	text = newText ifTrue: [^ self].	"No substantive change"
	text ifNotNil: [(embeddedMorphs _ text embeddedMorphs)
			ifNotNil: 
				[self removeAllMorphsIn: embeddedMorphs.
				embeddedMorphs do: [:m | m delete]]].

	text _ newText.

	"add all morphs off the visible region; they'll be moved into the right 
	place when they become visible. (this can make the scrollable area too 
	large, though)"
	newText embeddedMorphs do: 
		[:m | 
		self addMorph: m.
		m position: -1000 @ 0].
	self releaseParagraph.
	"update the paragraph cache"
	self paragraph.
	"re-instantiate to set bounds"
	self world ifNotNil: [self world startSteppingSubmorphsOf: self]! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
setCharacters: chars
	"obtain a string value from the receiver"

	(self getCharacters = chars) ifFalse:
		[self newContents: chars]! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
setFirstCharacter: source 
	"Set the first character of the receiver as indicated"
	| aChar chars |
	aChar _ source asCharacter.
	(chars _ self getCharacters) isEmpty
		ifTrue: [self
				newContents: (String with: aChar)]
		ifFalse: [chars first = aChar
				ifFalse: [self
						newContents: (String
								streamContents: [:aStream | 
									aStream nextPut: aChar.
									aStream
										nextPutAll: (chars copyFrom: 2 to: chars size)])]] ! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
text
	^ text! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
textColor

	^ color! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
textColor: aColor

	color = aColor ifTrue: [^ self].
	color _ aColor.
	self changed.
! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
textStyle
	^textStyle! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
userString
	"Do I have a text string to be searched on?"

	^ text string! !

!TextBrick methodsFor: 'accessing' stamp: 'tb 3/8/2003 17:42'!
wrapFlag: aBoolean
	"Change whether contents are wrapped to the container."

	aBoolean == wrapFlag ifTrue: [^ self].
	wrapFlag _ aBoolean.
	self composeToBounds! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
autoFitOnOff
	self setProperty: #autoFitContents toValue: self isAutoFit not.
	self isAutoFit ifTrue: [self fit]! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
autoFitString
	"Answer the string to put in a menu that will invite the user to switch autoFit mode"

	^ (self isAutoFit
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'text auto fit'
! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
changeMargins: evt
	| handle origin aHand oldMargin newMargin |
	aHand _ evt ifNil: [self primaryHand] ifNotNil: [evt hand].
	origin _ aHand position.
	oldMargin _ margins.
	handle _ HandleMorph new
		forEachPointDo:
			[:newPoint | handle removeAllMorphs.
			handle addMorph:
				(LineMorph from: origin to: newPoint color: Color black width: 1).
			newMargin _ (newPoint - origin max: 0@0) // 5.
			self margins: newMargin]
		lastPointDo:
			[:newPoint | handle deleteBalloon.
			self halo doIfNotNil: [:halo | halo addHandles].
			self rememberCommand:
				(Command new cmdWording: 'margin change';
					undoTarget: self selector: #margins: argument: oldMargin;
					redoTarget: self selector: #margins: argument: newMargin)].
	aHand attachMorph: handle.
	handle setProperty: #helpAtCenter toValue: true.
	handle showBalloon:
'Move cursor down and to the right
to increase margin inset.
Click when done.' hand: evt hand.
	handle startStepping! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
changeTextColor
	"Change the color of the receiver -- triggered, e.g. from a menu"

	self openATextPropertySheet.
">>>>>
	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self activeHand;
		target: self;
		selector: #textColor:;
		originalColor: self textColor;
		putUpFor: self near: self fullBoundsInWorld
<<<<"! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
followCurve
	self setContainer: (TextOnCurveContainer new baseline: 0; textDirection: 1).
	self changed! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
reverseCurveDirection
	container textDirection: container textDirection negated.
	self paragraph composeAll! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
setCurveBaseline: evt
	| handle origin |
	origin _ evt cursorPoint.
	handle _ HandleMorph new forEachPointDo:
		[:newPoint | handle removeAllMorphs.
		handle addMorph:
			(PolygonMorph vertices: (Array with: origin with: newPoint)
				color: Color black borderWidth: 1 borderColor: Color black).
		container baseline: (newPoint - origin) y negated asInteger // 5.
		self paragraph composeAll].
	evt hand attachMorph: handle.
	handle startStepping	! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
shiftedYellowButtonActivity
	"Supply the normal 'code pane' menu to use its text editing commands from a menu."

	self editor pluggableYellowButtonActivity: true.
	self changed.
! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
wrapOnOff
	self wrapFlag: wrapFlag not! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
wrapString
	"Answer the string to put in a menu that will invite the user to switch autoFit mode"

	^ (wrapFlag
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'text wrap to bounds'
! !

!TextBrick methodsFor: 'menu' stamp: 'tb 3/8/2003 17:42'!
yellowButtonActivity
	"Supply the normal 'code pane' menu to use its text editing commands from a menu."

	self editor pluggableYellowButtonActivity: false.
	self changed.
! !

!TextBrick methodsFor: 'testing' stamp: 'tb 3/8/2003 17:42'!
basicType
	"Answer a symbol representing the inherent type I hold"

	"Number String Boolean player collection sound color etc"
	^ #Text! !

!TextBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:42'!
beAllFont: aFont

	textStyle _ TextStyle fontArray: (Array with: aFont).
	self releaseCachedState; changed! !

!TextBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:42'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color black! !

!TextBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:42'!
initialize
	super initialize.
	borderWidth _ 0.
	textStyle _ TextStyle default copy.
	wrapFlag _ true.
! !

!TextBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:42'!
setTextStyle: aTextStyle

	textStyle _ aTextStyle.
	self releaseCachedState; changed! !

!TextBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:42'!
string: aString fontName: aName size: aSize

	self string: aString fontName: aName size: aSize wrap: true! !

!TextBrick methodsFor: 'initialization' stamp: 'tb 3/8/2003 17:42'!
string: aString fontName: aName size: aSize wrap: shouldWrap

	shouldWrap
		ifTrue: [self contentsWrapped: aString]
		ifFalse: [self contents: aString].
	self fontName: aName size: aSize! !

!TextBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:42'!
bounds
	container ifNil: [^ bounds].
	^ container bounds ifNil: [bounds]! !

!TextBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:42'!
container
	"Return the container for composing this text.  There are four cases:
	1.  container is specified as, eg, an arbitrary shape,
	2.  container is specified as the bound rectangle, because
		this morph is linked to others,
	3.  container is nil, and wrap is true -- grow downward as necessary,
	4.  container is nil, and wrap is false -- grow in 2D as nexessary."

	container ifNil:
		[successor ifNotNil: [^ self compositionRectangle].
		wrapFlag ifTrue: [^ self compositionRectangle withHeight: 9999999].
		^ self compositionRectangle topLeft extent: 9999999@9999999].
	^ container! !

!TextBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:42'!
defaultLineHeight
	^ textStyle lineGrid! !

!TextBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:42'!
extent: aPoint 
	| newExtent priorEditor |
	priorEditor _ editor.
	self isAutoFit
		ifTrue: [wrapFlag ifFalse: [^ self].  "full autofit can't change"
				newExtent _ aPoint truncated max: self minimumExtent.
				newExtent x = self extent x ifTrue: [^ self].  "No change of wrap width"
				self releaseParagraphReally.  "invalidate the paragraph cache"
				super extent: newExtent.
				priorEditor
					ifNil: [self fit]  "since the width has changed..."
					ifNotNil: [self installEditorToReplace: priorEditor]]
		ifFalse: [super extent: (aPoint truncated max: self minimumExtent).
				wrapFlag ifFalse: [^ self].  "no effect on composition"
				self composeToBounds]
! !

!TextBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:42'!
minimumExtent
	| minExt |
	textStyle ifNil: [^ 9@16].
	borderWidth ifNil: [^ 9@16].
	minExt _ (9@(textStyle lineGrid+2)) + (borderWidth*2).
	margins ifNil: [^ minExt].
	^ ((0@0 extent: minExt) expandBy: margins) extent! !

!TextBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:42'!
privateMoveBy: delta 
	super privateMoveBy: delta.
	editor isNil 
		ifTrue: [paragraph ifNotNil: [paragraph moveBy: delta]]
		ifFalse: 
			["When moving text with an active editor, save and restore all state."

			paragraph moveBy: delta.
			self installEditorToReplace: editor]! !

!TextBrick methodsFor: 'geometry' stamp: 'tb 3/8/2003 17:42'!
textBounds
	^ bounds! !

!TextBrick methodsFor: 'alignment' stamp: 'tb 3/8/2003 17:42'!
centered 
	self paragraph centered.
	self updateFromParagraph ! !

!TextBrick methodsFor: 'alignment' stamp: 'tb 3/8/2003 17:42'!
justified 
	self paragraph justified.
	self updateFromParagraph! !

!TextBrick methodsFor: 'alignment' stamp: 'tb 3/8/2003 17:42'!
leftFlush 
	self paragraph leftFlush.
	self updateFromParagraph! !

!TextBrick methodsFor: 'alignment' stamp: 'tb 3/8/2003 17:42'!
rightFlush 
	self paragraph rightFlush.
	self updateFromParagraph! !

!TextBrick methodsFor: 'e-toy support' stamp: 'tb 3/8/2003 17:42'!
configureForKids
	super configureForKids.
	self lock! !

!TextBrick methodsFor: 'e-toy support' stamp: 'tb 3/8/2003 17:42'!
getNumericValue
	"Obtain a numeric value from the receiver; if no digits, return zero"

	| aString |
	^ [(aString _ text string) asNumber] ifError: [:a :b | ^ aString asInteger ifNil: [0]]! !

!TextBrick methodsFor: 'e-toy support' stamp: 'tb 3/8/2003 17:42'!
setNumericValue: aValue
	"Set the contents of the receiver to be a string obtained from aValue"

	self newContents: aValue asString! !

!TextBrick methodsFor: 'geometry testing' stamp: 'tb 3/8/2003 17:42'!
containsPoint: aPoint
	(super containsPoint: aPoint) ifFalse: [^ false].  "Not in my bounds"
	container ifNil: [^ true].  "In bounds of simple text"
	self startingIndex > text size ifTrue:
		["make null text frame visible"
		^ super containsPoint: aPoint].
	"In complex text (non-rect container), test by line bounds"
	^ self paragraph containsPoint: aPoint
! !

!TextBrick methodsFor: 'objects from disk' stamp: 'tb 3/8/2003 17:42'!
convertToCurrentVersion: varDict refStream: smartRefStrm
	
	borderWidth ifNil:
		[borderWidth _ 0.
		self removeProperty: #fillStyle].
	^ super convertToCurrentVersion: varDict refStream: smartRefStrm.

! !

!TextBrick methodsFor: 'copying' stamp: 'tb 3/8/2003 17:42'!
copy
	^ super copy text: text copy textStyle: textStyle copy 
		wrap: wrapFlag color: color
		predecessor: nil successor: nil! !

!TextBrick methodsFor: 'copying' stamp: 'tb 3/8/2003 17:42'!
updateReferencesUsing: refDict
	| anchors range new |
	super updateReferencesUsing: refDict.
	"Update any anchors in the text of a newly copied morph"
	anchors _ IdentityDictionary new.
	text runs withStartStopAndValueDo:
		[:start :stop :attributes |
		attributes do: [:att | (att isMemberOf: TextAnchor)
							ifTrue: [anchors at: att put: (start to: stop)]]].
	anchors isEmpty ifTrue: [^ self].
	anchors keysDo:
		[:old |  range _ anchors at: old.
		text removeAttribute: old from: range first to: range last.
		new _ TextAnchor new anchoredMorph:
					(refDict at: old anchoredMorph).
		text addAttribute: new from: range first to: range last].
	self layoutChanged "for good measure"! !

!TextBrick methodsFor: 'copying' stamp: 'tb 3/8/2003 17:42'!
veryDeepFixupWith: deepCopier 
	"If target and arguments fields were weakly copied, fix them here.  If 
	they were in the tree being copied, fix them up, otherwise point to the 
	originals!!"

	super veryDeepFixupWith: deepCopier.
	"It makes no sense to share pointers to an existing predecessor and successor"
	predecessor _ deepCopier references at: predecessor ifAbsent: [nil].
	successor _ deepCopier references at: successor ifAbsent: [nil]! !

!TextBrick methodsFor: 'copying' stamp: 'tb 3/8/2003 17:42'!
veryDeepInner: deepCopier 
	"Copy all of my instance variables. Some need to be not copied at all, but shared.
	Warning!!!! Every instance variable defined in this class must be handled.
	We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	textStyle _ textStyle veryDeepCopyWith: deepCopier.
	text _ text veryDeepCopyWith: deepCopier.
	wrapFlag _ wrapFlag veryDeepCopyWith: deepCopier.
	paragraph _ paragraph veryDeepCopyWith: deepCopier.
	editor _ editor veryDeepCopyWith: deepCopier.
	container _ container veryDeepCopyWith: deepCopier.
	predecessor _ predecessor.
	successor _ successor.
	lastGesture _ lastGesture veryDeepCopyWith: deepCopier.
	backgroundColor _ backgroundColor veryDeepCopyWith: deepCopier.
	margins _ margins veryDeepCopyWith: deepCopier.
! !

!TextBrick methodsFor: 'card in a stack' stamp: 'tb 3/8/2003 17:42'!
couldHoldSeparateDataForEachInstance
	"Answer whether this type of morph is inherently capable of holding separate data for each instance ('card data')"

	^ true! !

!TextBrick methodsFor: 'player' stamp: 'tb 3/8/2003 17:42'!
currentDataValue
	"Answer the current data value held by the receiver"

	^ text! !

!TextBrick methodsFor: 'player' stamp: 'tb 3/8/2003 17:42'!
variableDocks
	"Answer a list of VariableDock objects for docking up my data with an instance held in my containing playfield"

	^ Array with: (VariableDock new variableName: self defaultVariableName type: #text definingMorph: self morphGetSelector: #contents morphPutSelector: #setNewContentsFrom:)! !

!TextBrick methodsFor: 'genie-processing' stamp: 'tb 3/8/2003 17:42'!
defaultGestureDictionaryOrName
	^ #Text! !

!TextBrick methodsFor: 'genie-processing' stamp: 'tb 3/8/2003 17:42'!
gestureHandler
	"If the TextMorph is part of a pane (like PluggableTextMorph), return it"

	| pane |
	pane _ self owner.
	[pane notNil] whileTrue: 
		[(pane isKindOf: PluggableTextMorph) ifTrue: [^ pane].
		pane _ pane owner].
	^ super gestureHandler! !

!TextBrick methodsFor: 'visual properties' stamp: 'tb 3/8/2003 17:42'!
fillStyle
	"Return the current fillStyle of the receiver."
	^ self
		valueOfProperty: #fillStyle
		ifAbsent: [backgroundColor
				ifNil: [Color transparent]]! !

!TextBrick methodsFor: 'visual properties' stamp: 'tb 3/8/2003 17:42'!
fillStyle: aFillStyle
	"Set the current fillStyle of the receiver."
	self setProperty: #fillStyle toValue: aFillStyle.
	"Workaround for Morphs not yet converted"
	backgroundColor _ aFillStyle asColor.
	self changed.! !

!TextBrick methodsFor: 'containment' stamp: 'tb 3/8/2003 17:42'!
fillingOnOff
	"Establish a container for this text, with opposite filling status"
	self setContainer:
	(container
		ifNil: [TextContainer new for: self minWidth: textStyle lineGrid*2]
		ifNotNil: [(container fillsOwner and: [container avoidsOcclusions not])
			ifTrue: [nil  "Return to simple rectangular bounds"]
			ifFalse: [container fillsOwner: container fillsOwner not]])! !

!TextBrick methodsFor: 'containment' stamp: 'tb 3/8/2003 17:42'!
occlusionsOnOff
	"Establish a container for this text, with opposite occlusion avoidance status"
	self setContainer:
	(container
	ifNil: [(TextContainer new for: self minWidth: textStyle lineGrid*2)
							fillsOwner: false; avoidsOcclusions: true]
	ifNotNil: [(container avoidsOcclusions and: [container fillsOwner not])
			ifTrue: [nil  "Return to simple rectangular bounds"]
			ifFalse: [container avoidsOcclusions: container avoidsOcclusions not]])! !

!TextBrick methodsFor: 'containment' stamp: 'tb 3/8/2003 17:42'!
recognizerArena
	"Answer the rectangular area, in world coordinates, that the character recognizer should regard as its tablet"

	| outer |
	^ (outer _ self ownerThatIsA: PluggableTextMorph)
		ifNotNil:
			[outer boundsInWorld]
		ifNil:
			[self boundsInWorld]! !

!TextBrick methodsFor: 'containment' stamp: 'tb 3/8/2003 17:42'!
setContainer: newContainer
	"Adopt (or abandon) container shape"
	self changed.
	container _ newContainer.
	self releaseParagraph! !

!TextBrick methodsFor: 'printing' stamp: 'tb 3/8/2003 17:42'!
fullPrintOn: aStream

	aStream nextPutAll: '('.
	super fullPrintOn: aStream.
	aStream nextPutAll: ') contents: '; print: text! !

!TextBrick methodsFor: 'scripting access' stamp: 'tb 3/8/2003 17:42'!
getAllButFirstCharacter
	"Obtain all but the first character from the receiver; if that would be empty, return a black dot"

	| aString |
	^ (aString _ text string) size > 1 ifTrue: [aString copyFrom: 2 to: aString size] ifFalse: ['']! !

!TextBrick methodsFor: 'scripting access' stamp: 'tb 3/8/2003 17:42'!
setAllButFirstCharacter: source 
	"Set all but the first char of the receiver to the source"
	| aChar chars |
	aChar _ source asCharacter.
	(chars _ self getCharacters) isEmpty
		ifTrue: [self newContents: '' , source asString]
		ifFalse: [chars first = aChar
				ifFalse: [""
					self
						newContents: (String
								streamContents: [:aStream | 
									aStream nextPut: chars first.
									aStream nextPutAll: source])]] ! !

!TextBrick methodsFor: 'genie-dispatching' stamp: 'tb 3/8/2003 17:42'!
handleGesture: aCRGesture
	"Handle the gesture and store the last handled gesture as lastGestureEvent.
	lastGestureEvent is used for undoing gestures"

	| handled |
	handled _ super handleGesture: aCRGesture.
	handled ifTrue: [self lastGesture: aCRGesture. ^ true].
	(self modifyGesture: self lastGesture by: aCRGesture) 
		ifTrue: [^ true].
	(aCRGesture isCommand and: [aCRGesture normalizedChar = #alignment]) ifTrue:
		[self setAlignment: aCRGesture.
		^ true].
	^ false.! !

!TextBrick methodsFor: 'genie-dispatching' stamp: 'tb 3/8/2003 17:42'!
lastGesture
	^ lastGesture! !

!TextBrick methodsFor: 'genie-dispatching' stamp: 'tb 3/8/2003 17:42'!
lastGesture: aCRGesture
	"Store lastGestureEvent if it is undoable."

	lastGesture _ (self isGestureUndoable: aCRGesture)
		ifTrue: [aCRGesture]	! !

!TextBrick methodsFor: 'genie-dispatching' stamp: 'tb 3/8/2003 17:42'!
setAlignment: aCRGesture
	"Sets the alignment of the TextMorph accoding to the cursorPoint of MorphicGestureEvent.
	If the point is at the left, it's left alignment. If in the center or or at the right, it's centered
	resp. right alignment.
	This is only one example of a tousands of possibilities how to integrate the gesure 
	recognizer into the system"

	| min alignment newMin localX |
	localX _ (self globalPointToLocal: aCRGesture position) x.
	min _ localX abs.
	alignment _ #left.
	
	min > (newMin _ (localX - (self extent x // 2)) abs) ifTrue:
		[min _ newMin.
		alignment _ #centered].
	min > (newMin _ (localX - self extent x) abs) ifTrue:
		[alignment _ #right].

	alignment = #left ifTrue: [self leftFlush].
	alignment = #centered ifTrue: [self centered].
	alignment = #right ifTrue: [self rightFlush].! !

!TextBrick methodsFor: 'events-processing' stamp: 'tb 3/8/2003 17:42'!
handleKeystroke: anEvent
	"System level event handling."

	| pasteUp |
	anEvent wasHandled ifTrue:[^self].
	(self handlesKeyboard: anEvent) ifFalse:	[^ self].
	anEvent wasHandled: true.
	anEvent keyCharacter = Character tab ifTrue:
		["Allow passing through text morph inside pasteups"
		(self wouldAcceptKeyboardFocusUponTab and:
				[(pasteUp _ self pasteUpMorphHandlingTabAmongFields) notNil])
			ifTrue:[^ pasteUp tabHitWithEvent: anEvent]].
	self keyStroke: anEvent! !

!TextBrick methodsFor: 'events-processing' stamp: 'tb 3/8/2003 17:42'!
handleMouseMove: anEvent
	"Re-implemented to allow for mouse-up move events"
	anEvent wasHandled ifTrue:[^self]. "not interested"
	(anEvent hand hasSubmorphs) ifTrue:[^self].
	anEvent wasHandled: true.
	self mouseMove: anEvent.
	(anEvent anyButtonPressed and:[anEvent hand mouseFocus == self]) ifFalse:[^self].
	(self handlesMouseStillDown: anEvent) ifTrue:[
		"Step at the new location"
		self startStepping: #handleMouseStillDown: 
			at: Time millisecondClockValue
			arguments: {anEvent copy resetHandlerFields}
			stepTime: 1].
! !

!TextBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 17:42'!
handlesKeyboard: evt
	^true! !

!TextBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 17:42'!
handlesMouseDown: evt
	self isPartsDonor ifTrue: [^ false].
	^ self innerBounds containsPoint: evt cursorPoint! !

!TextBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 17:42'!
hasFocus
	^editor notNil! !

!TextBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 17:42'!
keyStroke: evt
	"Handle a keystroke event."
	| action |
	evt keyValue = 13 ifTrue:["CR - check for special action"
		action _ self crAction.
		action ifNotNil:[
			"Note: Code below assumes that this was some
			input field reacting on CR. Break the keyboard
			focus so that the receiver can be safely deleted."
			evt hand newKeyboardFocus: nil.
			^action value]].
	self handleInteraction: [editor readKeyboard] fromEvent: evt.
	self updateFromParagraph.
	super keyStroke: evt  "sends to keyStroke event handler, if any"! !

!TextBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 17:42'!
keyboardFocusChange: aBoolean 
	| w |
	aBoolean 
		ifTrue: 
			["A hand is wanting to send us characters..."

			self hasFocus ifFalse: [self editor	"Forces install"]]
		ifFalse: 
			["A hand has clicked elsewhere..."

			(w := self world) isNil 
				ifFalse: 
					[w handsDo: [:h | h keyboardFocus == self ifTrue: [^self]].
					"Release control unless some hand is still holding on"
					self releaseEditor]]! !

!TextBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 17:42'!
mouseDown: evt
	"Make this TextMorph be the keyboard input focus, if it isn't already,
		and repond to the text selection gesture."

	evt hand newKeyboardFocus: self.
	self handleInteraction: [editor mouseDown: evt] fromEvent: evt! !

!TextBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 17:42'!
mouseMove: evt
	evt redButtonPressed ifFalse: [^ self enterClickableRegion: evt].
	self handleInteraction: [editor mouseMove: evt] fromEvent: evt! !

!TextBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 17:42'!
mouseUp: evt
	self handleInteraction: [editor mouseUp: evt] fromEvent: evt! !

!TextBrick methodsFor: 'event handling' stamp: 'tb 3/8/2003 17:42'!
wouldAcceptKeyboardFocusUponTab
	"Answer whether the receiver might accept keyboard focus if tab were hit in some container playfield"

	^ self isLocked not and: [self inPartsBin not]! !

!TextBrick methodsFor: 'classification' stamp: 'tb 3/8/2003 17:42'!
isTextMorph
	^true! !

!TextBrick methodsFor: 'caching' stamp: 'tb 3/8/2003 17:42'!
loadCachedState
	"Prepare for fast response -- next page of a book?"
	self paragraph! !

!TextBrick methodsFor: 'caching' stamp: 'tb 3/8/2003 17:42'!
releaseCachedState

	super releaseCachedState.
	self releaseParagraph.
! !

!TextBrick methodsFor: 'card & stack' stamp: 'tb 3/8/2003 17:42'!
newContents: stringOrText fromCard: aCard
	"Accept new text contents."
	| newText setter |

	newText _ stringOrText asText.
	text = newText ifTrue: [^ self].  "No substantive change"

	text ifNotNil: [
		text embeddedMorphs do: [ :m | m delete ] ].

	text _ newText.

	"add all morphs off the visible region; they'll be moved into the right place when they become visible.  (this can make the scrollable area too large, though)"
	stringOrText asText embeddedMorphs do: [ :m | 
		self addMorph: m. 
		m position: (-1000@0)].

	self releaseParagraph.  "update the paragraph cache"
	self paragraph.  "re-instantiate to set bounds"

	self holdsSeparateDataForEachInstance
		ifTrue:
			[setter _ self valueOfProperty: #setterSelector.
			setter ifNotNil:
				[aCard perform: setter with: newText]].

	self world ifNotNil:
		[self world startSteppingSubmorphsOf: self ].
! !

!TextBrick methodsFor: 'card & stack' stamp: 'tb 3/8/2003 17:42'!
setNewContentsFrom: stringOrTextOrNil
	"Using stringOrTextOrNil as a guide, set the receiver's contents afresh.  If the input parameter is nil, the a default value stored in a property of the receiver, if any, will supply the new initial content.  This method is only called when a VariableDock is attempting to put a new value.  This is still messy and ill-understood and not ready for prime time."

	| defaultValue tt atts |
	stringOrTextOrNil ifNotNil: [^ self newContents: stringOrTextOrNil 
		fromCard: (self valueOfProperty: #cardInstance)].
		   "Well, totally yuk -- emergency measure late on eve of demo"
	defaultValue _ self valueOfProperty: #defaultValue 
					ifAbsent: [atts _ text attributesAt: 1.	"Preserve size, emphasis"
						tt _ text copyReplaceFrom: 1 to: text size
								with: 'blankText'.
						atts do: [:anAtt | tt addAttribute: anAtt].
						tt].
	self contents: defaultValue deepCopy wrappedTo: self width.
! !

!TextBrick methodsFor: 'change reporting' stamp: 'tb 3/8/2003 17:42'!
ownerChanged
	| priorEditor |
	super ownerChanged.
	container ifNotNil: 
			[editor isNil 
				ifTrue: [self releaseParagraph]
				ifFalse: 
					[priorEditor := editor.
					self releaseParagraph.
					self installEditorToReplace: priorEditor]]! !


!TextBrick class methodsFor: 'scripting' stamp: 'tb 3/8/2003 17:42'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."

	^ #(
(text (
(slot characters	'The characters in my contents' String	readWrite Player getCharacters Player setCharacters:)
(slot firstCharacter  'The first character in my contents' String  readWrite Player getFirstCharacter  Player  setFirstCharacter:)
(slot allButFirst 'All my characters except the first one' String readWrite Player getAllButFirstCharacter Player  setAllButFirstCharacter:)
(slot numericValue 'The number represented by my contents' Number readWrite Player getNumericValue Player  setNumericValue:)))

(basic (
(slot characters	'The characters in my contents' String	readWrite Player getCharacters Player setCharacters:))))


! !

!TextBrick class methodsFor: 'scripting' stamp: 'tb 3/8/2003 17:42'!
authoringPrototype
	| t |
	t _ super authoringPrototype.
	t contents: 'abc' asText.
	t wrapFlag: true. 

"Strangeness here in order to avoid two offset copies of the default contents when operating in an mvc project before cursor enters the morphic window"
	t paragraph.
	^ t! !

!TextBrick class methodsFor: 'parts bin' stamp: 'tb 3/8/2003 17:42'!
borderedPrototype

	| t |
	t _ self authoringPrototype.
	t autoFit: false; extent: 250@100.
	t borderWidth: 1; margins: 4@0.

"Strangeness here in order to avoid two offset copies of the default contents when operating in an mvc project before cursor enters the morphic window"
	t paragraph.
	^ t! !

!TextBrick class methodsFor: 'parts bin' stamp: 'tb 3/8/2003 17:42'!
descriptionForPartsBin
	^ self partName:	'Text'
		categories:		#('Text' ' Basic 1 ')
		documentation:	'A raw piece of text which you can edit into anything you want'! !

!TextBrick class methodsFor: 'parts bin' stamp: 'tb 3/8/2003 17:42'!
exampleBackgroundField
	"Answer a background field for a parts bin"

	| aMorph |
	aMorph _ TextMorph authoringPrototype.
	aMorph contents: 'background field' asText allBold.
	aMorph setProperty: #shared toValue: true.
	aMorph setNameTo: 'field1'.
	aMorph setProperty: #holdsSeparateDataForEachInstance toValue: true.	
	^ aMorph
! !

!TextBrick class methodsFor: 'parts bin' stamp: 'tb 3/8/2003 17:42'!
exampleBackgroundLabel
	"Answer a background label for a parts bin"

	| aTextMorph |
	aTextMorph _ self authoringPrototype.
	aTextMorph contents: 'background
label' asText.  
	aTextMorph beAllFont: (StrikeFont familyName: #NewYork size: 18).
	aTextMorph color: Color brown.
	aTextMorph setProperty: #shared toValue: true.
	^ aTextMorph
! !

!TextBrick class methodsFor: 'parts bin' stamp: 'tb 3/8/2003 17:42'!
fancyPrototype

	| t |
	t _ self authoringPrototype.
	t autoFit: false; extent: 150@75.
	t borderWidth: 2; margins: 4@0; useRoundedCorners.	"Why not rounded?"
	"fancy font, shadow, rounded"
	t fontName: #ComicBold size: 18; textColor: Color blue; backgroundColor: Color lightBrown.
	t addDropShadow.

"Strangeness here in order to avoid two offset copies of the default contents when operating in an mvc project before cursor enters the morphic window"
	t paragraph.
	^ t! !

!TextBrick class methodsFor: 'parts bin' stamp: 'tb 3/8/2003 17:42'!
supplementaryPartsDescriptions
	^ {DescriptionForPartsBin
		formalName: 'Text (border)'
		categoryList: #(' Basic 1 ' 'Text')
		documentation: 'A text field with border'
		globalReceiverSymbol: #TextMorph
		nativitySelector: #borderedPrototype.

	DescriptionForPartsBin
		formalName: 'Text (fancy)'
		categoryList: #(' Basic 1 ' 'Text')
		documentation: 'A text field with a rounded shadowed border, with a fancy font.'
		globalReceiverSymbol: #TextMorph
		nativitySelector: #fancyPrototype.}
! !

!TextBrick class methodsFor: 'new-morph participation' stamp: 'tb 3/8/2003 17:42'!
includeInNewMorphMenu
	^ true! !

!TextBrick class methodsFor: 'class initialization' stamp: 'tb 3/8/2003 17:42'!
initialize	"TextMorph initialize"
	"Initialize constants shared by classes associated with text display."

	CaretForm _ (ColorForm extent: 16@5
					fromArray: #(2r001100e26 2r001100e26 2r011110e26 2r111111e26 2r110011e26)
					offset: -2@0)
					colors: (Array with: Color transparent with: self new selectionColor).
! !


!ToolbarBrick methodsFor: 'geometry' stamp: 'tb 4/10/2003 17:43'!
boundsForCell: aBrick

	^(aBrick bounds insetBy: (inset negated / 2))

"	^self isVertical ifTrue: 
	[ 
		| cellHeight |
		cellHeight := ((self height // self submorphs size)).
		(self left)@((self top + (cellHeight * (aCell - 1)) asInteger)) extent: ((self width)@(cellHeight asInteger))
	]
	ifFalse:
	[
		| cellWidth |
		cellWidth := ((self width // self submorphs size)).
		(self left + ((cellWidth * (aCell - 1))asInteger))@(self top) extent: ((cellWidth asInteger)@(self height))
	]  "! !

!ToolbarBrick methodsFor: 'geometry' stamp: 'tb 4/10/2003 17:48'!
cellContainingPoint: aPoint

	^submorphs detect: [:ea | (ea bounds insetBy: (inset negated / 2)) containsPoint: aPoint] ifNone: [nil]! !

!ToolbarBrick methodsFor: 'accessing' stamp: 'tb 3/18/2003 18:03'!
addMorph: aBrick

	
	self isVertical ifTrue:
	[
		"should probably check for hresizing and vresizing to see if its ok to resize the brick"
		aBrick width > (self width - (2* inset x)) ifTrue: 
		[
			aBrick hResizing == #rigid 
				ifTrue: [ self width: (aBrick width + (2* inset x))]
				ifFalse: [ aBrick width: (self width - (2* inset x)) ].
		].
		aBrick height > (self width - (2* inset y)) ifTrue:
		[
			aBrick vResizing == #rigid 
				ifFalse: [ aBrick height: (self width - (2* inset x)) ].
		].
		 
		(self submorphs isNil or: [self submorphs isEmpty]) 
			ifTrue: 
			[ 
				aBrick center: ((self center x)@((self top + ((aBrick height / 2) rounded) + (inset y)))). 
			]
			ifFalse: 
			[
				| x y |
				x := (self center x).
				y := ((self submorphs first bottom) + ((aBrick height / 2) rounded) + (inset y)).
				aBrick center: (x@y) 
			].
		aBrick leftToRightLayout: 's-s'.
	]
	ifFalse: "Horizontal"
	[
		aBrick width: (self height - (2 * inset x)).
		aBrick height: (self height - (2 * inset y)).

		aBrick height > (self height - (2* inset y)) ifTrue: 
		[
			aBrick vResizing == #rigid 
				ifTrue: [ self height: (aBrick height + (2* inset y))]
				ifFalse: [ aBrick height: (self height - (2* inset y)) ].
		].
		aBrick width > (self height - (2* inset x)) ifTrue:
		[
			aBrick hResizing == #rigid 
				ifFalse: [ aBrick width: (self height - (2* inset y)) ].
		].


		(self submorphs isNil or: [self submorphs isEmpty]) 
			ifTrue: 
			[ 
				aBrick center: (((self left + ((aBrick width / 2) rounded) + (inset x)))@(self center y)).  
			]
			ifFalse: 
			[
				| x y |
				y := (self center y).
				x := (self submorphs first right) + ((aBrick width / 2) rounded) + (inset x).
				aBrick center: (x@y) 
			].
		aBrick topToBottomLayout: 's-s'.
	].
	aBrick world ifNil: [ aBrick openInWorld ].
	super addMorph: aBrick.
	aBrick updateLayoutProperties.
	self changed.! !

!ToolbarBrick methodsFor: 'accessing' stamp: 'tb 3/18/2003 16:51'!
beHorizontal

	| bricks h w |
	direction == #horizontal ifFalse:
	[
		
		direction := #horizontal.
		bricks := self submorphs copy.
		self removeAllMorphsIn: bricks.
		h := self height.
		w := self width.
		self height: w.
		self width: h.
		bricks reverseDo: [:m | self addMorph: m]. 	
	]! !

!ToolbarBrick methodsFor: 'accessing' stamp: 'tb 3/18/2003 16:48'!
beVertical

	| bricks h w |
	direction == #vertical ifFalse:
	[
		
		direction := #vertical.
		bricks := self submorphs copy.
		self removeAllMorphsIn: bricks.
		h := self height.
		w := self width.
		self height: w.
		self width: h.
		bricks reverseDo: [:m | self addMorph: m]. 	
	]! !

!ToolbarBrick methodsFor: 'accessing' stamp: 'tb 3/18/2003 20:06'!
inset: aPoint

	| newInset delta |

	aPoint isNumber ifTrue: [ newInset := ((aPoint asInteger)@(aPoint asInteger)) ]
	ifFalse: [ aPoint isPoint ifFalse: [^self]. newInset := aPoint].

	delta := newInset - inset.

	self submorphsDo: [:m | m bounds: (m bounds insetBy: delta). m updateLayoutProperties ].

	inset := newInset.! !

!ToolbarBrick methodsFor: 'accessing' stamp: 'tb 3/18/2003 16:02'!
isHorizontal

	^direction == #horizontal! !

!ToolbarBrick methodsFor: 'accessing' stamp: 'tb 3/18/2003 16:01'!
isVertical

	^direction == #vertical! !

!ToolbarBrick methodsFor: 'accessing' stamp: 'tb 3/18/2003 18:38'!
sizeToFit
	
	self isVertical ifTrue:
	[
		self height: (self submorphs first bottom + (inset y) - (self top)).
	]
	ifFalse: "Horizontal"
	[
		self width: (self submorphs first right + (inset x) - (self left)).
	]! !

!ToolbarBrick methodsFor: 'initialization' stamp: 'tb 4/29/2003 21:56'!
initialize

	super initialize.

	inset := 8@8.
	self beHorizontal.

	self addPainter: (BackgroundPainter color: #stainless).
	self addPainter: (BorderPainter etched).

	self dropEnabled: false.! !

!ToolbarBrick methodsFor: 'event handling' stamp: 'tb 4/10/2003 16:24'!
mouseLeave: evt

	self removePainter: HilightPainter! !

!ToolbarBrick methodsFor: 'event handling' stamp: 'tb 4/29/2003 21:58'!
mouseLeaveDragging: evt

	self removePainter: HilightPainter! !

!ToolbarBrick methodsFor: 'event handling' stamp: 'tb 4/10/2003 17:47'!
mouseMove: evt

	| cell rect painter |

	cell := self cellContainingPoint: evt position.
	cell ifNil: 
	[
		self removePainter: HilightPainter.
	]
	ifNotNil:
	[
		painter := self painterAtLayer: HilightPainter.
		rect := (self boundsForCell: cell) translateBy: (self position negated).
		(painter notNil and: [painter bounds = rect]) ifTrue: [^self].
		self addPainter: (HilightPainter bounds: rect)
	]! !


!Window methodsFor: 'accessing' stamp: 'tb 3/10/2003 21:43'!
defaultColor

	^Color gray.! !

!Window methodsFor: 'accessing' stamp: 'tb 3/10/2003 21:43'!
title
	^title contents! !

!Window methodsFor: 'accessing' stamp: 'tb 3/11/2003 19:22'!
title: aString

	title contents: aString.
	self layoutChild: title in: self bounds.! !

!Window methodsFor: 'accessing' stamp: 'tb 3/17/2003 16:01'!
titleBar

	^titleBar! !

!Window methodsFor: 'event handling' stamp: 'tb 3/11/2003 00:25'!
handlesMouseEnter: evt
	^true! !

!Window methodsFor: 'event handling' stamp: 'tb 3/15/2003 08:34'!
mouseDown: evt

	| parent |

	parent := self owner.
	parent addMorphFront: self.! !

!Window methodsFor: 'event handling' stamp: 'tb 3/15/2003 08:28'!
mouseDrop: evt

	! !

!Window methodsFor: 'event handling' stamp: 'tb 3/15/2003 10:59'!
mouseDropFiles: evt

	evt wasHandled: true.! !

!Window methodsFor: 'event handling' stamp: 'tb 3/11/2003 00:26'!
mouseEnter: evt
	self title: 'Entered'! !

!Window methodsFor: 'event handling' stamp: 'tb 3/14/2003 21:09'!
mouseEnterDragging: evt
! !

!Window methodsFor: 'event handling' stamp: 'tb 3/15/2003 08:28'!
mouseFiles: evt

	! !

!Window methodsFor: 'event handling' stamp: 'tb 3/11/2003 20:14'!
mouseLeave: evt
	self title: 'Untitled'! !

!Window methodsFor: 'event handling' stamp: 'tb 3/14/2003 21:09'!
mouseLeaveDragging: evt
	! !

!Window methodsFor: 'event handling' stamp: 'tb 3/18/2003 21:42'!
mouseMoveDragging: evt

	((titleBar containsPoint: evt cursorPoint event: evt) and: [evt hand submorphs isEmpty])
		ifTrue: [evt hand grabMorph: self].! !

!Window methodsFor: 'event handling' stamp: 'tb 3/14/2003 21:09'!
mouseUp: evt! !

!Window methodsFor: 'initialization' stamp: 'tb 3/17/2003 18:09'!
initialize
	super initialize.
	bounds := ((30@30) extent: (200@300)).
	titleBar := Brick new.
	titleBar width: self width.
	titleBar position: self position.
	title := StringBrick contents: 'Untitled'.
	title emphasis: 1.
	titleBar height: (title height + 12).
	self addMorph: titleBar.
	titleBar addMorphCentered: title.
	title leftToRightLayout: 's-s'.
	titleBar leftToRightLayout: '-s-'.
	title color: (Color darkGray twiceDarker darker).
	self submorphsDo: [:ea | ea updateLayoutProperties ].! !


!Window class methodsFor: 'instance creation' stamp: 'tb 3/18/2003 14:07'!
aqua

	| me | 

	me := self new.

	me titleBar addPainter: (BackgroundPainter color: #aqua).
	me titleBar addPainter: (BorderPainter color: (Color r: 0.49 g: 0.49 b: 0.49) width: 1).
	me addPainter: (BackgroundPainter color: Color white).
	me addPainter: (BorderPainter color: (Color r: 0.49 g: 0.49 b: 0.49) width: 1).
	me addPainter: (CornerPainter topCorners).
	me addPainter: (ShadowPainter color: (Color black alpha: 0.42) width: (1@2)).
	^me.! !

!Window class methodsFor: 'instance creation' stamp: 'tb 3/18/2003 14:08'!
stainless

	| me | 

	me := self new.
	me titleBar removePainter: BackgroundPainter.
	me addPainter: (BackgroundPainter color: #stainless).
	me addPainter: (BorderPainter color: (Color black alpha: 0.4) width: 1).
	me addPainter: (ShadowPainter color: (TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.4) width: 1@1).
	me addPainter: (CornerPainter new).
	^me! !

Window class removeSelector: #backgrounds!
Window class removeSelector: #initialize!
Window class removeSelector: #newWindow710!
ToolbarBrick removeSelector: #mouseEnter:!
ToolbarBrick removeSelector: #mouseOver:!
TextBrick initialize!
HilightPainter class removeSelector: #fillStyle:!
Painter initialize!
HilightPainter removeSelector: #defaultFillStyle!
HilightPainter removeSelector: #fillStyle!
HilightPainter removeSelector: #fillStyle:!
PScrollBar initialize!
ImageBrick initialize!
DragPainterBrick removeSelector: #mouseDown:!
DragPainterBrick removeSelector: #mouseEnter:!
DragPainterBrick removeSelector: #mouseLeave:!
DragWrapperBrick removeSelector: #aboutToBeGrabbedBy:!
DragWrapperBrick removeSelector: #mouseMoveDragging:!
BrickEventDispatcher initialize!
Brick initialize!
Brick removeSelector: #addBorderStyleMenuItems:hand:!
Brick removeSelector: #addDropShadow!
Brick removeSelector: #addDropShadowMenuItems:hand:!
Brick removeSelector: #canDrawBorder:!
Brick removeSelector: #changeShadowColor!
Brick removeSelector: #cornerStyle!
Brick removeSelector: #cornerStyle:!
Brick removeSelector: #drawDropHighlightOn:!
Brick removeSelector: #fillStyle!
Brick removeSelector: #fillStyle:!
Brick removeSelector: #hasDropShadow!
Brick removeSelector: #hasDropShadow:!
Brick removeSelector: #hasDropShadowString!
Brick removeSelector: #hasRolloverBorder!
Brick removeSelector: #highlightedForDrop!
Brick removeSelector: #mouseDown:!
Brick removeSelector: #mouseEnter:!
Brick removeSelector: #mouseLeave:!
Brick removeSelector: #mouseLeaveDragging:!
Brick removeSelector: #mouseUp:!
Brick removeSelector: #removeDropShadow!
Brick removeSelector: #roundedCorners!
Brick removeSelector: #roundedCornersString!
Brick removeSelector: #setBorderStyle:!
Brick removeSelector: #setShadowOffset:!
Brick removeSelector: #shadowColor!
Brick removeSelector: #shadowColor:!
Brick removeSelector: #shadowOffset!
Brick removeSelector: #shadowOffset:!
Brick removeSelector: #shadowPoint:!
Brick removeSelector: #toggleDropShadow!
